//----- getty.c ----- 04/02/09 -----(04/26/06)-----

#include <common.h>

#include <sys/types.h>
#include <unistd.h>
#include <fcntl.h>
#include <errno.h>

#include <string.h>

#include <sys/serial.h>


void _task tsh(int argc, char **argv);


#include <sys/farprintf.h>

//-----------------------------------------------------------------------------
//  process to create command shells process for serial port users
//-----------------------------------------------------------------------------
void _task getty(int argc, char **argv)
{
  fd_t  serialfd;
  PID  pid;
  int  status;
  char  *argv_[2];


  if (argc < 3)  { printf("Usage: getty baudrate devName\r\n\n");  Exit(-1); }

  if ((serialfd = open(argv[2], O_RDWR, 0)) < 0)  {
    printf("getty: Unable to open device: %s\n", argv[2]);  Exit(-2);  }

  for (;;)  {
    argv_[0] = "tsh";  argv_[1] = NULL;
    FD[MyTaskIdx][serialfd].istty = true;
    pid = createProc(tsh, 5, 1, argv_, serialfd, serialfd, serialfd);
    close(serialfd);
    if (pid > 0)
      waitpid(pid, &status, 0);
    else  {
      printf("Unable to start tty shell\r\n");  sleepMS(5000); }
  }

}

//-----------------------------------------------------------------------------
