	.objcmt	Softools, Inc. ** Control Cross-C Globally Optimizing Compiler ** Version 2.18.00
	.objcmt	Copyright (c) 1989 - 2003, Softools, Inc.  All rights reserved.
	.debug	P 5
	.debug	X 11 10
	.debug	X 12 10
	.debug	N 'C:\work\dev\Rabbit_ST\rtos\lib\fmemcpy.c' 14 38 12 12 6 32
;1 //----- fmemcpy.c ----- 03/29/12 -----(06/17/10)-----
;2 
;3 //-------------------------------------------------------------------------
;4 //  A version of fmemcpy() that avoids single write operations that span a
;5 //  4K boundary
;6 //-------------------------------------------------------------------------
;7 //  Version log (most recent first):
;8 //
;9 //
;10 //  2012-03-29 - Mark Davis (*)
;11 //               - The most significant byte of the source and destination
;12 //                 pointer values are now forced to be 0.  Prior to this, I
;13 //                 ran in to at least one case where one of them was not 0,
;14 //                 which caused the code to malfunction because some of the
;15 //                 code forced that byte to 0 after fetching it and some di
;16 //                 not.
;17 //
;18 //  2010-07-09 - Mark Davis (*)
;19 //               - Several bugs found and fixed.  Some more refinements tha
;20 //                 along with the bug fixes, resulted in some significant
;21 //                 speed improvements.
;22 //
;23 //  2010-06-25 - Mark Davis
;24 //               - mostly optimized all-assembly code version
;25 //
;26 //  2010-06-24 - Mark Davis
;27 //               - First working hybrid C/asm version of fmemcpy() that is
;28 //                 compatible with hardware write protection.
;29 //
;30 //  2010-06-17 - Mark Davis
;31 //               - Temporary (and slow) version is compatible with hardware
;32 //                 write protection (because the compiled code calls _farst
;33 //                 which has been replaced with a hardware write protection
;34 //                 comptabile version).
;35 //
;36 //-------------------------------------------------------------------------
;37 
;38 #include <sys/types.h>
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
;39 #include <unistd.h>
;40 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\sched.h' 3 49 6 8 6 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\signal.h' 6 21 8 17 3 29
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\list.h' 21 49 15 26 7 30
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\wait.h' 10 13 9 20 4 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\dummy.h' 25 58 21 12 10 27
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\list.h' 21 49 15 26 7 30
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\time.h' 15 48 18 10 12 22
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\string.h' 26 27 14 2 6 25
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stddef.h' 21 20 12 5 6 22
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\math.h' 19 23 18 21 9 21
	.debug	I
	.debug	I
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Rabbit.h' 24 40 11 19 5 30
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stdio.h' 22 16 12 9 4 26
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\SoftoolsIDblock.h' 18 52 15 4 6 26
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\FlashBlock.h' 5 10 16 30 11 24
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Flash.h' 0 55 21 17 7 26
	.debug	I
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Stdlib.h' 2 30 16 6 7 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\dcdefs.h' 18 42 23 19 7 26
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Rabbit.h' 24 40 11 19 5 30
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\SoftoolsIDBlock.h' 18 52 15 4 6 26
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\errors.h' 25 8 15 18 11 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stdlib.h' 2 30 16 6 7 24
	.debug	I
	.debug	# 109
_LIN2SEG	.macro

	.debug	# 110
add hl,hl

	.debug	# 111
rla

	.debug	# 112
add hl,hl

	.debug	# 113
rla

	.debug	# 114
add hl,hl

	.debug	# 115
rla

	.debug	# 116
add hl,hl

	.debug	# 117
rla

	.debug	# 118
sub 0x0E

	.debug	# 119
or a

	.debug	# 120
rr hl

	.debug	# 121
scf

	.debug	# 122
rr hl

	.debug	# 123
scf

	.debug	# 124
rr hl

	.debug	# 125
scf

	.debug	# 126
rr hl

	.debug	# 127
.endm

	.cseg
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\hdwdefs.h' 20 2 12 27 10 31
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\sched.h' 3 49 6 8 6 32
	.debug	I
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\fcntl.h' 29 48 12 5 12 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\wait.h' 10 13 9 20 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\ioctl.h' 2 15 10 21 5 30
	.debug	I
	.debug	I
	.debug	I
;41 
;42 #pragma offset_labels on
;43 
;44 //-------------------------------------------------------------------------
;45 //  A version of fmemcpy() that uses the safe version of __farst1 to avoid
;46 //  writing to 4K pages outside the specified range.
;47 //-------------------------------------------------------------------------
;48 /*
;49 void far * far fmemcpy (void far *to, void const far *from, ulong size)
;50 {
;51   uchar far  *to_ = (uchar far *)to, *from_ = (uchar far *)from;
;52 
;53   while (size--)  *to_++ = *from_++;
;54 
;55   return to;
;56 }
;57 */
;58 
;59 #pragma warn -758
;60 #pragma warn -759
;61 
;62 //-------------------------------------------------------------------------
;63 //  DEBROS version of fmemcpy() function that is both faster than the Softo
;64 //  version and compatible with Rabbit 3000A memory write protection
;65 //-------------------------------------------------------------------------
;66 void far * far fmemcpy(void far *to, void const far *from, ulong size)
;67 {
	.defseg	FARCODE
	.seg	FARCODE
$fmemcpy::
	.debug	G $fmemcpy 32 9
	.debug	{ $fmemcpy 32 66 @3 @2
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-24
.to = 5
	.debug	A to 5 33
.from = 9
	.debug	A from 9 33
.size = 13
	.debug	A size 13 9
;68   uchar far *saveTo;
.saveTo = -4
	.debug	L saveTo -4 34
;69   uint   byteCount, safeToCount;
.byteCount = -6
	.debug	L byteCount -6 7
.safeToCount = -8
	.debug	L safeToCount -8 7
;70   ulong  fromEnd, toEnd, safeFromEnd, safeToEnd;
.fromEnd = -12
	.debug	L fromEnd -12 9
.toEnd = -16
	.debug	L toEnd -16 9
.safeFromEnd = -20
	.debug	L safeFromEnd -20 9
.safeToEnd = -24
	.debug	L safeToEnd -24 9
;71 
;72 /*===================================================
;73    Aprox CPU cycles for each stage:
;74 
;75       1-time regardless of # of bytes:        300
;76       once for each 4K segment touched:       484
;77       per byte within each <= 4K block:        22.5
;78 
;79    For the best case (all bytes in 1 4K block):
;80 
;81                              784 cycles + 22.5/byte  (~0.0178 ms @ 44MHz)
;82 
;83    For blocks that don't cross a 4K boundary:
;84 
;85       512 bytes:   ~12,304 cycles  (~0.28  ms @ 44MHz)
;86      1024 bytes:   ~23,824 cycles  (~0.54  ms @ 44MHz)
;87      2048 bytes:   ~46,864 cycles  (~1.065 ms @ 44MHz)
;88 
;89    For a typical "full" Ethernet pakcet (MSS data bytes):
;90 
;91      1460 bytes:   ~33,634 cycles  (~0.764 ms @ 44MHz)
;92 
;93 =====================================================*/
;94 
;95 ;
;96 #asm
	.debug	# 98
ld      (ix+.to+3),0         

	.debug	# 99
ld      (ix+.from+3),0       

	.debug	# 102
ld      hl,(ix+.to)          

	.debug	# 103
ld      (ix+.saveTo),hl      

	.debug	# 104
ld      hl,(ix+.to+2)        

	.debug	# 105
ld      (ix+.saveTo+2),hl    

	.debug	# 108
ld      hl,(ix+.from+2)      

	.debug	# 109
push    hl                   

	.debug	# 110
ld      hl,(ix+.from)        

	.debug	# 111
push    hl                   

	.debug	# 112
ld      hl,(ix+.size+2)      

	.debug	# 113
ld      bc,hl                

	.debug	# 114
ld      hl,(ix+.size)        

	.debug	# 115
ex      de,hl                

	.debug	# 116
call    __ladd##             

	.debug	# 117
call    __ldec##             

	.debug	# 118
ld      hl,bc                

	.debug	# 119
ld      (ix+.fromEnd+2),hl   

	.debug	# 120
ex      de,hl                

	.debug	# 121
ld      (ix+.fromEnd),hl     

	.debug	# 124
ld      hl,(ix+.to+2)        

	.debug	# 125
push    hl                   

	.debug	# 126
ld      hl,(ix+.to)          

	.debug	# 127
push    hl                   

	.debug	# 128
ld      hl,(ix+.size+2)      

	.debug	# 129
ld      bc,hl                

	.debug	# 130
ld      hl,(ix+.size)        

	.debug	# 131
ex      de,hl                

	.debug	# 132
call    __ladd##             

	.debug	# 133
call    __ldec##             

	.debug	# 134
ld      hl,bc                

	.debug	# 135
ld      (ix+.toEnd+2),hl     

	.debug	# 136
ex      de,hl                

	.debug	# 137
ld      (ix+.toEnd),hl       

	.debug	# 142
while:

	.debug	# 143
ld      hl,(ix+.size)        

	.debug	# 144
ex      de,hl                

	.debug	# 145
ld      hl,(ix+.size+2)      

	.debug	# 146
or      hl,de                

	.debug	# 147
jp      z,done               

	.debug	# 151
ld      hl,(ix+.from)        

	.debug	# 152
ld      de,0x0FFF            

	.debug	# 153
or      hl,de                

	.debug	# 154
ld      (ix+.safeFromEnd),hl 

	.debug	# 155
ld      hl,(ix+.from+2)      

	.debug	# 156
ld      (ix+.safeFromEnd+2),hl 

	.debug	# 159
ex      de,hl                

	.debug	# 160
ld      hl,(ix+.fromEnd+2)   

	.debug	# 161
ex      de,hl                

	.debug	# 162
or      a,a                  

	.debug	# 163
sbc     hl,de                

	.debug	# 164
jr      c,fromOK             

	.debug	# 165
jr      nz,copyFromEnd       

	.debug	# 167
ld      hl,(ix+.safeFromEnd) 

	.debug	# 168
ex      de,hl                

	.debug	# 169
ld      hl,(ix+.fromEnd)     

	.debug	# 170
scf                          

	.debug	# 171
sbc     hl,de                

	.debug	# 172
jr      nc,fromOK            

	.debug	# 174
copyFromEnd:                     

	.debug	# 175
ld      hl,(ix+.fromEnd+2)   

	.debug	# 176
ld      (ix+.safeFromEnd+2),hl 

	.debug	# 177
ld      hl,(ix+.fromEnd)     

	.debug	# 178
ld      (ix+.safeFromEnd),hl 

	.debug	# 179
fromOK:

	.debug	# 182
ld      hl,(ix+.safeFromEnd) 

	.debug	# 183
ex      de,hl                

	.debug	# 184
ld      hl,(ix+.from)        

	.debug	# 185
ex      de,hl                

	.debug	# 186
or      a,a                  

	.debug	# 187
sbc     hl,de                

	.debug	# 188
inc     hl                   

	.debug	# 189
ld      (ix+.byteCount),hl   

	.debug	# 193
ld      hl,(ix+.to)          

	.debug	# 194
ld      de,0x0FFF            

	.debug	# 195
or      hl,de                

	.debug	# 196
ld      (ix+.safeToEnd),hl   

	.debug	# 197
ld      hl,(ix+.to+2)        

	.debug	# 198
ld      (ix+.safeToEnd+2),hl 

	.debug	# 201
ex      de,hl                

	.debug	# 202
ld      hl,(ix+.toEnd+2)     

	.debug	# 203
ex      de,hl                

	.debug	# 204
or      a,a                  

	.debug	# 205
sbc     hl,de                

	.debug	# 206
jr      c,toOK               

	.debug	# 207
jr      nz,copyToEnd         

	.debug	# 209
ld      hl,(ix+.safeToEnd)   

	.debug	# 210
ex      de,hl                

	.debug	# 211
ld      hl,(ix+.toEnd)       

	.debug	# 212
scf                          

	.debug	# 213
sbc     hl,de                

	.debug	# 214
jr      nc,toOK              

	.debug	# 216
copyToEnd:                       

	.debug	# 217
ld      hl,(ix+.toEnd+2)     

	.debug	# 218
ld      (ix+.safeToEnd+2),hl 

	.debug	# 219
ld      hl,(ix+.toEnd)       

	.debug	# 220
ld      (ix+.safeToEnd),hl   

	.debug	# 221
toOK:

	.debug	# 224
ld      hl,(ix+.to)          

	.debug	# 225
ex      de,hl                

	.debug	# 226
ld      hl,(ix+.safeToEnd)   

	.debug	# 227
or      a,a                  

	.debug	# 228
sbc     hl,de                

	.debug	# 229
inc     hl                   

	.debug	# 230
ld      (ix+.safeToCount),hl 

	.debug	# 234
ex      de,hl                

	.debug	# 235
ld      hl,(ix+.byteCount)   

	.debug	# 236
scf                          

	.debug	# 237
sbc     hl,de                

	.debug	# 238
jr      c,countOK            

	.debug	# 239
ex      de,hl                

	.debug	# 240
ld      (ix+.byteCount),hl   

	.debug	# 241
countOK:

	.debug	# 245
ld      hl,(ix+.byteCount)   

	.debug	# 246
or      a,a                  

	.debug	# 247
rr      hl                   

	.debug	# 248
jp      z,copy1              

	.debug	# 255
ex    de,hl                   

	.debug	# 257
push  ix                      

	.debug	# 260
ld    a,(ix+.to+2)            

	.debug	# 261
ex    af,af'                  ;[2]   A'= MSB(to)

	.debug	# 262
ld    hl,(ix+.to)             

	.debug	# 263
ld    iy,hl                   

	.debug	# 266
ld    a,(ix+.from+2)          

	.debug	# 267
ld    hl,(ix+.from)           

	.debug	# 268
ld    ix,hl                   

	.debug	# 270
ld    bc,2                    

	.debug	# 278
loop:

	.debug	# 279
ldp   hl,(ix)           

	.debug	# 280
add   ix,bc             

	.debug	# 282
ex    af,af'            ;[2]    switch A to target addr's 4 MSB

	.debug	# 284
ldp   (iy),hl           

	.debug	# 285
add   iy,bc             

	.debug	# 287
ex    af,af'            ;[2]    switch A back to source addr's 4 MSB

	.debug	# 289
dec   de                

	.debug	# 290
rl    de                

	.debug	# 291
rr    de                

	.debug	# 292
jr    nz,loop           

	.debug	# 295
ld    hl,ix                 

	.debug	# 297
pop   ix                    

	.debug	# 299
ld    (ix+.from),hl         

	.debug	# 300
or    hl,de                 

	.debug	# 301
jr    nz,saveTarget         

	.debug	# 302
inc   (ix+.from+2)          

	.debug	# 304
saveTarget:

	.debug	# 305
ld    hl,iy                 

	.debug	# 306
ld    (ix+.to),hl           

	.debug	# 307
or    hl,de                 

	.debug	# 308
jr    nz,updSize            

	.debug	# 309
inc   (ix+.to+2)            

	.debug	# 311
updSize:   

	.debug	# 312
ld    hl,(ix+.byteCount)    

	.debug	# 313
ex    de,hl                 

	.debug	# 314
res   0,e                   

	.debug	# 316
ld    hl,(ix+.size)         

	.debug	# 317
or    a,a                   

	.debug	# 318
sbc   hl,de                 

	.debug	# 319
ld    (ix+.size),hl         

	.debug	# 320
jp    nc,while              

	.debug	# 321
dec   (ix+.size+2)          

	.debug	# 322
jp    while                 

	.debug	# 327
copy1:

	.debug	# 328
ex    de,hl                 

	.debug	# 331
ld    a,(ix+.from+2)        

	.debug	# 332
ld    hl,(ix+.from)         

	.debug	# 333
ld    iy,hl                 

	.debug	# 334
ldp   hl,(hl)               

	.debug	# 335
ld    b,l                   

	.debug	# 338
ld    hl,iy                 

	.debug	# 339
inc   hl                    

	.debug	# 340
ld    (ix+.from),hl         

	.debug	# 341
or    hl,de                 

	.debug	# 342
jr    nz,getTo              

	.debug	# 343
inc   (ix+.from+2)          

	.debug	# 346
getTo:

	.debug	# 347
ld    a,(ix+.to+2)          

	.debug	# 348
ld    hl,(ix+.to)           

	.debug	# 349
ld    iy,hl                 

	.debug	# 352
inc   hl                    

	.debug	# 353
ld    (ix+.to),hl           

	.debug	# 354
or    hl,de                 

	.debug	# 355
jr    nz,testTo             

	.debug	# 356
inc   (ix+.to+2)            

	.debug	# 359
testTo:

	.debug	# 360
bit   0,l                   

	.debug	# 361
jr    nz,evenAddr           

	.debug	# 366
dec    iy                   

	.debug	# 367
ldp    hl,(iy)              

	.debug	# 368
ld     h,b                  

	.debug	# 369
jr     writeWord            

	.debug	# 373
evenAddr:

	.debug	# 374
ldp    hl,(iy)              

	.debug	# 375
ld     l,b                  

	.debug	# 377
writeWord:

	.debug	# 378
ldp    (iy),hl              

	.debug	# 382
ld     hl,(ix+.size)        

	.debug	# 383
dec    hl                   

	.debug	# 384
ld     (ix+.size),hl        

	.debug	# 386
ld     a,h                  

	.debug	# 387
and    l                    

	.debug	# 388
inc    a                    

	.debug	# 389
jp     nz,while             

	.debug	# 391
ld     hl,(ix+.size+2)      

	.debug	# 392
dec    hl                   

	.debug	# 393
ld     (ix+.size+2),hl      

	.debug	# 394
jp     while

	.debug	# 396
done:

;399 
	.seg	FARCODE
;400   return saveTo;
	.debug	# 400
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
;401 }
@2:
	.debug	} @2 401

@1	equ	24
	ld	sp,ix
	pop	ix
	lret
@3	equ	26
;402 
;403 #pragma warn +758
;404 #pragma warn +759
;405 
;406 //-------------------------------------------------------------------------
;407 
;408 #pragma offset_labels off
;409 
	.debug	T	130002200003002100210000002100040009000800
	.debug	T	070008210004000100
	.debug	T	070008220004000300
	.end
