	.objcmt	Softools, Inc. ** Control Cross-C Globally Optimizing Compiler ** Version 2.18.00
	.objcmt	Copyright (c) 1989 - 2003, Softools, Inc.  All rights reserved.
	.debug	P 5
	.debug	X 11 10
	.debug	X 12 10
	.debug	N 'C:\work\dev\Rabbit_ST\rtos\kernel\list.c' 19 54 9 30 4 30
;1 //----- list.c ----- 04/30/10 -----(04/19/07)-----
;2 
;3 #include <linux/list.h>
;4 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\list.h' 21 49 15 26 7 30
	.debug	I
;5 //-------------------------------------------------------------------------
;6 //  DEBROS implementations of standard Linux doubly-linked list functions
;7 //-------------------------------------------------------------------------
;8 //  Update log (most recent first)
;9 //
;10 //
;11 //  2010-04-29 - Mark Davis
;12 //               - Cleaned up a bit and changed __list_del() to a macro.
;13 //
;14 //  2007-04-23 - Mark Davis
;15 //               - original version
;16 //
;17 //-------------------------------------------------------------------------
;18 
;19 
;20 /*-------------------------------------------------------------------------
;21  * Insert a new entry between two known consecutive entries.
;22  *
;23  * This is only for internal list manipulation where we know
;24  * the prev/next entries already!
;25  *-------------------------------------------------------------------------
;26 void __list_add(list_head_t *new_, list_head_t *prev_, list_head_t *next_)
;27 {
	.defseg	FARCODE
	.seg	FARCODE
$__list_add::
	.debug	G $__list_add 32 9
	.debug	{ $__list_add 32 26 @3 @2
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A new_ 5 33
	.debug	A prev_ 7 33
	.debug	A next_ 9 33
;28   next_->prev = new_;
	.debug	# 28
	ld	hl,(ix+9)
	inc	hl
	inc	hl
	ex	de,hl
	ld	hl,(ix+5)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
;29   new_->next = next_;
	.debug	# 29
	ld	hl,(ix+9)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
;30   new_->prev = prev_;
	.debug	# 30
	ld	hl,(ix+5)
	inc	hl
	inc	hl
	ex	de,hl
	ld	hl,(ix+7)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
;31   prev_->next = new_;
	.debug	# 31
	ld	hl,(ix+5)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
;32 }
@2:
	.debug	} @2 32

@1	equ	0
	pop	ix
	lret
@3	equ	2
;33 
;34 
;35 /*-------------------------------------------------------------------------
;36  * list_empty_careful - tests whether a list is empty and not being modifie
;37  * @head: the list to test
;38  *
;39  * Description:
;40  * tests whether a list is empty _and_ checks that no other CPU might be
;41  * in the process of modifying either member (next or prev)
;42  *
;43  * NOTE: using list_empty_careful() without synchronization
;44  * can only be safe if the only activity that can happen
;45  * to the list entry is list_del_init(). Eg. it cannot be used
;46  * if another CPU could re-list_add() it.
;47  *-------------------------------------------------------------------------
;48 int list_empty_careful(list_head_t *head)
;49 {
$list_empty_careful::
	.debug	G $list_empty_careful 35 9
	.debug	{ $list_empty_careful 35 48 @6 @5
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	.debug	A head 5 33
;50   list_head_t *next = head->next;
	.debug	L next -2 33
	.debug	# 50
	ld	hl,(ix+5)
	ld	hl,(hl)
	ld	(ix-2),hl
	.seg	FARCODE
;51   return (next == head) && (next == head->prev);
	.debug	# 51
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix-2)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	nz,@8
	ld	hl,(ix+5)
	inc	hl
	inc	hl
	ld	hl,(hl)
	or	a,a
	sbc	hl,de
	jr	nz,@8
	ld	hl,1
	jr	@5
@8:
	bool	hl
	ld	l,h
;52 }
@5:
	.debug	} @5 52

@4	equ	2
	ld	sp,ix
	pop	ix
	lret
@6	equ	4
;53 
;54 
;55 /*-------------------------------------------------------------------------
;56  * list_splice - join two lists
;57  * @list: the new list to add.
;58  * @head: the place to add it in the first list.
;59  *-------------------------------------------------------------------------
;60 void list_splice(list_head_t *list, list_head_t *head)
;61 {
$list_splice::
	.debug	G $list_splice 36 9
	.debug	{ $list_splice 36 60 @12 @11
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-6
	.debug	A list 5 33
	.debug	A head 7 33
;62   list_head_t *first = list->next;
	.debug	L first -2 33
	.debug	# 62
	ld	hl,(ix+5)
	ld	hl,(hl)
	ld	(ix-2),hl
	.seg	FARCODE
;63 
;64   if (first != list) {
	.debug	# 64
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix-2)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	z,@13
;65     list_head_t *last = list->prev;
@14:
	.debug	< @14 @15
	.debug	L last -4 33
	.debug	# 65
	ld	hl,(ix+5)
	inc	hl
	inc	hl
	ld	hl,(hl)
	ld	(ix-4),hl
	.seg	FARCODE
;66     list_head_t *at = head->next;
	.debug	L at -6 33
	.debug	# 66
	ld	hl,(ix+7)
	ld	hl,(hl)
	ld	(ix-6),hl
	.seg	FARCODE
;67 
;68     first->prev = head;
	.debug	# 68
	ld	h,d
	ld	l,e
	inc	hl
	inc	hl
	ex	de,hl
	ld	hl,(ix+7)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
;69     head->next = first;
	.debug	# 69
	ld	hl,(ix-2)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
;70 
;71     last->next = at;
	.debug	# 71
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-6)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
;72     at->prev = last;
	.debug	# 72
	ld	h,d
	ld	l,e
	inc	hl
	inc	hl
	ex	de,hl
	ld	hl,(ix-4)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
;73   }
@15:
	.debug	>
;74 }
@13:
@11:
	.debug	} @11 74

@10	equ	6
	ld	sp,ix
	pop	ix
	lret
@12	equ	8
;75 
;76 
	.debug	T	130002200003000100210000002100020021000400
	.debug	T	070000210002002200
	.debug	T	2600032200040002000A6C6973745F686561640021000000056E65
	.debug	T	78740021000200057072657600
	.debug	T	0B000223000100060021000000
	.debug	T	0F00022400020001002100000021000200
	.end
