	.objcmt	Softools, Inc. ** Control Cross-C Globally Optimizing Compiler ** Version 2.18.00
	.objcmt	Copyright (c) 1989 - 2003, Softools, Inc.  All rights reserved.
	.debug	P 5
	.debug	X 11 10
	.debug	X 12 10
	.debug	N 'C:\work\dev\Rabbit_ST\rtos\arch\timerb.c' 24 35 11 11 6 32
;1 //----- timerb.c ----- 02/15/12 -----(xx/xx/06)-----
;2 
;3 //-------------------------------------------------------------------------
;4 //  TimerB interrupt handler.  Original version (used almost verbatim here)
;5 //  from SHDesigns TimerB sample code.
;6 //-------------------------------------------------------------------------
;7 //  Change log (most recent first)
;8 //
;9 //
;10 //  2012-06-11 - Mark Davis
;11 //               - _TimerMilliSeconds[1] and _TimerSeconds are now updated
;12 //                 within _TimerBISR().
;13 //               - Changed the name of timer_interrupt() to sched_tick().
;14 //
;15 //  2012-02-15 - Mark Davis
;16 //               - Made timer_interrupt() a far func to free up some root
;17 //                 memory space.
;18 //
;19 //  2010-02-27 - Mark Davis
;20 //               - ipres is now done regardless of whether timer_interrupt(
;21 //                 is called.  This is required because timer_interrupt()
;22 //                 now reenables the interrupt just long enough to call
;23 //                 schedule() (and not at all if it doesn't call schedule()
;24 //
;25 //  2007-03-02 - Mark Davis
;26 //               - initial use of slightly modified version of this code (?
;27 //
;28 //-------------------------------------------------------------------------
;29 
;30 #include "dcdefs.h"
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\dcdefs.h' 18 42 23 19 7 26
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Rabbit.h' 24 40 11 19 5 30
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stdio.h' 22 16 12 9 4 26
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\SoftoolsIDblock.h' 18 52 15 4 6 26
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\FlashBlock.h' 5 10 16 30 11 24
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Flash.h' 0 55 21 17 7 26
	.debug	I
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\SoftoolsIDBlock.h' 18 52 15 4 6 26
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\errors.h' 25 8 15 18 11 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stdlib.h' 2 30 16 6 7 24
	.debug	I
	.debug	# 109
_LIN2SEG	.macro

	.debug	# 110
add hl,hl

	.debug	# 111
rla

	.debug	# 112
add hl,hl

	.debug	# 113
rla

	.debug	# 114
add hl,hl

	.debug	# 115
rla

	.debug	# 116
add hl,hl

	.debug	# 117
rla

	.debug	# 118
sub 0x0E

	.debug	# 119
or a

	.debug	# 120
rr hl

	.debug	# 121
scf

	.debug	# 122
rr hl

	.debug	# 123
scf

	.debug	# 124
rr hl

	.debug	# 125
scf

	.debug	# 126
rr hl

	.debug	# 127
.endm

	.cseg
	.debug	I
;31 #include "TIMERB.h"
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\TIMERB.h' 7 27 11 11 6 32
	.debug	I
;32 #include "Rabbit.h"
;33 
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Rabbit.h' 24 40 11 19 5 30
	.debug	I
;34 #include <sys/types.h>
;35 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
;36 
;37 
;38 #define XTAL_FREQ ((long)_serial19200TC * 307200l)
;39 
;40 #if DEBUG_RST
;43   #define MIN_TIMER 165
;44 #endif
;45 
;46 static int _timerb_inc;
;47 // used by isr
;48 static unsigned  int _timerb_ctr;
;49 unsigned int  _timerb_scale; // made public for demo
;50 static float  _timerb_divisor;
;51 static int  _timerb_match = 0;
	.dseg
__timerb_match:
	.dw	0
	.debug	F __timerb_match 6 0
;52 
;53 uchar  intTicks;
;54 
;55 /*-------------------------------------------------------------------------
;56 ***** WARNING *****
;57   If this is changed at all, be sure to update the TimerBISR_PushCount macr
;58   in the header file!!!
;59 ***** WARNING *****
;60  --------------------------------------------------------------------------
;61  --- This is what the stack look likes when we call sched_tick() ---
;62 
;63                 ret_addr (LSB)  (addr inside _TimerBISR())
;64                 ret_addr (MSB)
;65 
;66                 XPC
;67 
;68                 AF' (LSB)
;69                 AF' (MSB)
;70 
;71                 BC' (LSB)
;72                 BC' (MSB)
;73 
;74                 DE' (LSB)
;75                 DE' (MSB)
;76 
;77                 HL' (LSB)
;78                 HL' (MSB)
;79 
;80                 BC (LSB)
;81                 BC (MSB)
;82 
;83                 IY (LSB)
;84                 IY (MSB)
;85 
;86                 IX (LSB)
;87                 IX (MSB)
;88            --------------------
;89                 HL (LSB)
;90                 HL (MSB)
;91 
;92                 DE (LSB)
;93                 DE (MSB)
;94 
;95                 AF (LSB == F)
;96                 AF (MSB == A)
;97 */
;98 
;99 //-------------------------------------------------------------------------
;100 // *** WARNING ***
;101 //     ANY changes to this will almost certainly require changes to the
;102 //     dumpFault() and postMortem() functions in unistd.c!!!
;103 // *** WARNING ***
;104 //-------------------------------------------------------------------------
;105 void near _nostep _TimerBISR(void)
;106 {
	.cseg
__TimerBISR::
	.debug	G __TimerBISR 32 3
	.debug	{ __TimerBISR 32 105 @3 @2
;107 #asm
	.debug	# 108
push   af                    

	.debug	# 109
push   de                    

	.debug	# 110
push   hl                    

	.debug	# 112
ld     hl,(__timerb_match)   

	.debug	# 113
ld     a,h                   

	.debug	# 114
or     0x3f  

	.debug	# 115
ld     h,a                   

	.debug	# 116
ld     de,(__timerb_inc)     

	.debug	# 117
add    hl,de                 

	.debug	# 118
ld     (__timerb_match),hl   

	.debug	# 120
push   ip

	.debug	# 122
ipset  3

	.debug	# 123
ioi ld a, (0xB0)     

	.debug	# 124
ld     a,h

	.debug	# 125
ioi ld (0xB2), a     

	.debug	# 126
ld     a,l            

	.debug	# 127
ioi ld (0xB3), a     

	.debug	# 129
pop    ip

	.debug	# 132
ld     hl,(__timerb_scale)

	.debug	# 133
bool   hl

	.debug	# 134
jr     z,no_scale

	.debug	# 137
ld     hl,(__timerb_ctr)

	.debug	# 138
dec    hl

	.debug	# 139
ld     (__timerb_ctr),hl

	.debug	# 140
bool   hl

	.debug	# 141
jr     nz,skip_user

	.debug	# 143
ld     hl,(__timerb_scale)

	.debug	# 144
ld     (__timerb_ctr),hl

	.debug	# 146
no_scale:

	.debug	# 148
ld     hl,__TimerMilliSeconds##+4

	.debug	# 149
inc    (hl)

	.debug	# 150
jr     nz,..x

	.debug	# 152
inc    hl

	.debug	# 153
inc    (hl)

	.debug	# 154
jr     nz,..x

	.debug	# 156
inc    hl

	.debug	# 157
inc    (hl)

	.debug	# 158
jr     nz,..x

	.debug	# 160
inc    hl

	.debug	# 161
inc    (hl)

	.debug	# 162
..x:

	.debug	# 165
ld     hl,(_milliTicks##)

	.debug	# 166
inc    hl

	.debug	# 167
ld     (_milliTicks##),hl

	.debug	# 168
ld     de,0x3e8

	.debug	# 169
or     a,a

	.debug	# 170
sbc    hl,de

	.debug	# 171
jr     nz,..endSecChk

	.debug	# 173
ld     hl,__TimerSeconds##

	.debug	# 174
inc    (hl)

	.debug	# 175
jr     nz,..y

	.debug	# 177
inc    hl

	.debug	# 178
inc    (hl)

	.debug	# 179
jr     nz,..y

	.debug	# 181
inc    hl

	.debug	# 182
inc    (hl)

	.debug	# 183
jr     nz,..y

	.debug	# 185
inc    hl

	.debug	# 186
inc    (hl)

	.debug	# 187
..y:

	.debug	# 189
bool    hl

	.debug	# 190
ld      l,h

	.debug	# 191
ld      (_milliTicks##),hl

	.debug	# 192
..endSecChk:

	.debug	# 196
ld      a,(_intTicks)

	.debug	# 197
inc     a

	.debug	# 198
ld      (_intTicks),a

	.debug	# 199
bool    hl

	.debug	# 200
ld      l,a

	.debug	# 201
ld      de,(_SchedMS##)

	.debug	# 202
or      a,a

	.debug	# 203
sbc     hl,de

	.debug	# 204
jp      c,skip_user

	.debug	# 207
xor     a,a

	.debug	# 208
ld      (_intTicks),a

	.debug	# 212
push   ix                    

	.debug	# 213
push   iy                    

	.debug	# 214
push   bc                    

	.debug	# 216
exx                          

	.debug	# 217
push   hl                    

	.debug	# 218
push   de                    

	.debug	# 219
push   bc                    

	.debug	# 220
exx                          

	.debug	# 222
ex     af,af'                ;[2]


	.debug	# 223
push   af                    

	.debug	# 224
ex     af,af'                ;[2]


	.debug	# 227
lcall   $sched_tick##   

	.debug	# 229
ex     af,af'                ;[2]


	.debug	# 230
pop    af                    

	.debug	# 231
ex     af,af'                ;[2]


	.debug	# 233
exx                          

	.debug	# 234
pop    bc                    

	.debug	# 235
pop    de                    

	.debug	# 236
pop    hl                    

	.debug	# 237
exx                          

	.debug	# 239
pop    bc                    

	.debug	# 240
pop    iy                    

	.debug	# 241
pop    ix                    

	.debug	# 244
skip_user:

	.debug	# 245
pop    hl

	.debug	# 246
pop    de

	.debug	# 247
pop    af

	.debug	# 249
ipres

	.cseg
;252 }
@2:
	.debug	} @2 252

@1	equ	0
	ret
@3	equ	0
;253 
;254 
;255 //-------------------------------------------------------------------------
;256 int _nostep select_timer(unsigned long usec, char intlevel)
;257 {
	.defseg	FARCODE
	.seg	FARCODE
$select_timer::
	.debug	G $select_timer 33 11
	.debug	{ $select_timer 33 256 @6 @5
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-10
	.debug	A usec 5 9
	.debug	A intlevel 9 3
;258   static char  timera_mod = 0;
	.dseg
@7:
	.db	0
	.debug	S timera_mod @7 3
	.seg	FARCODE
;259   unsigned long  divisor;
	.debug	L divisor -4 9
;260   int  timeradiv;
	.debug	L timeradiv -6 6
;261   unsigned long  intscale;
	.debug	L intscale -10 9
;262 
;263   _timerb_match = 0;
	.debug	# 263
	bool	hl
	ld	l,h
	ld	(__timerb_match),hl
;264   ini(TBCSR);             // clear any pending int
	.debug	# 264
	ioi ld	a,(176)
;265   ioSrOutI(TBCSR, 0x00);  // disable timer B and its interrupts
	.debug	# 265
	xor	a,a
	ld	de,0xb0
  ld  hl,_srTBCSR##
  ld  (hl),a
  ioi ldi
;266   ioSrOutI(TBCR, 0x04);   // disable timer B and its interrupts (use timer 
	.debug	# 266
	ld	a,0x4
	ld	de,0xb1
  ld  hl,_srTBCR##
  ld  (hl),a
  ioi ldi
;267   ini(TBCSR);             // clear any pending int
	.debug	# 267
	ioi ld	a,(176)
;268   _timerb_scale = 0;      // no scale be default
	.debug	# 268
	bool	hl
	ld	l,h
	ld	(__timerb_scale),hl
;269 
;270   // if serial ports are using timer A1 we can't modify it.
;271   timeradiv = (int)srTAT1R + 1;
	.debug	# 271
	ld	a,(_srTAT1R)
	ld	l,a
	inc	hl
	ld	(ix-6),hl
;272   if (timeradiv == 1)  timera_mod = 1; // we can change it
	.debug	# 272
	ld	de,0x1
	or	a,a
	sbc	hl,de
	jr	nz,@8
	ld	a,e
	ld	(@7),a
;273   if (timera_mod)  timeradiv = 256;  // use max as default
@8:
	.debug	# 273
	ld	a,(@7)
	or	a,a
	jr	z,@9
	ld	hl,0x100
	ld	(ix-6),hl
;274 
;275   intscale = (unsigned long) // divisor is # of 1024 count timerb rollovers
@9:
;276      ((float)usec * (float)XTAL_FREQ / 1.024e9);
	.debug	# 276
	ld	a,(__serial19200TC)
	ld	e,a
	ld	bc,0
	ld	d,c
	push	bc
	push	de
	ld	de,0xb000
	ld	c,0x4
	call	__ulmlt##
	call	__ltof##
	push	bc
	push	de
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	call	__ultof##
	call	__fmlt##
	push	bc
	push	de
	ld	de,0x2400
	ld	bc,0x4e74
	call	__fdiv##
	call	__ftol##
	ld	hl,bc
	ld	(ix-8),hl
	ex	de,hl
	ld	(ix-10),hl
	ex	de,hl
;277 
;278   if (intscale < timeradiv) {  // max for using both timer A and B
	.debug	# 278
	ld	hl,(ix-6)
	ex	de,hl
	ld	a,d
	rlca
	sbc	a,a
	ld	c,a
	ld	b,a
	push	bc
	push	de
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	call	__lsubr##
	jp	nc,@10
;279     divisor = (unsigned long) (((float)usec * (float)XTAL_FREQ) / 1.0e6+0.5
@11:
	.debug	< @11 @12
	.debug	# 279
	ld	a,(__serial19200TC)
	ld	e,a
	ld	bc,0
	ld	d,c
	push	bc
	push	de
	ld	de,0xb000
	ld	c,0x4
	call	__ulmlt##
	call	__ltof##
	push	bc
	push	de
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	call	__ultof##
	call	__fmlt##
	push	bc
	push	de
	ld	de,0x2400
	ld	bc,0x4974
	call	__fdiv##
	push	bc
	push	de
	ld	de,0
	ld	bc,0x3f00
	call	__fadd##
	call	__ftol##
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
;280     if (intscale == 0L)   {  // timer b only
	.debug	# 280
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	or	hl,de
	jr	nz,@13
;281       intlevel &= 3;    // mask valid
@14:
	.debug	< @14 @15
	.debug	# 281
	ld	a,(ix+9)
	and	a,3
	ld	(ix+9),a
;282       _timerb_divisor = divisor;
	.debug	# 282
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	call	__ultof##
	ld	(__timerb_divisor),de
	ld	(__timerb_divisor+2),bc
;283       // not enough instrs for accurate time between ints?
;284       if (divisor < MIN_TIMER)  return 1;
	.debug	# 284
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xa5
	ld	c,d
	ld	b,d
	call	__lsub##
	jp	nc,@27
	jp	@38
;285     }
@15:
	.debug	>
;286     else  if (intscale < 8L)  { // TimerB clk/16
@13:
	.debug	# 286
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x8
	ld	c,d
	ld	b,d
	call	__lsub##
	jr	nc,@18
;287       intlevel = 0x8 | (intlevel & 3);    // mask valid set pclk/2
@19:
	.debug	< @19 @20
	.debug	# 287
	ld	a,(ix+9)
	and	a,3
	or	a,8
	ld	(ix+9),a
;288       divisor = (unsigned long) (((float)usec * (float)XTAL_FREQ) / 8.0e6+0
	.debug	# 288
	ld	a,(__serial19200TC)
	ld	e,a
	ld	bc,0
	ld	d,c
	push	bc
	push	de
	ld	de,0xb000
	ld	c,0x4
	call	__ulmlt##
	call	__ltof##
	push	bc
	push	de
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	call	__ultof##
	call	__fmlt##
	push	bc
	push	de
	ld	de,0x2400
	ld	bc,0x4af4
	call	__fdiv##
	push	bc
	push	de
	ld	de,0
	ld	bc,0x3f00
	call	__fadd##
	call	__ftol##
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
;289       _timerb_divisor = divisor * 8L;
	.debug	# 289
	ld	a,0x3
	call	__lshl##
	jp	@39
;290     }
@20:
	.debug	>
;291     else  {  // use TimerA
@18:
;292       if (timera_mod)  { // this is unused so we can modify it
@22:
	.debug	< @22 @23
	.debug	# 292
	ld	a,(@7)
	or	a,a
	jp	z,@24
;293         timeradiv = (int)((divisor + 1023L) / 1024L);
@25:
	.debug	< @25 @26
	.debug	# 293
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x3ff
	ld	bc,0
	call	__ladd##
	ld	a,0xa
	call	__ulshr##
	ex	de,hl
	ld	(ix-6),hl
;294         ioSrOutI(TAT1R, timeradiv - 1);  // use new val
	.debug	# 294
	dec	hl
	ld	a,l
	ld	de,0xa3
  ld  hl,_srTAT1R##
  ld  (hl),a
  ioi ldi
;295       }
@26:
	.debug	>
;296       intlevel = 0x4 | (intlevel & 3);    // mask valid set timera
@24:
	.debug	# 296
	ld	a,(ix+9)
	and	a,3
	or	a,4
	ld	(ix+9),a
;297       // try to calc best value
;298       divisor = (divisor + (timeradiv>>1)) /timeradiv; // nearest mult of t
	.debug	# 298
	ld	hl,(ix-6)
	sra	h
	rr	l
	ex	de,hl
	ld	a,d
	rlca
	sbc	a,a
	ld	c,a
	ld	b,a
	push	bc
	push	de
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	call	__ladd##
	ld	hl,(ix-6)
	push	bc
	push	de
	ex	de,hl
	ld	a,d
	rlca
	sbc	a,a
	ld	c,a
	ld	b,a
	call	__uldiv##
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
;299       _timerb_divisor = divisor * timeradiv;
	.debug	# 299
	ld	hl,(ix-6)
	ex	de,hl
	ld	a,d
	rlca
	sbc	a,a
	ld	c,a
	ld	b,a
	push	bc
	push	de
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	call	__ulmlt##
@39:
	call	__ultof##
	ld	(__timerb_divisor),de
	ld	(__timerb_divisor+2),bc
;300     }
@23:
	.debug	>
;301   }
@12:
	.debug	>
;302   else {  // TimerA + TimerB + timerscale
	jp	@27
@10:
;303     intlevel = 0x4 | (intlevel & 3);  // mask valid set TimerA
@28:
	.debug	< @28 @29
	.debug	# 303
	ld	a,(ix+9)
	and	a,3
	or	a,4
	ld	(ix+9),a
;304     ioSrOutI(TAT1R, timeradiv - 1);   // use new val
	.debug	# 304
	ld	hl,(ix-6)
	dec	hl
	ld	a,l
	ld	de,0xa3
  ld  hl,_srTAT1R##
  ld  (hl),a
  ioi ldi
;305 
;306     intscale = (unsigned long)
;307             (((float)usec * (float)XTAL_FREQ) / (timeradiv * 1.024e9) + 1.0
	.debug	# 307
	ld	a,(__serial19200TC)
	ld	e,a
	ld	bc,0
	ld	d,c
	push	bc
	push	de
	ld	de,0xb000
	ld	c,0x4
	call	__ulmlt##
	call	__ltof##
	push	bc
	push	de
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	call	__ultof##
	call	__fmlt##
	ld	hl,(ix-6)
	push	bc
	push	de
	ex	de,hl
	call	__itof##
	push	bc
	push	de
	ld	de,0x2400
	ld	bc,0x4e74
	call	__fmlt##
	call	__fdiv##
	call	__finc##
	call	__ftol##
	ld	hl,bc
	ld	(ix-8),hl
	ex	de,hl
	ld	(ix-10),hl
	ex	de,hl
;308     if (intscale > 65535L)  return 1;  // max for using both timer A & B an
	.debug	# 308
	push	bc
	push	de
	ld	de,0xffff
	ld	bc,0
	call	__lsub##
	jr	c,@30
	jr	z,@30
@38:
	ld	hl,0x1
	jp	@5
;309 
;310     divisor = (unsigned long)
@30:
;311       (((float)usec * (float)XTAL_FREQ) / (timeradiv * 1.0e6 * intscale) + 
	.debug	# 311
	ld	a,(__serial19200TC)
	ld	e,a
	ld	bc,0
	ld	d,c
	push	bc
	push	de
	ld	de,0xb000
	ld	c,0x4
	call	__ulmlt##
	call	__ltof##
	push	bc
	push	de
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	call	__ultof##
	call	__fmlt##
	ld	hl,(ix-6)
	push	bc
	push	de
	ex	de,hl
	call	__itof##
	push	bc
	push	de
	ld	de,0x2400
	ld	bc,0x4974
	call	__fmlt##
	push	bc
	push	de
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	call	__ultof##
	call	__fmlt##
	call	__fdiv##
	push	bc
	push	de
	ld	de,0
	ld	bc,0x3f00
	call	__fadd##
	call	__ftol##
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
;312 
;313     _timerb_scale = (unsigned int) intscale;  // init first
	.debug	# 313
	ld	hl,(ix-10)
	ld	(__timerb_scale),hl
;314 
;315 #ifdef TIMERB_IMMEDIATE
;318     _timerb_ctr = _timerb_scale;
	.debug	# 318
	ld	(__timerb_ctr),hl
;319     if (divisor != 1024)  _timerb_ctr++;
	.debug	# 319
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xfc00
	ld	bc,0xffff
	call	__ladd##
	jr	z,@31
	ld	hl,(__timerb_ctr)
	inc	hl
	ld	(__timerb_ctr),hl
;320 #endif
;321 
;322     _timerb_divisor = (float)divisor * (float)intscale * (float)timeradiv;
@31:
	.debug	# 322
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	call	__ultof##
	push	bc
	push	de
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	call	__ultof##
	call	__fmlt##
	ld	hl,(ix-6)
	push	bc
	push	de
	ex	de,hl
	call	__itof##
	call	__fmlt##
	ld	(__timerb_divisor),de
	ld	(__timerb_divisor+2),bc
;323   }
@29:
	.debug	>
;324 
;325   _timerb_inc = (int)((divisor & 0xff) | ((divisor << 6) & 0xc000));  // va
@27:
	.debug	# 325
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xff
	ld	c,d
	ld	b,d
	call	__land##
	push	bc
	push	de
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	ld	a,0x6
	call	__lshl##
	push	bc
	push	de
	ld	de,0xc000
	ld	c,e
	ld	b,e
	call	__land##
	call	__lor##
	ld	(__timerb_inc),de
;326 
;327 //  ipset3();
;328 
;329 #asm
	.debug	# 330
ioi ld  a,(0xBF)

	.debug	# 331
ld      l,a

	.debug	# 332
ioi ld  a,(0xBE)

	.debug	# 333
or      0x3f

	.debug	# 334
ld      h,a

	.debug	# 335
ld      de,(__timerb_inc)

	.debug	# 336
add     hl,de

	.debug	# 337
ld      (__timerb_match),hl

	.debug	# 338
ld      a,h

	.debug	# 339
ioi ld  (0xB2),a

	.debug	# 340
ld      a,l

	.debug	# 341
ioi ld  (0xB3),a

	.debug	# 342
ld      a,0x3

	.debug	# 343
ioi ld  (0xB0),a

	.debug	# 344
ld      (_srTBCSR),a

;346 
	.seg	FARCODE
;347   setInterruptHandler(INT_TIMER_B, _TimerBISR);    // set up ISR
	.debug	# 347
	ld	hl,__TimerBISR
	push	hl
	ld	hl,0xb
	push	hl
	lcall	$setInterruptHandler
	add	sp,4
;348   ioSrOutI(TBCR, intlevel);  // clock timer B with clock source and int lev
	.debug	# 348
	ld	a,(ix+9)
	ld	de,0xb1
  ld  hl,_srTBCR##
  ld  (hl),a
  ioi ldi
;349 
;350 //  ipres();
;351 
;352 #ifdef TIMER_DEBUG
;357   return 0; // :-)
	.debug	# 357
	bool	hl
	ld	l,h
;358 }
@5:
	.debug	} @5 358

@4	equ	10
	ld	sp,ix
	pop	ix
	lret
@6	equ	12
;359 
;360 //-------------------------------------------------------------------------
;361 float TimerBRate()
;362 {
$TimerBRate::
	.debug	G $TimerBRate 34 9
	.debug	{ $TimerBRate 34 361 @34 @33
;363   return (_timerb_divisor * 1000000.0) / ((float) XTAL_FREQ);
	.debug	# 363
	ld	de,(__timerb_divisor)
	ld	bc,(__timerb_divisor+2)
	push	bc
	push	de
	ld	de,0x2400
	ld	bc,0x4974
	call	__fmlt##
	ld	a,(__serial19200TC)
	push	bc
	push	de
	ld	e,a
	ld	bc,0
	ld	d,c
	push	bc
	push	de
	ld	de,0xb000
	ld	c,0x4
	call	__ulmlt##
	call	__ltof##
	call	__fdiv##
;364 }
@33:
	.debug	} @33 364

@32	equ	0
	lret
@34	equ	0
;365 
;366 
;367 //-------------------------------------------------------------------------
;368 void TimerBUninit(void)
;369 {
$TimerBUninit::
	.debug	G $TimerBUninit 32 9
	.debug	{ $TimerBUninit 32 368 @37 @36
;370   outi(TBCSR, srTBCSR = 0x00);  // disable timer B and its interrupts
	.debug	# 370
	xor	a,a
	ld	(_srTBCSR),a
	ioi ld	(176),a
;371 }
@36:
	.debug	} @36 371

@35	equ	0
	lret
@37	equ	0
;372 
;373 //-------------------------------------------------------------------------
	.extern	_srTAT1R 3
	.extern	_srTBCSR 3
	.extern	$setInterruptHandler 35
	.extern	__serial19200TC 3
	.bseg
__timerb_scale::
	.ds	2
	.debug	G __timerb_scale 7 0
__timerb_inc:
	.ds	2
	.debug	F __timerb_inc 6 0
__timerb_ctr:
	.ds	2
	.debug	F __timerb_ctr 7 0
__timerb_divisor:
	.ds	4
	.debug	F __timerb_divisor 10 0
_intTicks::
	.ds	1
	.debug	G _intTicks 3 0
	.debug	T	0B000220000100010001000000
	.debug	T	0F00022100020006000900000003000400
	.debug	T	070002220000000A00
	.debug	T	0F00022300020001002400000025000200
	.debug	T	EC0109240001001F00010000000A494E545F54494D45520001000D
	.debug	T	494E545F4E4F545F555345440002000A494E545F5253543130
	.debug	T	0003000A494E545F52535431380004000A494E545F52535432
	.debug	T	300005000A494E545F52535432380006000E494E545F4E4F54
	.debug	T	5F55534544320007000A494E545F52535433380008000F494E
	.debug	T	545F534C4156455F504F52540009000E494E545F4E4F545F55
	.debug	T	53454433000A000C494E545F54494D45525F41000B000C494E
	.debug	T	545F54494D45525F42000C000D494E545F53455249414C5F41
	.debug	T	000D000D494E545F53455249414C5F42000E000D494E545F53
	.debug	T	455249414C5F43000F000D494E545F53455249414C5F440010
	.debug	T	0009494E545F494E543000110009494E545F494E5431001200
	.debug	T	0E494E545F4E4F545F55534544340013000E494E545F4E4F54
	.debug	T	5F55534544350014000E494E545F4E4F545F55534544360015
	.debug	T	000E494E545F4E4F545F55534544370016000E494E545F4E4F
	.debug	T	545F55534544380017000E494E545F4E4F545F555345443900
	.debug	T	18000F494E545F4E4F545F55534544313000190011494E545F
	.debug	T	515541445F4445434F444552001A000E494E545F494E505554
	.debug	T	5F434150001B000F494E545F4E4F545F555345443131001C00
	.debug	T	0D494E545F53455249414C5F45001D000D494E545F53455249
	.debug	T	414C5F46001E0009494E545F4C41535400
	.debug	T	070000250002002000
	.end
