//----- kill.c ----- 02/08/12 -----(03/14/06)-----

//-----------------------------------------------------------------------------
//
//  2012-02-08 - Mark Davis
//               - Actually supports a user specified signal now
//
//  2009-xx-xx - Mark Davis
//               - original version of ...
//
//-----------------------------------------------------------------------------

#include <time.h>
#include <common.h>

#include <sys/types.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/socket.h>
#include <fcntl.h>
#include <arpa/inet.h>
#include <errno.h>
#include <signal.h>
#include <utime.h>


#include <busybox.h>

#include <sys/hdwDefs.h>

#include <dcdefs.h>

#include <ctype.h>
#include <limits.h>

#include <sys/SHD_headers.h>

#include <applic.h>

#include <sys/farprintf.h>


//-----------------------------------------------------------------------------
//  send a signal to a process
//-----------------------------------------------------------------------------
void _task _kill(int argc, char **argv)
{
  int  stat = -1;

  do {
    if (showHelp(2, argc, argv))  {
      printf("\nusage: kill [-signal#] pid\r\n");  break; }

    if (argc > 2)  { stat = kill(ATOI(argv[2]), -ATOI(argv[1]));  break; }

    if (isdigit(*argv[1]))  { stat = kill(ATOI(argv[1]), SIGKILL);  break; }
  } while(0);

  Exit(stat);
}


//-----------------------------------------------------------------------------
