//----- linux/dummy.h ----- 04/19/07 -----(04/19/07)-----

#ifndef __LINUX_DUMMY_H
#define __LINUX_DUMMY_H


// dummy header file to handle lots of non-applicable linux stuff
// and allow the few bits I used to compile without the rest


//=============== generic stuff ===============

#define  EXPORT_SYMBOL(s)


//#define  FASTCALL(x)  x
#define  FASTCALL
#define  fastcall

#define  inline
#define  __inline__

#define  NORET_TYPE
#define  NORET_AND
#define  ATTRIB_NORET


#define  BITS_PER_LONG    32


//=============== in place of linux/spinlock.h ===============

#define spin_lock_init(lock)    { }

#define rwlock_init(lock)   { }

#define spin_lock_irqsave(lock, flags)   { {} KLOCK(); {} }
#define spin_unlock_irqrestore(lock, flags)  { {}  KUNLOCK(); {}  }



//=============== from linux/kernel.h ===============

/**
 * container_of - cast a member of a structure out to the containing structure
 * @ptr:  the pointer to the member.
 * @type: the type of the container struct this is embedded in.
 * @member: the name of the member within the struct.
 *
 */
#define container_of(ptr, type, member) ({      \
        const typeof( ((type *)0)->member ) *__mptr = (ptr);  \
        (type *)( (char *)__mptr - offsetof(type,member) );})




#endif /* __LINUX_DUMMY_H */
