//----- sys/RegVars.h ----- 10/05/06 -----(06/08/06)-----

#ifndef _sys_RegVarsH_
#define _sys_RegVarsH_

//--- include this file in any module that needs to reference the global ---
//--- variables defined in RegDefs.h via the ModBus register macros ---

#include <sys/modbus.h>


#define COIL0( name, mult, reg, wrFunc )  \
        extern uchar C0##mult##ValDef(name);

#define REG3( name, mult, reg, typ )  \
        extern typ   R3##mult##ValDef(name);

#define REG4( name, mult, reg, typ, rw, wrFunc )  \
        extern typ   R4##mult##ValDef(name);


//#include <RegDefs.h>



#endif
