//---- sys/nsclSerialProto.h ----- 06/23/06 -----(xx/xx/95)-----


#ifndef _sys_nsclSerialPhotoH_
#define _sys_nsclSerialPhotoH_


#define CMD_CLEAR_ERR              'C'    /* COMMANDS */
#define CMD_DEBUG                  'D'
#define CMD_ECHO                   'E'
#define CMD_INIT                   'I'
#define CMD_CALIBRATE              'K'
#define CMD_MODBUSREGS             'M'
#define CMD_POLL                   'P'
#define CMD_SET_AND_POLL           'Q'
#define CMD_REPORT_ERRS            'R'
#define CMD_SET                    'S'
#define CMD_WHATARESET             'W'
#define CMD_XCAL                   'X'
#define CMD_REBOOT                 'Y'

#define STAT_IGNORE_MESSAGE        '*'    /* STATUS REPORT RESPONSES */
#define STAT_OK                    'A'
#define STAT_BADFORMAT             'B'
#define STAT_CHECKSUM_ERROR        'C'
#define STAT_BAD_FIELD_CHAR        'D'
#define STAT_FRAMING_ERROR         'F'
#define STAT_ILLEGAL_STRUCT        'I'
#define STAT_MESSAGE_LONG          'L'
#define STAT_NOT_FROM_MASTER       'M'
#define STAT_OVERRUN_ERROR         'O'
#define STAT_PARITY_ERROR          'P'
#define STAT_RESET                 'R'
#define STAT_MESSAGE_SHORT         'S'
#define STAT_UNDEFINED_COMMAND     'U'
#define STAT_UNKNOWN               '?'

#define MASTER_ID                  0x2D   /* ID OF MASTER CONTROLLER */


char* reverseString( char* buffer, char dataCount);

char checkMessage(char *buffer, char *ID);

bool packMessage( char* buffer, char ID, char commStat,
                  char* dataBuffer, char dataCount);

char unpackMessage( char* buffer, char* commStat,
                    char* dataBuffer, char* dataCount);



#endif


