	.objcmt	Softools, Inc. ** Control Cross-C Globally Optimizing Compiler ** Version 2.18.00
	.objcmt	Copyright (c) 1989 - 2003, Softools, Inc.  All rights reserved.
	.debug	P 5
	.debug	X 11 10
	.debug	X 12 10
	.debug	N 'C:\work\dev\Rabbit_ST\usr\_shared_.c' 9 58 14 7 9 32
;1 //----- _shared_.c ----- 09/07/12 -----(03/14/06)-----
;2 
;3 //-------------------------------------------------------------------------
;4 //  Module to house versions of the standard command-line commands and ones
;5 //  that are indepent of the application type.
;6 //-------------------------------------------------------------------------
;7 //  UPDATE LOG (most recent first)
;8 //
;9 //
;10 //  2012-09-07 - Mark Davis
;11 //               - Removed leading 0's in the output of fmtHMSUsed()
;12 //
;13 //  2010-10-21 - Mark Davis
;14 //               - Fixed problem that caused calibrations for the wrong sig
;15 //                 to be shown if its name rather than its number was used 
;16 //                 the calibration command.
;17 //
;18 //  2010-05-11 - Mark Davis
;19 //               - Added echo argument to copyData() for use by tip command
;20 //                 half-duplex devices
;21 //
;22 //  2010-02-15 - Mark Davis
;23 //               - Moved readBufCh() from this module to the "common" modul
;24 //
;25 //  2010-02-09 - Mark Davis
;26 //               - calibrate() function now always show the resulting gain,
;27 //                 offset, and range of any changes made before asking if
;28 //                 you want to save the updated values.
;29 //
;30 //  2009-10-27 - Mark Davis
;31 //               - The range show for calib commands is now sorted (with th
;32 //                 numerically smaller value shown for the minimum) so the
;33 //                 min and max values are intuatively correct independent o
;34 //                 the sign on the gain.  NOTE that external functions are
;35 //                 are called to set global values that hold the min/max
;36 //                 values so application code does not have to concern itse
;37 //                 with this issue.
;38 //
;39 //  2009-10-06 - Mark Davis
;40 //               - Updated call to saveParams() to include new parameter th
;41 //                 tells it to save to flash (which was the only option bef
;42 //
;43 //  2009-05-13 - Mark Davis
;44 //               - Added option to calibrate() to dump values out in format
;45 //                 commands that can be run as a script.
;46 //
;47 //  2009-05-11 - Mark Davis
;48 //               - calibrate() now allows you to specify signals via their
;49 //                 index rather than just their name.
;50 //
;51 //  2009-03-13 - Mark Davis
;52 //               - Changed fmtHexLine so it prefaces '%' chars with a '\'
;53 //                 (used by od, rdflash, rdmem, rduserblk).  Before this fi
;54 //                 the output of these commands would be corrupted when the
;55 //                 encountered a byte value of '%'.
;56 //
;57 //  2009-02-04 - Mark Davis
;58 //               - The current value of digital input bits with a forced va
;59 //                 are shown for ios cmd when using digital or input mode e
;60 //                 if the bit doesn't represent a real hardware bit.
;61 //
;62 //  2008-12-03 - Mark Davis
;63 //               - Added ability to set the testpoints used to calibrate
;64 //                 analog outputs
;65 //
;66 //  2008-11-13 - Mark Davis
;67 //               - Added ability to set calibration data by specifying the
;68 //                 range of measurable values
;69 //
;70 //  2008-05-21 - Mark Davis
;71 //               - split in to 2 modules to address linkage problems
;72 //
;73 //  2008-03-29 - Mark Davis
;74 //               - added -t option to update command to download new boot i
;75 //                 from /srfs/test directory
;76 //
;77 //  2008-02-11 - Mark Davis
;78 //               - added "zero" option to xxxcalib commands to set offset t
;79 //                 the latest reading
;80 //
;81 //  2008-01-31 - Mark Davis
;82 //               - added "adc" cmd to allow forcing a value for an ADC read
;83 //
;84 //  2007-07-02 - Mark Davis
;85 //               - Added calibrate() func, used by cmds for viewing/setting
;86 //                 device-specific analog calibrations
;87 //
;88 //  2006-03-14 - Mark Davis
;89 //               - original version started
;90 //
;91 //-------------------------------------------------------------------------
;92 
;93 #include <time.h>
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\time.h' 15 48 18 10 12 22
	.debug	I
;94 #include <common.h>
;95 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\time.h' 15 48 18 10 12 22
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\string.h' 26 27 14 2 6 25
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stddef.h' 21 20 12 5 6 22
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\math.h' 19 23 18 21 9 21
	.debug	I
	.debug	I
;96 #include <sys/types.h>
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
;97 #include <unistd.h>
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\sched.h' 3 49 6 8 6 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\signal.h' 6 21 8 17 3 29
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\list.h' 21 49 15 26 7 30
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\wait.h' 10 13 9 20 4 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\dummy.h' 25 58 21 12 10 27
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\list.h' 21 49 15 26 7 30
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	I
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Rabbit.h' 24 40 11 19 5 30
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stdio.h' 22 16 12 9 4 26
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\SoftoolsIDblock.h' 18 52 15 4 6 26
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\FlashBlock.h' 5 10 16 30 11 24
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Flash.h' 0 55 21 17 7 26
	.debug	I
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Stdlib.h' 2 30 16 6 7 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\dcdefs.h' 18 42 23 19 7 26
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Rabbit.h' 24 40 11 19 5 30
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\SoftoolsIDBlock.h' 18 52 15 4 6 26
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\errors.h' 25 8 15 18 11 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stdlib.h' 2 30 16 6 7 24
	.debug	I
	.debug	# 109
_LIN2SEG	.macro

	.debug	# 110
add hl,hl

	.debug	# 111
rla

	.debug	# 112
add hl,hl

	.debug	# 113
rla

	.debug	# 114
add hl,hl

	.debug	# 115
rla

	.debug	# 116
add hl,hl

	.debug	# 117
rla

	.debug	# 118
sub 0x0E

	.debug	# 119
or a

	.debug	# 120
rr hl

	.debug	# 121
scf

	.debug	# 122
rr hl

	.debug	# 123
scf

	.debug	# 124
rr hl

	.debug	# 125
scf

	.debug	# 126
rr hl

	.debug	# 127
.endm

	.cseg
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\hdwdefs.h' 20 2 12 27 10 31
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\sched.h' 3 49 6 8 6 32
	.debug	I
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\fcntl.h' 29 48 12 5 12 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\wait.h' 10 13 9 20 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\ioctl.h' 2 15 10 21 5 30
	.debug	I
	.debug	I
	.debug	I
;98 #include <sys/stat.h>
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\stat.h' 0 48 10 31 3 29
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\time.h' 15 48 18 10 12 22
	.debug	I
	.debug	I
;99 #include <sys/socket.h>
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\socket.h' 2 54 9 7 6 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\netinet\in.h' 15 56 20 12 3 27
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip.h' 10 19 7 30 6 29
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\dcdefs.h' 18 42 23 19 7 26
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\dcrtcp.h' 1 9 9 21 2 32
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\tcp_config.h' 9 28 14 7 1 25
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\neterrno.h' 26 24 16 30 7 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\errors.h' 25 8 15 18 11 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\servlist.h' 7 29 16 30 7 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\net.h' 21 21 9 7 3 32
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ppp.h' 4 42 22 17 6 26
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ppplink.h' 18 1 2 19 9 26
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\chat.h' 12 7 15 6 10 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Rabbit.h' 24 40 11 19 5 30
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\net.h' 21 21 9 7 3 32
	.debug	I
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\pktdrv.h' 16 19 17 14 3 25
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\arp.h' 21 56 14 30 7 24
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ip.h' 16 35 12 25 4 25
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ip.h' 16 35 12 25 4 25
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\udp.h' 23 23 20 4 3 30
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\icmp.h' 2 44 0 17 5 25
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\tcp.h' 14 5 18 19 4 25
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\bootp.h' 2 16 3 7 2 26
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\bsdname.h' 9 41 20 10 2 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\icmp.h' 2 44 0 17 5 25
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\dns.h' 18 15 17 7 1 25
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\servlist.h' 7 29 16 30 7 24
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\igmp.h' 10 41 20 10 2 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\smtp.h' 0 54 12 2 8 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\http.h' 28 52 16 7 1 25
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\zserver.h' 26 57 12 10 1 25
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\limits.h' 1 13 9 26 5 19
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\pool.h' 10 58 16 7 1 25
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\errno.h' 16 4 11 6 2 29
	.debug	I
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\mib.h' 28 3 18 15 4 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\snmp.h' 22 42 15 4 11 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ftp_client.h' 9 41 20 10 2 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ftp_server.h' 5 50 18 7 1 25
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\zserver.h' 26 57 12 10 1 25
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ethernet.h' 21 56 23 21 3 26
	.debug	I
	.debug	I
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\wait.h' 10 13 9 20 4 32
	.debug	I
	.debug	I
;100 #include <fcntl.h>
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\fcntl.h' 29 48 12 5 12 32
	.debug	I
;101 #include <arpa/inet.h>
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\arpa\inet.h' 14 56 20 12 3 27
	.debug	I
;102 #include <errno.h>
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\errno.h' 22 0 10 11 8 30
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	I
	.debug	I
;103 #include <signal.h>
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\signal.h' 6 21 8 17 3 29
	.debug	I
;104 #include <utime.h>
;105 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\utime.h' 29 54 20 12 3 27
	.debug	I
;106 
;107 #include <busybox.h>
;108 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\busybox.h' 23 57 14 6 3 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\backup.h' 9 9 8 10 9 32
	.debug	I
	.debug	I
;109 #include <sys/backup.h>
;110 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\backup.h' 9 9 8 10 9 32
	.debug	I
;111 #include <sys/hdwDefs.h>
;112 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\hdwDefs.h' 20 2 12 27 10 31
	.debug	I
;113 #include <sys/srfs.h>
;114 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\srfs.h' 6 17 10 7 4 28
	.debug	I
;115 #include <dcdefs.h>
;116 
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\dcdefs.h' 18 42 23 19 7 26
	.debug	I
;117 #include <ctype.h>
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\ctype.h' 22 48 13 9 7 24
	.debug	I
;118 #include <limits.h>
;119 
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\limits.h' 1 13 9 26 5 19
	.debug	I
;120 #include <sys/SHD_headers.h>
;121 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\SHD_headers.h' 7 57 11 8 2 32
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\SoftoolsIDblock.h' 18 52 15 4 6 26
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\fs\DLMiii.h' 3 21 14 4 6 30
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\ZWIDblock.h' 29 54 20 12 3 27
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\SoftoolsIDBlock.h' 18 52 15 4 6 26
	.debug	I
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\fs\SHD_DLM.h' 7 53 11 8 2 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\socket.h' 2 54 9 7 6 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\fs\DLMIII.h' 3 21 14 4 6 30
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I
	.debug	I
;122 extern ulong _xmemSize;
;123 
;124 
;125 #include <tsh.h>
;126 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\tsh.h' 3 45 16 21 3 28
	.debug	I
;127 #include <sys/modbus.h>
;128 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\modbus.h' 21 56 10 7 12 32
	.debug	I
;129 #include <sys/backup.h>
;130 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\backup.h' 9 9 8 10 9 32
	.debug	I
;131 #include <applic.h>
;132 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\applic.h' 28 10 10 5 12 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\busybox.h' 23 57 14 6 3 32
	.debug	I
	.debug	I
;133 #include <sys/farprintf.h>
;134 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\farprintf.h' 5 43 7 29 11 27
	.debug	I
;135 
;136 extern void _task configd(int argc, char **argv);
;137 extern void _task inetd(int argc, char **argv);
;138 //extern void _task timeClient(int argc, char **argv);
;139 
;140 
;141 //--- a "forgotten" prototype (from sys/stat.h) ---
;142 int stat(const char *file_name, struct stat *buf);
;143 
;144 //#include <user_block.h>
;145 //int   readUserBlock(void *dest, unsigned addr, unsigned numbytes);
;146 
;147 
;148 //=========================================================================
;149 const CalibInfo far adcCalibInfo = {
;150   adcGetRaw, adcMinRaw, adcMaxRaw,
	.defseg	FARCONST
	.seg	FARCONST
_adcCalibInfo::
	.dw	word _adcGetRaw
	.dw	word _adcMinRaw
	.dw	word _adcMaxRaw
;151   adcDefaults, adcCalibPoints,
	.dw	word _adcDefaults
	.dw	word _adcCalibPoints
;152   adcUnits, ainName, logicalOrderAIN,
	.dw	word _adcUnits
	.dw	word _ainName
	.dw	word _logicalOrderAIN
;153   newADCCalib,
	.dw	word _newADCCalib
;154   NULL,
	.dw	0
;155   &hdwCfgFile,
	.dw	word _hdwCfgFile
;156   adcGain, adcOffset,
	.dw	word _adcGain
	.dw	word _adcOffset
;157   &NumHdwADC,
	.dw	word _NumHdwADC
;158   "ADC"
;159 };
	.dw	@1
	.debug	G _adcCalibInfo 32 8
;160 
;161 const CalibInfo far dacCalibInfo = {
;162   dacGetRaw, dacMinRaw, dacMaxRaw,
_dacCalibInfo::
	.dw	word _dacGetRaw
	.dw	word _dacMinRaw
	.dw	word _dacMaxRaw
;163   dacDefaults, dacCalibPoints,
	.dw	word _dacDefaults
	.dw	word _dacCalibPoints
;164   dacUnits, aoutName, logicalOrderAOUT,
	.dw	word _dacUnits
	.dw	word _aoutName
	.dw	word _logicalOrderAOUT
;165   newDACCalib,
	.dw	word _newDACCalib
;166   setStateDAC,
	.dw	word _setStateDAC
;167   &hdwCfgFile,
	.dw	word _hdwCfgFile
;168   dacGain, dacOffset,
	.dw	word _dacGain
	.dw	word _dacOffset
;169   &NumHdwDAC,
	.dw	word _NumHdwDAC
;170   "DAC"
;171 };
	.dw	@1+4
	.debug	G _dacCalibInfo 32 8
;172 
;173 const CalibInfo far readCalibInfo = {
;174   readGetRaw, readMinRaw, readMaxRaw,
_readCalibInfo::
	.dw	word _readGetRaw
	.dw	word _readMinRaw
	.dw	word _readMaxRaw
;175   readDefaults, readCalibPoints,
	.dw	word _readDefaults
	.dw	word _readCalibPoints
;176   readUnits, ainName, logicalOrderAIN,
	.dw	word _readUnits
	.dw	word _ainName
	.dw	word _logicalOrderAIN
;177   newADCCalib,  // newCalib(ui)
	.dw	word _newADCCalib
;178   NULL,
	.dw	0
;179   &devDataFile,
	.dw	word _devDataFile
;180   readGain, readOffset,
	.dw	word _readGain
	.dw	word _readOffset
;181   &NumApplAIN,
	.dw	word _NumApplAIN
;182   "Device Readings"
;183 };
	.dw	@1+8
	.debug	G _readCalibInfo 32 8
;184 
;185 const CalibInfo far setCalibInfo = {
;186   setGetRaw, setMinRaw, setMaxRaw,
_setCalibInfo::
	.dw	word _setGetRaw
	.dw	word _setMinRaw
	.dw	word _setMaxRaw
;187   setDefaults, setCalibPoints,
	.dw	word _setDefaults
	.dw	word _setCalibPoints
;188   setUnits, aoutName, logicalOrderAOUT,
	.dw	word _setUnits
	.dw	word _aoutName
	.dw	word _logicalOrderAOUT
;189   newDACCalib,
	.dw	word _newDACCalib
;190   NULL,
	.dw	0
;191   &devDataFile,
	.dw	word _devDataFile
;192   setGain, setOffset,
	.dw	word _setGain
	.dw	word _setOffset
;193   &NumApplAOUT,
	.dw	word _NumApplAOUT
;194   "Device Settings"
;195 };
	.dw	@1+24
	.debug	G _setCalibInfo 32 8
;196 
;197 
;198 
;199 //-------------------------------------------------------------------------
;200 //  show or set the level of diagnostic output for processes
;201 //-------------------------------------------------------------------------
;202 //  show description of the specified command
;203 //-------------------------------------------------------------------------
;204 void showDesc(char *cmdStr)
;205 {
	.defseg	FARCODE
	.seg	FARCODE
$showDesc::
	.debug	G $showDesc 33 9
	.debug	{ $showDesc 33 204 @4 @3
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-6
	.debug	A cmdStr 5 34
;206   uint  u;
	.debug	L u -2 7
;207   const CmdInfo far *cmdInfo;
	.debug	L cmdInfo -6 35
;208 
;209 
;210   for (u=0; u<NumCommonCmds; ++u)  {
@5:
	.debug	< @5 @6
	.debug	# 210
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@7:
	ld	hl,(ix-2)
	ld	de,(_NumCommonCmds)
	or	a,a
	sbc	hl,de
	jr	nc,@8
;211     cmdInfo = commonCmds + u;
@10:
	.debug	< @10 @11
	.debug	# 211
	ld	hl,(ix-2)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,0xa
	call	__ulmlt##
	push	bc
	push	de
	ld	de,word (phys _commonCmds)
	ld	c,phys _commonCmds >> 16
	call	__ladd##
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
;212     if (fstrcmp((char far *)cmdStr, cmdInfo->cmdName) == 0)  {
	.debug	# 212
	call	__farld4##
	push	bc
	push	de
	ld	hl,(ix+5)
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	call	_fstrcmp
	add	sp,8
	bool	hl
	jr	z,@282
;213       printf("\r\n%ls\r\n", cmdInfo->descr);  return;  }
@13:
	.debug	< @13 @14
	.debug	# 213
@14:
	.debug	>
;214   }
@11:
	.debug	>
;215 
;216   for (u=0; u<NumApplCmds; ++u)  {
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jr	@7
@8:
@6:
	.debug	>
@16:
	.debug	< @16 @17
	.debug	# 216
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@18:
	ld	hl,(ix-2)
	ld	de,(_NumApplCmds)
	or	a,a
	sbc	hl,de
	jr	nc,@19
;217     cmdInfo = applCmds + u;
@21:
	.debug	< @21 @22
	.debug	# 217
	ld	hl,(ix-2)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,0xa
	call	__ulmlt##
	push	bc
	push	de
	ld	de,word (phys _applCmds)
	ld	c,phys _applCmds >> 16
	call	__ladd##
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
;218     if (fstrcmp((char far *)cmdStr, cmdInfo->cmdName) == 0)  {
	.debug	# 218
	call	__farld4##
	push	bc
	push	de
	ld	hl,(ix+5)
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	call	_fstrcmp
	add	sp,8
	bool	hl
	jr	nz,@23
;219       printf("\r\n%ls\r\n", cmdInfo->descr);  return;  }
@24:
	.debug	< @24 @25
	.debug	# 219
@282:
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x6
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld4##
	push	bc
	push	de
	ld	de,word (phys @15)
	ld	c,phys @15 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
	jr	@3
@25:
	.debug	>
;220   }
@23:
@22:
	.debug	>
;221 
;222 }
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jr	@18
@19:
@17:
	.debug	>
@3:
	.debug	} @3 222

@2	equ	6
	ld	sp,ix
	pop	ix
	lret
@4	equ	8
;223 
;224 //-------------------------------------------------------------------------
;225 //  returns true if any of the arguments are one of the typical formats for
;226 //  asking for help on command syntax, or the number of arguments is less t
;227 //  the minimum needed by the command.
;228 //-------------------------------------------------------------------------
;229 bool showHelp(int minArgs, int argc, char **argv)
;230 {
$showHelp::
	.debug	G $showHelp 37 9
	.debug	{ $showHelp 37 229 @28 @27
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-4
	.debug	A minArgs 5 6
	.debug	A argc 7 6
	.debug	A argv 9 38
;231   int  i, j;
	.debug	L i -2 6
	.debug	L j -4 6
;232   static char  *helpStrs[] = { "?", "-?", "/?",
	.dseg
@29:
	.dw	@1+40
	.dw	@1+42
	.dw	@1+45
;233                                 "help", "-help", "/help", NULL };
	.dw	@1+48
	.dw	@1+53
	.dw	@1+59
	.dw	0
	.debug	S helpStrs @29 39
	.seg	FARCODE
;234 
;235   if (argc < minArgs)  { showDesc(argv[0]);  return true; }
	.debug	# 235
	ld	hl,(ix+7)
	ex	de,hl
	ld	hl,(ix+5)
	ex	de,hl
	call	__icmp##
	jr	c,@281
@31:
	.debug	< @31 @32
@32:
	.debug	>
;236 
;237   for (i=0; i<argc; ++i)
@33:
	.debug	< @33 @34
	.debug	# 237
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@35:
	ld	hl,(ix-2)
	ex	de,hl
	ld	hl,(ix+7)
	ex	de,hl
	call	__icmp##
	jr	nc,@36
;238     for (j=0; helpStrs[j]; ++j)
@38:
	.debug	< @38 @39
	.debug	# 238
	bool	hl
	ld	l,h
	ld	(ix-4),hl
@40:
	ld	hl,(ix-4)
	add	hl,hl
	ld	de,@29
	add	hl,de
	ld	hl,(hl)
	bool	hl
	jr	z,@41
;239       if (StriEq(argv[i], helpStrs[j]))  { showDesc(argv[0]);  return true;
	.debug	# 239
	ld	hl,(ix-4)
	add	hl,hl
	add	hl,de
	ld	hl,(hl)
	push	hl
	ld	hl,(ix-2)
	add	hl,hl
	ex	de,hl
	ld	hl,(ix+9)
	ex	de,hl
	add	hl,de
	ld	hl,(hl)
	push	hl
	call	_stricmp
	add	sp,4
	bool	hl
	jr	nz,@43
@44:
	.debug	< @44 @45
@281:
	ld	hl,(ix+9)
	ld	hl,(hl)
	push	hl
	lcall	$showDesc
	pop	hl
	ld	a,0x1
	jr	@27
@45:
	.debug	>
;240 
;241   return false;
@43:
	ld	hl,(ix-4)
	inc	hl
	ld	(ix-4),hl
	jr	@40
@41:
@39:
	.debug	>
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jr	@35
@36:
@34:
	.debug	>
	.debug	# 241
	xor	a,a
;242 }
@27:
	.debug	} @27 242

@26	equ	4
	ld	sp,ix
	pop	ix
	lret
@28	equ	6
;243 
;244 
;245 //-------------------------------------------------------------------------
;246 //  return info about specified file in a string of the form:
;247 //    <size> YYYY-MM-DD HH:MM
;248 //-------------------------------------------------------------------------
;249 int fileInfoStr(char *fileName, char *descr)
;250 {
$fileInfoStr::
	.debug	G $fileInfoStr 40 9
	.debug	{ $fileInfoStr 40 249 @48 @47
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-64
	.debug	A fileName 5 34
	.debug	A descr 7 34
;251   time_t  fileTime;
	.debug	L fileTime -4 9
;252   struct tm  tms;
	.debug	L tms -22 41
;253   struct stat  fsInfo;
	.debug	L fsInfo -64 42
;254 
;255 
;256   strcpy(descr, "       0 unknown");
	.debug	# 256
	ld	hl,@1+65
	push	hl
	ld	hl,(ix+7)
	push	hl
	call	_strcpy
	add	sp,4
;257 
;258   if (stat(fileName, &fsInfo))  return -1;
	.debug	# 258
	ld	hl,-64+@46
	add	hl,sp
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$stat
	add	sp,4
	bool	hl
	jr	z,@49
	ld	hl,0xffff
	jr	@47
;259 
;260   fileTime = fsInfo.st_mtime;  fileTime += (long)(timeZone * 3600);
@49:
	.debug	# 260
	ld	hl,(ix-30)
	ex	de,hl
	ld	hl,(ix-28)
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
	ld	hl,(_timeZone)
	ld	bc,0xe10
	ex	de,hl
	mul
	ld	de,bc
	ld	a,d
	rlca
	sbc	a,a
	ld	c,a
	ld	b,a
	push	bc
	push	de
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	call	__ladd##
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
;261   gmtime_r(&fileTime, &tms);
	.debug	# 261
	ld	hl,-22+@46
	add	hl,sp
	push	hl
	ld	hl,-2+@46
	add	hl,sp
	push	hl
	lcall	$gmtime_r
	add	sp,4
;262 
;263   sprintf(descr, "%8lu %04d-%02d-%02d %02d:%02d",
;264           (ulong)fsInfo.st_size,
;265           tms.tm_year+1900, tms.tm_mon+1, tms.tm_mday,
;266           tms.tm_hour, tms.tm_min);
	.debug	# 266
	ld	hl,(ix-20)
	push	hl
	ld	hl,(ix-18)
	push	hl
	ld	hl,(ix-16)
	push	hl
	ld	hl,(ix-14)
	inc	hl
	push	hl
	ld	hl,(ix-12)
	ld	de,0x76c
	add	hl,de
	push	hl
	ld	hl,(ix-42)
	ex	de,hl
	ld	hl,(ix-40)
	ld	bc,hl
	push	bc
	push	de
	ld	de,word (phys @15+8)
	ld	c,phys @15+8 >> 16
	push	bc
	push	de
	ld	hl,(ix+7)
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	lcall	$farsprintf
	add	sp,22
;267 
;268   return 0;
	.debug	# 268
	bool	hl
	ld	l,h
;269 }
@47:
	.debug	} @47 269

@46	equ	64
	ld	sp,ix
	pop	ix
	lret
@48	equ	66
;270 
;271 
;272 //-------------------------------------------------------------------------
;273 //  convert # of ms to a string of the format: ####ms, ####s, ####m, or ###
;274 //-------------------------------------------------------------------------
;275 char *fmtIdleTime(char *str, ulong idle)
;276 {
$fmtIdleTime::
	.debug	G $fmtIdleTime 43 9
	.debug	{ $fmtIdleTime 43 275 @52 @51
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A str 5 34
	.debug	A idle 7 9
;277   if (idle < 1000)
	.debug	# 277
	ld	hl,(ix+7)
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x3e8
	ld	bc,0
	call	__lsub##
	jr	nc,@53
;278     sprintf(str, "%4ums  ", (uint)idle);
	.debug	# 278
	ld	hl,(ix+7)
	push	hl
	ld	de,word (phys @15+38)
	ld	c,phys @15+38 >> 16
	push	bc
	push	de
	ld	hl,(ix+5)
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	lcall	$farsprintf
	add	sp,10
;279   else if (idle < 60000L)
	jp	@54
@53:
	.debug	# 279
	ld	hl,(ix+7)
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xea60
	ld	bc,0
	call	__lsub##
	jr	nc,@55
;280     sprintf(str, "%4us   ", (uint)(idle / 1000));
	.debug	# 280
	ld	hl,(ix+7)
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x3e8
	ld	bc,0
	call	__uldiv##
	push	de
	ld	de,word (phys @15+46)
	ld	c,phys @15+46 >> 16
	push	bc
	push	de
	ld	hl,(ix+5)
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	lcall	$farsprintf
	add	sp,10
;281   else if (idle < 3600000L)
	jr	@56
@55:
	.debug	# 281
	ld	hl,(ix+7)
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xee80
	ld	bc,0x36
	call	__lsub##
	jr	nc,@57
;282     sprintf(str, "%4um   ", (uint)(idle / 60000L));
	.debug	# 282
	ld	hl,(ix+7)
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xea60
	ld	bc,0
	call	__uldiv##
	push	de
	ld	de,word (phys @15+54)
	ld	c,phys @15+54 >> 16
	push	bc
	push	de
	ld	hl,(ix+5)
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	lcall	$farsprintf
	add	sp,10
;283   else
;284     sprintf(str, "%4uh   ", (uint)(idle / 3600000L));
	jr	@58
@57:
	.debug	# 284
	ld	hl,(ix+7)
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xee80
	ld	bc,0x36
	call	__uldiv##
	push	de
	ld	de,word (phys @15+62)
	ld	c,phys @15+62 >> 16
	push	bc
	push	de
	ld	hl,(ix+5)
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	lcall	$farsprintf
	add	sp,10
;285 
;286   return str;
@58:
@56:
@54:
	.debug	# 286
	ld	hl,(ix+5)
;287 }
@51:
	.debug	} @51 287

@50	equ	0
	pop	ix
	lret
@52	equ	2
;288 
;289 //-------------------------------------------------------------------------
;290 //  convert # of seconds to a string of the format HHHH:MM:SS
;291 //-------------------------------------------------------------------------
;292 char *fmtHMSUsed(char *str, ulong secs)
;293 {
$fmtHMSUsed::
	.debug	G $fmtHMSUsed 43 9
	.debug	{ $fmtHMSUsed 43 292 @61 @60
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-4
	.debug	A str 5 34
	.debug	A secs 7 9
;294   uint  hours, mins;
	.debug	L hours -2 7
	.debug	L mins -4 7
;295 
;296   hours = (uint)(secs / 3600);
	.debug	# 296
	ld	hl,(ix+7)
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xe10
	ld	bc,0
	call	__uldiv##
	ex	de,hl
	ld	(ix-2),hl
;297   mins = (uint)((secs % 3600) / 60);
	.debug	# 297
	ld	hl,(ix+7)
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xe10
	ld	bc,0
	call	__ulmod##
	push	bc
	push	de
	ld	de,0x3c
	ld	c,d
	ld	b,d
	call	__uldiv##
	ex	de,hl
	ld	(ix-4),hl
;298   secs %= 60;
	.debug	# 298
	ld	hl,(ix+7)
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x3c
	ld	c,d
	ld	b,d
	call	__ulmod##
	ld	hl,bc
	ld	(ix+9),hl
	ex	de,hl
	ld	(ix+7),hl
	ex	de,hl
;299 
;300   sprintf(str, "%4u:%02u:%02u ", hours, mins, (uint)secs);
	.debug	# 300
	ld	h,d
	ld	l,e
	push	hl
	ld	hl,(ix-4)
	push	hl
	ld	hl,(ix-2)
	push	hl
	ld	de,word (phys @15+70)
	ld	c,phys @15+70 >> 16
	push	bc
	push	de
	ld	hl,(ix+5)
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	lcall	$farsprintf
	add	sp,14
;301 
;302   return str;
	.debug	# 302
	ld	hl,(ix+5)
;303 }
@60:
	.debug	} @60 303

@59	equ	4
	ld	sp,ix
	pop	ix
	lret
@61	equ	6
;304 
;305 //-------------------------------------------------------------------------
;306 //  Write a hex-dump style representation of an array of bytes in to the
;307 //  provided string using the following format:
;308 //
;309 //  hhhhhh: xx xx xx xx xx xx xx xx xx xx xx xx xx xx xx xx   AAAAAAAAAAAAA
;310 //
;311 //  where hhhhhhhh   is the value of offset in hexidecimal format
;312 //        xx xx ..   are the bytes in buf, each shown as a 2-digit hex valu
;313 //        AAAAA...   are the chars in buf shown in ASCII (with a '.' shown
;314 //                   in places of any non-printable chars)
;315 //
;316 //  The result is in "printf-compatible" format, meaning that '%' character
;317 //  are changed in to "%%" for the ASCII part.
;318 //-------------------------------------------------------------------------
;319 char *fmtHexLine(char *str, ulong offset, char *buf, uchar count)
;320 {
$fmtHexLine::
	.debug	G $fmtHexLine 44 9
	.debug	{ $fmtHexLine 44 319 @64 @63
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-6
	.debug	A str 5 34
	.debug	A offset 7 9
	.debug	A buf 11 34
	.debug	A count 13 3
;321   char  *ptr;
	.debug	L ptr -2 34
;322   uchar  i;
	.debug	L i -3 3
;323   char  ch;
	.debug	L ch -4 3
;324   uint  remain;
	.debug	L remain -6 7
;325 
;326 
;327   ptr = str;  sprintf(ptr, "%06lX: ", offset);  ptr += 8;
	.debug	# 327
	ld	hl,(ix+5)
	ld	(ix-2),hl
	ld	hl,(ix+7)
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	push	bc
	push	de
	ld	de,word (phys @15+85)
	ld	c,phys @15+85 >> 16
	push	bc
	push	de
	ld	hl,(ix-2)
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	lcall	$farsprintf
	add	sp,12
	ld	hl,(ix-2)
	ld	de,0x8
	add	hl,de
	ld	(ix-2),hl
;328 
;329   for (i=0; i<count; ++i)  { sprintf(ptr, "%02X ", buf[i]);  ptr += 3; }
@65:
	.debug	< @65 @66
	.debug	# 329
	xor	a,a
	ld	(ix-3),a
@67:
	ld	a,(ix-3)
	ld	hl,(ix+13)
	sub	a,l
	jr	nc,@68
@70:
	.debug	< @70 @71
	bool	hl
	ld	l,(ix-3)
	ex	de,hl
	ld	hl,(ix+11)
	ex	de,hl
	add	hl,de
	ld	a,(hl)
	bool	hl
	ld	l,a
	push	hl
	ld	de,word (phys @15+93)
	ld	c,phys @15+93 >> 16
	push	bc
	push	de
	ld	hl,(ix-2)
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	lcall	$farsprintf
	add	sp,10
	ld	hl,(ix-2)
	inc	hl
	inc	hl
	inc	hl
	ld	(ix-2),hl
@71:
	.debug	>
;330   remain = (16 - (uint)i) * 3;
	ld	a,(ix-3)
	inc	a
	ld	(ix-3),a
	jr	@67
@68:
@66:
	.debug	>
	.debug	# 330
	bool	hl
	ld	l,(ix-3)
	ld	de,0x10
	ex	de,hl
	or	a,a
	sbc	hl,de
	ld	bc,0x3
	ex	de,hl
	mul
	ld	(ix-6),c
	ld	(ix-5),b
;331   while (remain)  { *ptr++ = ' ';  --remain; }
@72:
	.debug	# 331
	ld	hl,(ix-6)
	bool	hl
	jr	z,@73
@74:
	.debug	< @74 @75
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	dec	hl
	ld	a,0x20
	ld	(hl),a
	ld	hl,(ix-6)
	dec	hl
	ld	(ix-6),hl
@75:
	.debug	>
;332 
;333   strcpy(ptr, "   ");  ptr += 3;
	jr	@72
@73:
	.debug	# 333
	ld	hl,@1+82
	push	hl
	ld	hl,(ix-2)
	push	hl
	call	_strcpy
	add	sp,4
	ld	hl,(ix-2)
	inc	hl
	inc	hl
	inc	hl
	ld	(ix-2),hl
;334 
;335   for (i=0; i<count; ++i)  {
@76:
	.debug	< @76 @77
	.debug	# 335
	xor	a,a
	ld	(ix-3),a
@78:
	ld	a,(ix-3)
	ld	hl,(ix+13)
	sub	a,l
	jr	nc,@79
;336     ch = buf[i];
@81:
	.debug	< @81 @82
	.debug	# 336
	bool	hl
	ld	l,(ix-3)
	ex	de,hl
	ld	hl,(ix+11)
	ex	de,hl
	add	hl,de
	ld	a,(hl)
	ld	(ix-4),a
;337     if ((ch < ' ') OR (ch > '~'))  ch = '.';
	.debug	# 337
	sub	a,32
	jr	c,@83
	ld	a,(ix-4)
	sub	a,126
	jr	c,@84
	jr	z,@84
@83:
	ld	(ix-4),0x2e
;338     if (ch == '\%')  *ptr++ = '\%';
@84:
	.debug	# 338
	ld	a,(ix-4)
	sub	a,37
	jr	nz,@85
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	dec	hl
	ld	a,0x25
	ld	(hl),a
;339     *ptr++ = ch;
@85:
	.debug	# 339
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	dec	hl
	ld	a,(ix-4)
	ld	(hl),a
;340   }
@82:
	.debug	>
;341   *ptr = 0;
	ld	a,(ix-3)
	inc	a
	ld	(ix-3),a
	jr	@78
@79:
@77:
	.debug	>
	.debug	# 341
	xor	a,a
	ld	hl,(ix-2)
	ld	(hl),a
;342 
;343   return str;
	.debug	# 343
	ld	hl,(ix+5)
;344 }
@63:
	.debug	} @63 344

@62	equ	6
	ld	sp,ix
	pop	ix
	lret
@64	equ	8
;345 
;346 //-------------------------------------------------------------------------
;347 //  Copy any unread data from one fd to another.  Does not block if there i
;348 //  nothing to read for fromfd, but does block until any data read has been
;349 //  written to tofd.
;350 //
;351 //  returns # of bytes copied on success ( >= 0), < 0 if an error
;352 //-------------------------------------------------------------------------
;353 int  copyData(fd_t fromfd, int fromFlags, fd_t tofd, int toFlags,
;354               bool checkForETX, bool echo)
;355 {
$copyData::
	.debug	G $copyData 45 9
	.debug	{ $copyData 45 353 @88 @87
	ld	hl,-136
	call	__fent##
	.debug	A fromfd 5 6
	.debug	A fromFlags 7 6
	.debug	A tofd 9 6
	.debug	A toFlags 11 6
	.debug	A checkForETX 13 3
	.debug	A echo 15 3
;356   int  i, readCount, writeCount;
	.debug	L i -2 6
	.debug	L readCount -4 6
	.debug	L writeCount -6 6
;357   char  *ptr;
	.debug	L ptr -8 34
;358   char  buf[128];
	.debug	L buf -136 46
;359 
;360 
;361   fcntl(fromfd, F_SETFL, fromFlags | O_NONBLOCK);  // don't block on read
	.debug	# 361
	ld	hl,(ix+7)
	set	5,l
	push	hl
	ld	hl,0x4
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$fcntl
	add	sp,6
;362   readCount = read(fromfd, buf, sizeof(buf));
	.debug	# 362
	ld	hl,0x80
	push	hl
	ld	hl,-134+@86
	add	hl,sp
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$read
	add	sp,6
	ld	(ix-4),hl
;363   fcntl(fromfd, F_SETFL, fromFlags);  // restore flags
	.debug	# 363
	ld	hl,(ix+7)
	push	hl
	ld	hl,0x4
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$fcntl
	add	sp,6
;364 
;365   if (readCount < 0)  {
	.debug	# 365
	ld	hl,(ix-4)
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@89
;366     if (errno == EAGAIN)  return 0;
@90:
	.debug	< @90 @91
	.debug	# 366
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	hl,(hl)
	ld	e,0xb
	or	a,a
	sbc	hl,de
	jr	nz,@92
	bool	hl
	ld	l,h
	jp	@87
;367     printf("read error: %d\r\n", readCount);  return -1;
@92:
	.debug	# 367
	ld	hl,(ix-4)
	push	hl
	ld	de,word (phys @15+99)
	ld	c,phys @15+99 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
	ld	hl,0xffff
	jp	@87
;368   }
@91:
	.debug	>
;369 
;370   if (readCount == 0)  { printf("EOF\r\n");  return -2; }
@89:
	.debug	# 370
	ld	hl,(ix-4)
	bool	hl
	jr	nz,@93
@94:
	.debug	< @94 @95
	ld	de,word (phys @15+116)
	ld	c,phys @15+116 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	ld	hl,0xfffe
	jp	@87
@95:
	.debug	>
;371 
;372   if (checkForETX)  if (*buf == 0x03)  { printf("KILL\r\n");  return -3; }
@93:
	.debug	# 372
	ld	a,(ix+13)
	or	a,a
	jr	z,@96
	ld	hl,-136+@86
	add	hl,sp
	ld	a,(hl)
	sub	a,3
	jr	nz,@97
@98:
	.debug	< @98 @99
	ld	de,word (phys @15+122)
	ld	c,phys @15+122 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	ld	hl,0xfffd
	jp	@87
@99:
	.debug	>
;373 
;374   for (i=0; i<readCount; ++i)  buf[i] = (int)buf[i] & 0x7f;
@97:
@96:
@100:
	.debug	< @100 @101
	.debug	# 374
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@102:
	ld	hl,(ix-2)
	ex	de,hl
	ld	hl,(ix-4)
	ex	de,hl
	call	__icmp##
	jr	nc,@103
	ld	hl,(ix-2)
	ex	de,hl
	ld	hl,-136+@86
	add	hl,sp
	add	hl,de
	ld	a,(hl)
	bool	hl
	ld	l,a
	ld	de,0x7f
	and	hl,de
	ex	de,hl
	ld	hl,(ix-2)
	ex	de,hl
	ld	bc,hl
	ld	hl,-136+@86
	add	hl,sp
	add	hl,de
	ld	(hl),c
;375 
;376   if (echo)  for (ptr=buf,i=0; i<readCount; ++i,++ptr)  {
	ld	h,d
	ld	l,e
	inc	hl
	ld	(ix-2),hl
	jr	@102
@103:
@101:
	.debug	>
	.debug	# 376
	ld	a,(ix+15)
	or	a,a
	jr	z,@105
@106:
	.debug	< @106 @107
	ld	hl,-136+@86
	add	hl,sp
	ld	(ix-8),hl
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@108:
	ld	hl,(ix-2)
	ex	de,hl
	ld	hl,(ix-4)
	ex	de,hl
	call	__icmp##
	jr	nc,@109
;377     write(1, ptr, 1);
@111:
	.debug	< @111 @112
	.debug	# 377
	ld	hl,0x1
	push	hl
	ld	hl,(ix-8)
	push	hl
	ld	hl,0x1
	push	hl
	lcall	$write
	add	sp,6
;378     if (*ptr == 0x0D)  write(1, "\012", 1);
	.debug	# 378
	ld	hl,(ix-8)
	ld	a,(hl)
	sub	a,13
	jr	nz,@113
	ld	hl,0x1
	push	hl
	ld	hl,@1+86
	push	hl
	ld	hl,0x1
	push	hl
	lcall	$write
	add	sp,6
;379   }
@113:
@112:
	.debug	>
;380 
;381   fcntl(tofd, F_SETFL, toFlags & (~O_NONBLOCK));  // block on write
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	ld	hl,(ix-8)
	inc	hl
	ld	(ix-8),hl
	jr	@108
@109:
@107:
	.debug	>
@105:
	.debug	# 381
	ld	hl,(ix+11)
	res	5,l
	push	hl
	ld	hl,0x4
	push	hl
	ld	hl,(ix+9)
	push	hl
	lcall	$fcntl
	add	sp,6
;382   writeCount = write(tofd, buf, readCount);
	.debug	# 382
	ld	hl,(ix-4)
	push	hl
	ld	hl,-134+@86
	add	hl,sp
	push	hl
	ld	hl,(ix+9)
	push	hl
	lcall	$write
	add	sp,6
	ld	(ix-6),hl
;383   fcntl(tofd, F_SETFL, toFlags);  // restore flags
	.debug	# 383
	ld	hl,(ix+11)
	push	hl
	ld	hl,0x4
	push	hl
	ld	hl,(ix+9)
	push	hl
	lcall	$fcntl
	add	sp,6
;384 
;385   if (writeCount < readCount)  { printf("write error\r\n");  return -4; }
	.debug	# 385
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ex	de,hl
	call	__icmp##
	jr	nc,@114
@115:
	.debug	< @115 @116
	ld	de,word (phys @15+129)
	ld	c,phys @15+129 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	ld	hl,0xfffc
	jr	@87
@116:
	.debug	>
;386 
;387   return writeCount;
@114:
	.debug	# 387
	ld	hl,(ix-6)
;388 }
@87:
	.debug	} @87 388

@86	equ	136
	ld	sp,ix
	pop	ix
	lret
@88	equ	138
;389 
;390 //-------------------------------------------------------------------------
;391 #define  EGUMin(ui)   ( (ci->minRaw(ui) - ci->offsets[ui]) * ci->gains[ui] 
;392 #define  EGUMax(ui)   ( (ci->maxRaw(ui) - ci->offsets[ui]) * ci->gains[ui] 
;393 
;394 const char far CalibPrompt[] = {
;395     "\r\nApply setting for '%.24s' test point #%u"
;396     "\r\nEnter known/measured value in %.16s: (default %s): " };
	.seg	FARCONST
_CalibPrompt::
	.db	13,10,"Apply setting for '%.24s' test point #%u",13,10,"Enter known/measured value in %.16s: (de"
	.db	"fault %s): ",0
	.debug	G _CalibPrompt 47 8
;397 
;398 
;399 //-------------------------------------------------------------------------
;400 //  function to show the Gain, Offset, and Range for an analog signal
;401 //-------------------------------------------------------------------------
;402 void showGainOffsetRange(uint ui, CalibInfo far *ci,
;403                          char *buf, bool showHeader)
;404 {
	.seg	FARCODE
$showGainOffsetRange::
	.debug	G $showGainOffsetRange 48 9
	.debug	{ $showGainOffsetRange 48 402 @119 @118
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-12
	.debug	A ui 5 7
	.debug	A ci 7 49
	.debug	A buf 11 34
	.debug	A showHeader 13 3
;405   float  eguMin, eguMax, hold;
	.debug	L eguMin -4 10
	.debug	L eguMax -8 10
	.debug	L hold -12 10
;406 
;407 
;408   if (showHeader)  printf("\r\n"
	.debug	# 408
	ld	a,(ix+13)
	or	a,a
	jr	z,@120
;409 "       ----Gain----  ---Offset---  ------- Range -------  ------Name------
	ld	de,word (phys @15+143)
	ld	c,phys @15+143 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;410 //####:  -##.####E-##  -##.####E-##  -##.##E-## -##.##E-##  ###############
;411 
;412   eguMin = EGUMin(ui);  eguMax = EGUMax(ui);
@120:
	.debug	# 412
	ld	hl,(ix+5)
	push	hl
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	ld	hl,(ix+7)
	ex	de,hl
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	call	__callde##
	pop	hl
	push	bc
	push	de
	ld	hl,(ix+7)
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x18
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fsub##
	push	bc
	push	de
	ld	hl,(ix+7)
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x16
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fmlt##
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
	ld	hl,(ix+5)
	push	hl
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	ld	hl,(ix+7)
	ex	de,hl
	push	bc
	push	de
	ld	de,0x4
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	call	__callde##
	pop	hl
	push	bc
	push	de
	ld	hl,(ix+7)
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x18
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fsub##
	push	bc
	push	de
	ld	hl,(ix+7)
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x16
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fmlt##
	ld	hl,bc
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
;413   if (eguMin > eguMax)  { hold = eguMin;  eguMin = eguMax;  eguMax = hold; 
	.debug	# 413
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	call	__fsub##
	jp	m,@121
	jr	z,@121
@122:
	.debug	< @122 @123
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	(ix-10),hl
	ex	de,hl
	ld	(ix-12),hl
	ex	de,hl
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	bc,hl
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
@123:
	.debug	>
;414 
;415   printf("%4u:  %s  %s  %s %s  %.24s\r\n", ui,
@121:
;416           Engineering(ci->gains[ui], 6, buf),
;417           Engineering(ci->offsets[ui], 6, buf+16),
;418           Engineering(eguMin, 4, buf+32),
;419           Engineering(eguMax, 4, buf+48),
;420           ci->getName(ui, buf+64)
;421         );
	.debug	# 421
	ld	hl,(ix+11)
	ld	de,0x40
	add	hl,de
	push	hl
	ld	hl,(ix+5)
	push	hl
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	ld	hl,(ix+7)
	ex	de,hl
	push	bc
	push	de
	ld	de,0xc
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	call	__callde##
	add	sp,4
	push	hl
	ld	hl,(ix+11)
	ld	de,0x30
	add	hl,de
	push	hl
	ld	hl,0x4
	push	hl
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	push	bc
	push	de
	lcall	$Engineering
	add	sp,8
	push	hl
	ld	hl,(ix+11)
	ld	de,0x20
	add	hl,de
	push	hl
	ld	hl,0x4
	push	hl
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	lcall	$Engineering
	add	sp,8
	push	hl
	ld	hl,(ix+11)
	ld	de,0x10
	add	hl,de
	push	hl
	ld	hl,0x6
	push	hl
	ld	hl,(ix+7)
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x18
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	lcall	$Engineering
	add	sp,8
	push	hl
	ld	hl,(ix+11)
	push	hl
	ld	hl,0x6
	push	hl
	ld	hl,(ix+7)
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x16
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	lcall	$Engineering
	add	sp,8
	push	hl
	ld	hl,(ix+5)
	push	hl
	ld	de,word (phys @15+222)
	ld	c,phys @15+222 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,16
;422 }
@118:
	.debug	} @118 422

@117	equ	12
	ld	sp,ix
	pop	ix
	lret
@119	equ	14
;423 
;424 
;425 //-------------------------------------------------------------------------
;426 //  Prompt user for actual (externally measured) engineering units for 2 te
;427 //  points for a signal and update the gain and offset based on the 2 point
;428 //-------------------------------------------------------------------------
;429 bool calibValue(CalibInfo far *ci, uint ui, char *temp, float egu1, float e
;430 {
$calibValue::
	.debug	G $calibValue 50 9
	.debug	{ $calibValue 50 429 @126 @125
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-16
	.debug	A ci 5 49
	.debug	A ui 9 7
	.debug	A temp 11 34
	.debug	A egu1 13 10
	.debug	A egu2 17 10
;431   float  raw1, raw2, calibLow, calibHigh;
	.debug	L raw1 -4 10
	.debug	L raw2 -8 10
	.debug	L calibLow -12 10
	.debug	L calibHigh -16 10
;432   static float  lastCalibLow, lastCalibHigh, lastegu1, lastegu2;
	.bseg
@127:
	.ds	4
	.debug	S lastCalibLow @127 10
	.seg	FARCODE
	.bseg
@128:
	.ds	4
	.debug	S lastCalibHigh @128 10
	.seg	FARCODE
	.bseg
@129:
	.ds	4
	.debug	S lastegu1 @129 10
	.seg	FARCODE
	.bseg
@130:
	.ds	4
	.debug	S lastegu2 @130 10
	.seg	FARCODE
;433 
;434 
;435   if (egu1 == egu2)  {
	.debug	# 435
	ld	hl,(ix+13)
	ex	de,hl
	ld	hl,(ix+15)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix+17)
	ex	de,hl
	ld	hl,(ix+19)
	ld	bc,hl
	call	__fequ##
	jp	nz,@131
;436     ci->calibPoints(ui, &calibLow, &calibHigh);
@132:
	.debug	< @132 @133
	.debug	# 436
	ld	hl,-16+@124
	add	hl,sp
	push	hl
	ld	hl,-10+@124
	add	hl,sp
	push	hl
	ld	hl,(ix+9)
	push	hl
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	ld	hl,(ix+5)
	ex	de,hl
	push	bc
	push	de
	ld	de,0x8
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	call	__callde##
	add	sp,6
;437     egu1 = (calibLow == lastCalibLow) ? lastegu1 : calibLow;
	.debug	# 437
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	bc,hl
	push	bc
	push	de
	ld	de,(@127)
	ld	bc,(@127+2)
	call	__fequ##
	jr	nz,@134
	ld	de,(@129)
	ld	bc,(@129+2)
	jr	@135
@134:
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	bc,hl
@135:
	ld	hl,bc
	ld	(ix+15),hl
	ex	de,hl
	ld	(ix+13),hl
	ex	de,hl
;438     egu2 = (calibHigh == lastCalibHigh) ? lastegu2 : calibHigh;
	.debug	# 438
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	push	bc
	push	de
	ld	de,(@128)
	ld	bc,(@128+2)
	call	__fequ##
	jr	nz,@136
	ld	de,(@130)
	ld	bc,(@130+2)
	jr	@137
@136:
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
@137:
	ld	hl,bc
	ld	(ix+19),hl
	ex	de,hl
	ld	(ix+17),hl
	ex	de,hl
;439   }
@133:
	.debug	>
;440 
;441 
;442 #define  ForceValue    false
;443 #define  ClearForced   true
;444 
;445 //--- test point 1 ---
;446   if (ci->setOutput)  ci->setOutput(ui, egu1, ForceValue);
@131:
	.debug	# 446
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x12
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ld	a,e
	or	a,d
	jr	z,@138
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix+13)
	ex	de,hl
	ld	hl,(ix+15)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix+9)
	push	hl
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	ld	hl,(ix+5)
	ex	de,hl
	push	bc
	push	de
	ld	de,0x12
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	call	__callde##
	add	sp,8
;447 
;448   printf(CalibPrompt, ci->getName(ui, temp), 1,
@138:
;449          ci->units(ui, temp+32), Engineering(egu1, 4, temp+64) );
	.debug	# 449
	ld	hl,(ix+11)
	ld	de,0x40
	add	hl,de
	push	hl
	ld	hl,0x4
	push	hl
	ld	hl,(ix+13)
	ex	de,hl
	ld	hl,(ix+15)
	ld	bc,hl
	push	bc
	push	de
	lcall	$Engineering
	add	sp,8
	push	hl
	ld	hl,(ix+11)
	ld	de,0x20
	add	hl,de
	push	hl
	ld	hl,(ix+9)
	push	hl
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	ld	hl,(ix+5)
	ex	de,hl
	push	bc
	push	de
	ld	de,0xa
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	call	__callde##
	add	sp,4
	push	hl
	ld	hl,0x1
	push	hl
	ld	hl,(ix+11)
	push	hl
	ld	hl,(ix+9)
	push	hl
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	ld	hl,(ix+5)
	ex	de,hl
	push	bc
	push	de
	ld	de,0xc
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	call	__callde##
	add	sp,4
	push	hl
	ld	de,word (phys _CalibPrompt)
	ld	c,phys _CalibPrompt >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,12
;450   GETS(temp);  raw1 = ci->getRaw(ui);
	.debug	# 450
	bool	hl
	ld	l,h
	push	hl
	push	hl
	push	hl
	ld	hl,(ix+11)
	push	hl
	lcall	$Gets
	add	sp,8
	ld	hl,(ix+9)
	push	hl
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	ld	hl,(ix+5)
	ex	de,hl
	call	__farld2##
	call	__callde##
	pop	hl
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
;451   if (*temp)  egu1 = atof(temp);
	.debug	# 451
	ld	hl,(ix+11)
	ld	a,(hl)
	or	a,a
	jr	z,@139
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix+11)
	push	hl
	call	_strtod
	add	sp,4
	ld	hl,bc
	ld	(ix+15),hl
	ex	de,hl
	ld	(ix+13),hl
	ex	de,hl
;452 
;453 
;454 //--- test point 2 ---
;455   if (ci->setOutput)  ci->setOutput(ui, egu2, ForceValue);
@139:
	.debug	# 455
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x12
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ld	a,e
	or	a,d
	jr	z,@140
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix+17)
	ex	de,hl
	ld	hl,(ix+19)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix+9)
	push	hl
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	ld	hl,(ix+5)
	ex	de,hl
	push	bc
	push	de
	ld	de,0x12
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	call	__callde##
	add	sp,8
;456 
;457   printf(CalibPrompt,  ci->getName(ui, temp), 2,
@140:
;458          ci->units(ui, temp+32), Engineering(egu2, 4, temp+64) );
	.debug	# 458
	ld	hl,(ix+11)
	ld	de,0x40
	add	hl,de
	push	hl
	ld	hl,0x4
	push	hl
	ld	hl,(ix+17)
	ex	de,hl
	ld	hl,(ix+19)
	ld	bc,hl
	push	bc
	push	de
	lcall	$Engineering
	add	sp,8
	push	hl
	ld	hl,(ix+11)
	ld	de,0x20
	add	hl,de
	push	hl
	ld	hl,(ix+9)
	push	hl
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	ld	hl,(ix+5)
	ex	de,hl
	push	bc
	push	de
	ld	de,0xa
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	call	__callde##
	add	sp,4
	push	hl
	ld	hl,0x2
	push	hl
	ld	hl,(ix+11)
	push	hl
	ld	hl,(ix+9)
	push	hl
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	ld	hl,(ix+5)
	ex	de,hl
	push	bc
	push	de
	ld	de,0xc
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	call	__callde##
	add	sp,4
	push	hl
	ld	de,word (phys _CalibPrompt)
	ld	c,phys _CalibPrompt >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,12
;459   GETS(temp);  raw2 = ci->getRaw(ui);
	.debug	# 459
	bool	hl
	ld	l,h
	push	hl
	push	hl
	push	hl
	ld	hl,(ix+11)
	push	hl
	lcall	$Gets
	add	sp,8
	ld	hl,(ix+9)
	push	hl
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	ld	hl,(ix+5)
	ex	de,hl
	call	__farld2##
	call	__callde##
	pop	hl
	ld	hl,bc
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
;460   if (*temp)  egu2 = atof(temp);
	.debug	# 460
	ld	hl,(ix+11)
	ld	a,(hl)
	or	a,a
	jr	z,@141
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix+11)
	push	hl
	call	_strtod
	add	sp,4
	ld	hl,bc
	ld	(ix+19),hl
	ex	de,hl
	ld	(ix+17),hl
	ex	de,hl
;461 
;462 
;463   if (ci->setOutput)  ci->setOutput(ui, 0.0, ClearForced);
@141:
	.debug	# 463
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x12
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ld	a,e
	or	a,d
	jr	z,@142
	ld	hl,0x1
	push	hl
	ld	d,h
	ld	e,h
	ld	c,e
	ld	b,e
	push	bc
	push	de
	ld	hl,(ix+9)
	push	hl
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	ld	hl,(ix+5)
	ex	de,hl
	push	bc
	push	de
	ld	de,0x12
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	call	__callde##
	add	sp,8
;464 
;465 //printf("raw: %s:%s   EGU: %s:%s\r\n",  //tdebug
;466 //       Engineering(raw1, 6, temp), Engineering(raw2, 6, temp+16),
;467 //       Engineering(egu1, 6, temp+32), Engineering(egu2, 6, temp+48) );
;468 
;469   if ((raw1 == raw2) OR (egu2 == egu1))  {
@142:
	.debug	# 469
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	call	__fequ##
	jr	z,@143
	ld	hl,(ix+17)
	ex	de,hl
	ld	hl,(ix+19)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix+13)
	ex	de,hl
	ld	hl,(ix+15)
	ld	bc,hl
	call	__fequ##
	jr	nz,@144
@143:
;470     printf("\r\nUnusable calibration data\r\n");  return false; }
@145:
	.debug	< @145 @146
	.debug	# 470
	ld	de,word (phys @15+251)
	ld	c,phys @15+251 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	xor	a,a
	jp	@125
@146:
	.debug	>
;471 
;472 
;473   ci->gains[ui] = (egu2 - egu1) / (raw2 - raw1);
@144:
	.debug	# 473
	ld	hl,(ix+17)
	ex	de,hl
	ld	hl,(ix+19)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix+13)
	ex	de,hl
	ld	hl,(ix+15)
	ld	bc,hl
	call	__fsub##
	push	bc
	push	de
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	call	__fsub##
	call	__fdiv##
	push	bc
	push	de
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x16
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ld	hl,(ix+9)
	add	hl,hl
	add	hl,hl
	add	hl,de
	pop	de
	pop	bc
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;474   ci->offsets[ui] = raw1 - egu1/ci->gains[ui];
	.debug	# 474
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x16
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ld	hl,(ix+9)
	add	hl,hl
	add	hl,hl
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,(ix+13)
	ex	de,hl
	ld	hl,(ix+15)
	ld	bc,hl
	call	__fdivr##
	push	bc
	push	de
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	call	__fsubr##
	push	bc
	push	de
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x18
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ld	hl,(ix+9)
	add	hl,hl
	add	hl,hl
	add	hl,de
	pop	de
	pop	bc
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;475 
;476 //  showGainOffsetRange(ui, ci, temp, true);  // now done by caller
;477 
;478   lastegu1 = egu1;  lastCalibLow = calibLow;
	.debug	# 478
	ld	hl,(ix+13)
	ex	de,hl
	ld	hl,(ix+15)
	ld	bc,hl
	ld	(@129),de
	ld	(@129+2),bc
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	bc,hl
	ld	(@127),de
	ld	(@127+2),bc
;479   lastegu2 = egu2;  lastCalibHigh = calibHigh;
	.debug	# 479
	ld	hl,(ix+17)
	ex	de,hl
	ld	hl,(ix+19)
	ld	bc,hl
	ld	(@130),de
	ld	(@130+2),bc
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	ld	(@128),de
	ld	(@128+2),bc
;480 
;481   return true;
	.debug	# 481
	ld	a,0x1
;482 }
@125:
	.debug	} @125 482

@124	equ	16
	ld	sp,ix
	pop	ix
	lret
@126	equ	18
;483 
;484 
;485 //-------------------------------------------------------------------------
;486 //  function to manage calibration information
;487 //-------------------------------------------------------------------------
;488 void calibrate(uint argc, char **argv, CalibInfo far *ci)
;489 {
$calibrate::
	.debug	G $calibrate 51 9
	.debug	{ $calibrate 51 488 @149 @148
	ld	hl,-184
	call	__fent##
	.debug	A argc 5 7
	.debug	A argv 7 38
	.debug	A ci 9 49
;490   char  ch;
	.debug	L ch -1 3
;491   uint  ui, ut, hdwIdx, numValues, interval, numSamples;
	.debug	L ui -3 7
	.debug	L ut -5 7
	.debug	L hdwIdx -7 7
	.debug	L numValues -9 7
	.debug	L interval -11 7
	.debug	L numSamples -13 7
;492   bool  allValues, foundMatch, chgsMade, useDefaults, setZeroOffset, setRan
	.debug	L allValues -14 3
	.debug	L foundMatch -15 3
	.debug	L chgsMade -16 3
	.debug	L useDefaults -17 3
	.debug	L setZeroOffset -18 3
	.debug	L setRange -19 3
;493         updatedCalib;
	.debug	L updatedCalib -20 3
;494   float  gain, offset, minValue, maxValue, minRaw, maxRaw, quietMode,
	.debug	L gain -24 10
	.debug	L offset -28 10
	.debug	L minValue -32 10
	.debug	L maxValue -36 10
	.debug	L minRaw -40 10
	.debug	L maxRaw -44 10
	.debug	L quietMode -48 10
;495          egu1, egu2;
	.debug	L egu1 -52 10
	.debug	L egu2 -56 10
;496   char  temp[128];
	.debug	L temp -184 46
;497 
;498 
;499 
;500   quietMode = StriEq(argv[argc-1], "-quiet");
	.debug	# 500
	ld	hl,@1+88
	push	hl
	ld	hl,(ix+5)
	dec	hl
	add	hl,hl
	ex	de,hl
	ld	hl,(ix+7)
	ex	de,hl
	add	hl,de
	ld	hl,(hl)
	push	hl
	call	_stricmp
	add	sp,4
	bool	hl
	ld	l,h
	jr	nz,@150
	inc	l
@150:
	ex	de,hl
	call	__uitof##
	ld	hl,bc
	ld	(ix-46),hl
	ex	de,hl
	ld	(ix-48),hl
	ex	de,hl
;501   if (quietMode)  --argc;
	.debug	# 501
	ld	a,b
	and	a,7Fh
	or	a,c
	or	a,d
	or	a,e
	jr	z,@151
	ld	hl,(ix+5)
	dec	hl
	ld	(ix+5),hl
;502 
;503   if (showHelp(2, argc, argv))  {
@151:
	.debug	# 503
	ld	hl,(ix+7)
	push	hl
	ld	hl,(ix+5)
	push	hl
	ld	hl,0x2
	push	hl
	lcall	$showHelp
	add	sp,6
	or	a,a
	jr	z,@152
;504     printf("\nusage: %s ...\r\n", argv[0]);
@153:
	.debug	< @153 @154
	.debug	# 504
	ld	hl,(ix+7)
	ld	hl,(hl)
	push	hl
	ld	de,word (phys @15+281)
	ld	c,phys @15+281 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;505     printf("     all|<name>|#\r\n"
;506            "     all|<name>|# defaults\r\n"
;507            "     all|<name>|# range <min> <max>\r\n"
;508            "     all|<name>|# <gain> <offset>\r\n");
	.debug	# 505
	ld	de,word (phys @15+298)
	ld	c,phys @15+298 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;509     if (ci->setOutput)  printf(
	.debug	# 509
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x12
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ld	a,e
	or	a,d
	jr	z,@155
;510            "     all|<name>|# setpoints <point1> <point2>\r\n");
	.debug	# 510
	ld	de,word (phys @15+418)
	ld	c,phys @15+418 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;511     printf("     all|<name>|# zero [interval [#samples]]\r\n"
@155:
;512            "     dump\r\n"
;513            "     show\r\n"
;514            "     reload\r\n"
;515            "     save\r\n"
;516            "  (-quiet at end will skip prompts)\r\n"
;517           );
	.debug	# 511
	ld	de,word (phys @15+466)
	ld	c,phys @15+466 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;518     Exit(-1);
	.debug	# 518
	ld	hl,0xffff
	push	hl
	lcall	$Exit
	pop	hl
;519   }
@154:
	.debug	>
;520 
;521 
;522   numValues = *(ci->numValues);   egu1 = egu2 = 0.0;
@152:
	.debug	# 522
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x1a
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ex	de,hl
	ld	hl,(hl)
	ld	(ix-9),hl
	ld	de,0
	ld	c,e
	ld	b,e
	ld	hl,bc
	ld	(ix-54),hl
	ex	de,hl
	ld	(ix-56),hl
	ex	de,hl
	ld	(ix-50),hl
	ex	de,hl
	ld	(ix-52),hl
	ex	de,hl
;523 
;524 //--- reload the data from a file ---
;525   if (argc == 2)  if (StriEq(argv[1], "reload"))  {
	.debug	# 525
	ld	hl,(ix+5)
	inc	e
	inc	e
	or	a,a
	sbc	hl,de
	jr	nz,@156
	ld	hl,@1+95
	push	hl
	ld	hl,(ix+7)
	inc	hl
	inc	hl
	ld	hl,(hl)
	push	hl
	call	_stricmp
	add	sp,4
	bool	hl
	jr	nz,@157
;526     loadParams(temp, sizeof(temp), ci->paramFile, false);   Exit(0);  }
@158:
	.debug	< @158 @159
	.debug	# 526
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x14
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	push	de
	ld	hl,0x80
	push	hl
	ld	hl,-178+@147
	add	hl,sp
	push	hl
	lcall	$loadParams
	add	sp,8
	bool	hl
	ld	l,h
	push	hl
	lcall	$Exit
	pop	hl
@159:
	.debug	>
;527 
;528 
;529 //--- save the data to a file ---
;530   if (argc == 2)  if (StriEq(argv[1], "save"))  {
@157:
@156:
	.debug	# 530
	ld	hl,(ix+5)
	ld	de,0x2
	or	a,a
	sbc	hl,de
	jr	nz,@160
	ld	hl,@1+102
	push	hl
	ld	hl,(ix+7)
	inc	hl
	inc	hl
	ld	hl,(hl)
	push	hl
	call	_stricmp
	add	sp,4
	bool	hl
	jr	nz,@161
;531     saveParams(temp, sizeof(temp), ci->paramFile, ForceFlush);  Exit(0);  }
@162:
	.debug	< @162 @163
	.debug	# 531
	ld	l,0x1
	push	hl
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x14
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	push	de
	ld	hl,0x80
	push	hl
	ld	hl,-178+@147
	add	hl,sp
	push	hl
	lcall	$saveParams
	add	sp,8
	bool	hl
	ld	l,h
	push	hl
	lcall	$Exit
	pop	hl
@163:
	.debug	>
;532 
;533 
;534 //--- dump in format that can be run as commands ---
;535   if (argc == 2)  if (StriEq(argv[1], "dump"))  {
@161:
@160:
	.debug	# 535
	ld	hl,(ix+5)
	ld	de,0x2
	or	a,a
	sbc	hl,de
	jp	nz,@164
	ld	hl,@1+107
	push	hl
	ld	hl,(ix+7)
	inc	hl
	inc	hl
	ld	hl,(hl)
	push	hl
	call	_stricmp
	add	sp,4
	bool	hl
	jp	nz,@165
;536     for (ui=0; ui<numValues; ++ui)  {
@166:
	.debug	< @166 @167
@168:
	.debug	< @168 @169
	.debug	# 536
	bool	hl
	ld	l,h
	ld	(ix-3),hl
@170:
	ld	hl,(ix-3)
	ex	de,hl
	ld	hl,(ix-9)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jp	nc,@171
;537       printf("%s %2d %s %s -quiet\r\n", argv[0], ui,
@173:
	.debug	< @173 @174
;538               Engineering(ci->gains[ui], 7, temp),
;539               Engineering(ci->offsets[ui], 7, temp+16)
;540             );
	.debug	# 540
	ld	hl,-168+@147
	add	hl,sp
	push	hl
	ld	hl,0x7
	push	hl
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x18
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ld	hl,(ix-3)
	add	hl,hl
	add	hl,hl
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	lcall	$Engineering
	add	sp,8
	push	hl
	ld	hl,-182+@147
	add	hl,sp
	push	hl
	ld	hl,0x7
	push	hl
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x16
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ld	hl,(ix-3)
	add	hl,hl
	add	hl,hl
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	lcall	$Engineering
	add	sp,8
	push	hl
	ld	hl,(ix-3)
	push	hl
	ld	hl,(ix+7)
	ld	hl,(hl)
	push	hl
	ld	de,word (phys @15+596)
	ld	c,phys @15+596 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,12
;541     }
@174:
	.debug	>
;542     printf("\r\n");  Exit(0);
	ld	hl,(ix-3)
	inc	hl
	ld	(ix-3),hl
	jp	@170
@171:
@169:
	.debug	>
	.debug	# 542
	ld	de,word (phys @15+5)
	ld	c,phys @15+5 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	bool	hl
	ld	l,h
	push	hl
	lcall	$Exit
	pop	hl
;543   }
@167:
	.debug	>
;544 
;545 //--- show the data ---
;546   if (argc == 2)  if (StriEq(argv[1], "show"))  {
@165:
@164:
	.debug	# 546
	ld	hl,(ix+5)
	ld	de,0x2
	or	a,a
	sbc	hl,de
	jp	nz,@175
	ld	hl,@1+112
	push	hl
	ld	hl,(ix+7)
	inc	hl
	inc	hl
	ld	hl,(hl)
	push	hl
	call	_stricmp
	add	sp,4
	bool	hl
	jp	nz,@176
;547     printf("\r\n%s calibration data:\r\n", ci->setDescr);
@177:
	.debug	< @177 @178
	.debug	# 547
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x1c
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	push	de
	ld	de,word (phys @15+618)
	ld	c,phys @15+618 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;548     for (ui=0; ui<128; ++ui)  {
@179:
	.debug	< @179 @180
	.debug	# 548
	bool	hl
	ld	l,h
	ld	(ix-3),hl
@181:
	ld	hl,(ix-3)
	ld	de,0x80
	or	a,a
	sbc	hl,de
	jr	nc,@182
;549       if ((hdwIdx = (ci->order)(ui)) >= numValues)  continue;
@184:
	.debug	< @184 @185
	.debug	# 549
	ld	hl,(ix-3)
	push	hl
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	ld	hl,(ix+9)
	ex	de,hl
	push	bc
	push	de
	ld	de,0xe
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	call	__callde##
	pop	de
	ld	(ix-7),hl
	ex	de,hl
	ld	hl,(ix-9)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	nc,@183
;550       showGainOffsetRange(hdwIdx, ci, temp, !ui);
	.debug	# 550
	ld	hl,(ix-3)
	bool	hl
	ld	l,h
	jr	nz,@187
	inc	l
@187:
	push	hl
	ld	hl,-182+@147
	add	hl,sp
	push	hl
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-7)
	push	hl
	lcall	$showGainOffsetRange
	add	sp,10
;551     }
@185:
	.debug	>
;552     printf("\r\n");  Exit(0);
@183:
	ld	hl,(ix-3)
	inc	hl
	ld	(ix-3),hl
	jr	@181
@182:
@180:
	.debug	>
	.debug	# 552
	ld	de,word (phys @15+5)
	ld	c,phys @15+5 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	bool	hl
	ld	l,h
	push	hl
	lcall	$Exit
	pop	hl
;553   }
@178:
	.debug	>
;554 
;555 
;556   if (argc < 2)  Exit(-1);
@176:
@175:
	.debug	# 556
	ld	hl,(ix+5)
	ld	de,0x2
	or	a,a
	sbc	hl,de
	jr	nc,@188
	ld	hl,0xffff
	push	hl
	lcall	$Exit
	pop	hl
;557 
;558 
;559 //--- set calibration values for one or more of the I/O signals ---
;560   useDefaults = setZeroOffset = setRange = false;
@188:
	.debug	# 560
	xor	a,a
	ld	(ix-19),a
	ld	(ix-18),a
	ld	(ix-17),a
;561   gain = 0.0;
	.debug	# 561
	ld	de,0
	ld	c,e
	ld	b,e
	ld	hl,bc
	ld	(ix-22),hl
	ex	de,hl
	ld	(ix-24),hl
	ex	de,hl
;562   allValues = (strcmp(argv[1], "all") == 0);
	.debug	# 562
	ld	hl,@1+117
	push	hl
	ld	hl,(ix+7)
	inc	hl
	inc	hl
	ld	hl,(hl)
	push	hl
	call	_strcmp
	add	sp,4
	bool	hl
	ld	l,h
	jr	nz,@189
	inc	l
@189:
	ld	(ix-14),l
;563 
;564   if (argc > 2)  if (StriEq(argv[2], "range"))  {
	.debug	# 564
	ld	hl,(ix+5)
	ld	de,0x2
	or	a,a
	sbc	hl,de
	jp	c,@190
	jp	z,@190
	ld	hl,@1+121
	push	hl
	ld	hl,(ix+7)
	ld	e,0x4
	add	hl,de
	ld	hl,(hl)
	push	hl
	call	_stricmp
	add	sp,4
	bool	hl
	jp	nz,@191
;565     if (argc < 5)  { printf("\r\nInvalid range command\r\n");  Exit(-1); }
@192:
	.debug	< @192 @193
	.debug	# 565
	ld	hl,(ix+5)
	ld	de,0x5
	or	a,a
	sbc	hl,de
	jr	nc,@194
@195:
	.debug	< @195 @196
	ld	de,word (phys @15+643)
	ld	c,phys @15+643 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	ld	hl,0xffff
	push	hl
	lcall	$Exit
	pop	hl
@196:
	.debug	>
;566     minValue = atof(argv[3]);  maxValue = atof(argv[4]);
@194:
	.debug	# 566
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix+7)
	ld	de,0x6
	add	hl,de
	ld	hl,(hl)
	push	hl
	call	_strtod
	add	sp,4
	ld	hl,bc
	ld	(ix-30),hl
	ex	de,hl
	ld	(ix-32),hl
	ex	de,hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix+7)
	ld	de,0x8
	add	hl,de
	ld	hl,(hl)
	push	hl
	call	_strtod
	add	sp,4
	ld	hl,bc
	ld	(ix-34),hl
	ex	de,hl
	ld	(ix-36),hl
	ex	de,hl
;567     if (minValue == maxValue)  { printf("\r\nInvalid range\r\n");  Exit(-1)
	.debug	# 567
	ld	hl,(ix-32)
	ex	de,hl
	ld	hl,(ix-30)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-36)
	ex	de,hl
	ld	hl,(ix-34)
	ld	bc,hl
	call	__fequ##
	jr	nz,@197
@198:
	.debug	< @198 @199
	ld	de,word (phys @15+669)
	ld	c,phys @15+669 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	ld	hl,0xffff
	push	hl
	lcall	$Exit
	pop	hl
@199:
	.debug	>
;568     setRange = true;
@197:
	.debug	# 568
	ld	(ix-19),0x1
;569   }
@193:
	.debug	>
;570 
;571   if (argc > 2)  if (StriEq(argv[2], "setpoints"))  {
@191:
@190:
	.debug	# 571
	ld	hl,(ix+5)
	ld	de,0x2
	or	a,a
	sbc	hl,de
	jp	c,@200
	jp	z,@200
	ld	hl,@1+127
	push	hl
	ld	hl,(ix+7)
	ld	e,0x4
	add	hl,de
	ld	hl,(hl)
	push	hl
	call	_stricmp
	add	sp,4
	bool	hl
	jp	nz,@201
;572     if (argc < 5)  { printf("\r\nInvalid setpoints command\r\n");  Exit(-1)
@202:
	.debug	< @202 @203
	.debug	# 572
	ld	hl,(ix+5)
	ld	de,0x5
	or	a,a
	sbc	hl,de
	jr	nc,@204
@205:
	.debug	< @205 @206
	ld	de,word (phys @15+687)
	ld	c,phys @15+687 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	ld	hl,0xffff
	push	hl
	lcall	$Exit
	pop	hl
@206:
	.debug	>
;573     egu1 = atof(argv[3]);  egu2 = atof(argv[4]);
@204:
	.debug	# 573
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix+7)
	ld	de,0x6
	add	hl,de
	ld	hl,(hl)
	push	hl
	call	_strtod
	add	sp,4
	ld	hl,bc
	ld	(ix-50),hl
	ex	de,hl
	ld	(ix-52),hl
	ex	de,hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix+7)
	ld	de,0x8
	add	hl,de
	ld	hl,(hl)
	push	hl
	call	_strtod
	add	sp,4
	ld	hl,bc
	ld	(ix-54),hl
	ex	de,hl
	ld	(ix-56),hl
	ex	de,hl
;574     if (egu1 == egu2)  { printf("\r\nInvalid setpoints\r\n");  Exit(-1); }
	.debug	# 574
	ld	hl,(ix-52)
	ex	de,hl
	ld	hl,(ix-50)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-56)
	ex	de,hl
	ld	hl,(ix-54)
	ld	bc,hl
	call	__fequ##
	jr	nz,@207
@208:
	.debug	< @208 @209
	ld	de,word (phys @15+717)
	ld	c,phys @15+717 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	ld	hl,0xffff
	push	hl
	lcall	$Exit
	pop	hl
@209:
	.debug	>
;575   }
@207:
@203:
	.debug	>
;576 
;577   if (argc == 4)  {
@201:
@200:
	.debug	# 577
	ld	hl,(ix+5)
	ld	de,0x4
	or	a,a
	sbc	hl,de
	jr	nz,@210
;578     gain = atof(argv[2]);  offset = atof(argv[3]);
@211:
	.debug	< @211 @212
	.debug	# 578
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix+7)
	add	hl,de
	ld	hl,(hl)
	push	hl
	call	_strtod
	add	sp,4
	ld	hl,bc
	ld	(ix-22),hl
	ex	de,hl
	ld	(ix-24),hl
	ex	de,hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix+7)
	ld	de,0x6
	add	hl,de
	ld	hl,(hl)
	push	hl
	call	_strtod
	add	sp,4
	ld	hl,bc
	ld	(ix-26),hl
	ex	de,hl
	ld	(ix-28),hl
	ex	de,hl
;579     if (gain == 0.0)  {
	.debug	# 579
	ld	hl,(ix-24)
	ex	de,hl
	ld	hl,(ix-22)
	ld	bc,hl
	ld	a,b
	and	a,7Fh
	or	a,c
	or	a,d
	or	a,e
	jr	nz,@213
;580       printf("\r\nUnusable gain: %s\r\n", argv[2]);  Exit(-1); }
@214:
	.debug	< @214 @215
	.debug	# 580
	ld	hl,(ix+7)
	ld	de,0x4
	add	hl,de
	ld	hl,(hl)
	push	hl
	ld	de,word (phys @15+739)
	ld	c,phys @15+739 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
	ld	hl,0xffff
	push	hl
	lcall	$Exit
	pop	hl
@215:
	.debug	>
;581   }
@213:
@212:
	.debug	>
;582 
;583   if (argc > 2)  {
@210:
	.debug	# 583
	ld	hl,(ix+5)
	ld	de,0x2
	or	a,a
	sbc	hl,de
	jp	c,@216
	jp	z,@216
;584     if (StriEq(argv[2], "defaults"))  useDefaults = true;
@217:
	.debug	< @217 @218
	.debug	# 584
	ld	hl,@1+137
	push	hl
	ld	hl,(ix+7)
	ld	e,0x4
	add	hl,de
	ld	hl,(hl)
	push	hl
	call	_stricmp
	add	sp,4
	bool	hl
	jr	nz,@219
	ld	(ix-17),0x1
;585 
;586     if (StriEq(argv[2], "zero"))  {
@219:
	.debug	# 586
	ld	hl,@1+146
	push	hl
	ld	hl,(ix+7)
	ld	de,0x4
	add	hl,de
	ld	hl,(hl)
	push	hl
	call	_stricmp
	add	sp,4
	bool	hl
	jr	nz,@220
;587       setZeroOffset = true;  interval = 250;  numSamples = 10;
@221:
	.debug	< @221 @222
	.debug	# 587
	ld	a,0x1
	ld	(ix-18),a
	ld	l,0xfa
	ld	(ix-11),hl
	ld	l,0xa
	ld	(ix-13),hl
;588       if (argc > 3)  interval = atoi(argv[3]);
	.debug	# 588
	ld	hl,(ix+5)
	ld	de,0x3
	or	a,a
	sbc	hl,de
	jr	c,@223
	jr	z,@223
	ld	hl,0xa
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix+7)
	ld	e,0x6
	add	hl,de
	ld	hl,(hl)
	push	hl
	lcall	$strtoi
	add	sp,6
	ld	(ix-11),hl
;589       if (interval < 10)  interval = 10;
@223:
	.debug	# 589
	ld	hl,(ix-11)
	ld	de,0xa
	or	a,a
	sbc	hl,de
	jr	nc,@224
	ld	h,d
	ld	l,e
	ld	(ix-11),hl
;590       if (argc > 4)  numSamples = atoi(argv[4]);
@224:
	.debug	# 590
	ld	hl,(ix+5)
	ld	de,0x4
	or	a,a
	sbc	hl,de
	jr	c,@225
	jr	z,@225
	ld	hl,0xa
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix+7)
	ld	e,0x8
	add	hl,de
	ld	hl,(hl)
	push	hl
	lcall	$strtoi
	add	sp,6
	ld	(ix-13),hl
;591       if (numSamples < 1)  numSamples = 1;
@225:
	.debug	# 591
	ld	hl,(ix-13)
	ld	de,0x1
	or	a,a
	sbc	hl,de
	jr	nc,@226
	ld	h,d
	ld	l,e
	ld	(ix-13),hl
;592     }
@226:
@222:
	.debug	>
;593   }
@220:
@218:
	.debug	>
;594 
;595 
;596   foundMatch = chgsMade = false;
@216:
	.debug	# 596
	xor	a,a
	ld	(ix-16),a
	ld	(ix-15),a
;597 
;598 //--- perform specified action for matching signal names (or all) ---
;599   for (ui=0; ui<128; ++ui)  {
@227:
	.debug	< @227 @228
	.debug	# 599
	bool	hl
	ld	l,h
	ld	(ix-3),hl
@229:
	ld	hl,(ix-3)
	ld	de,0x80
	or	a,a
	sbc	hl,de
	jp	nc,@230
;600 
;601     updatedCalib = false;
@232:
	.debug	< @232 @233
	.debug	# 601
	xor	a,a
	ld	(ix-20),a
;602 
;603     if (isdigit(argv[1][0]))  {
	.debug	# 603
	ld	hl,(ix+7)
	inc	hl
	inc	hl
	ld	hl,(hl)
	ld	a,(hl)
	bool	hl
	ld	l,a
	push	hl
	call	_isdigit
	pop	de
	bool	hl
	jr	z,@234
;604       hdwIdx = atoi(argv[1]);  if (hdwIdx != ui)  continue;
@235:
	.debug	< @235 @236
	.debug	# 604
	ld	l,0xa
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix+7)
	inc	hl
	inc	hl
	ld	hl,(hl)
	push	hl
	lcall	$strtoi
	add	sp,6
	ld	(ix-7),hl
	ex	de,hl
	ld	hl,(ix-3)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jp	nz,@231
;605       ci->getName(hdwIdx, temp);
	.debug	# 605
	ld	hl,-184+@147
	add	hl,sp
	push	hl
	ld	hl,(ix-7)
	push	hl
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	ld	hl,(ix+9)
	ex	de,hl
	push	bc
	push	de
	ld	de,0xc
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	call	__callde##
	add	sp,4
;606     }
@236:
	.debug	>
;607     else  {
	jr	@238
@234:
;608       hdwIdx = (ci->order)(ui);  ci->getName(hdwIdx, temp);
@239:
	.debug	< @239 @240
	.debug	# 608
	ld	hl,(ix-3)
	push	hl
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	ld	hl,(ix+9)
	ex	de,hl
	push	bc
	push	de
	ld	de,0xe
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	call	__callde##
	pop	de
	ld	(ix-7),hl
	ld	hl,-184+@147
	add	hl,sp
	push	hl
	ld	hl,(ix-7)
	push	hl
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	ld	hl,(ix+9)
	ex	de,hl
	push	bc
	push	de
	ld	de,0xc
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	call	__callde##
	add	sp,4
;609       if (!allValues AND !strstri(temp, argv[1]))  continue;
	.debug	# 609
	ld	a,(ix-14)
	or	a,a
	jr	nz,@242
	ld	hl,(ix+7)
	inc	hl
	inc	hl
	ld	hl,(hl)
	push	hl
	ld	hl,-182+@147
	add	hl,sp
	push	hl
	lcall	$strstri
	add	sp,4
	bool	hl
	jp	z,@231
;610     }
@242:
@240:
	.debug	>
;611 
;612     if (hdwIdx >= numValues)  continue;
@238:
	.debug	# 612
	ld	hl,(ix-7)
	ex	de,hl
	ld	hl,(ix-9)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jp	nc,@231
;613 
;614     foundMatch = true;
	.debug	# 614
	ld	(ix-15),0x1
;615 
;616     if (!quietMode)  {
	.debug	# 616
	ld	hl,(ix-48)
	ex	de,hl
	ld	hl,(ix-46)
	ld	bc,hl
	ld	a,b
	and	a,7Fh
	or	a,c
	or	a,d
	or	a,e
	jr	nz,@244
;617       printf("  %s (Y/N/Q): ", temp);  GETS(temp);  ch = toupper(*temp);
@245:
	.debug	< @245 @246
	.debug	# 617
	ld	hl,-184+@147
	add	hl,sp
	push	hl
	ld	de,word (phys @15+761)
	ld	c,phys @15+761 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
	bool	hl
	ld	l,h
	push	hl
	push	hl
	push	hl
	ld	hl,-178+@147
	add	hl,sp
	push	hl
	lcall	$Gets
	add	sp,8
	ld	hl,-184+@147
	add	hl,sp
	ld	a,(hl)
	bool	hl
	ld	l,a
	push	hl
	call	_toupper
	pop	de
	ld	(ix-1),l
;618       if (ch == 'Q')  Exit(-1);
	.debug	# 618
	ld	a,l
	sub	a,81
	jr	nz,@247
	ld	hl,0xffff
	push	hl
	lcall	$Exit
	pop	hl
;619       if (ch != 'Y')  continue;
@247:
	.debug	# 619
	ld	a,(ix-1)
	sub	a,89
	jp	nz,@231
;620     }
@246:
	.debug	>
;621 
;622     if (useDefaults)
@244:
	.debug	# 622
	ld	a,(ix-17)
	or	a,a
	jr	z,@249
;623       ci->defaults(hdwIdx, &gain, &offset);
	.debug	# 623
	ld	hl,-28+@147
	add	hl,sp
	push	hl
	ld	hl,-22+@147
	add	hl,sp
	push	hl
	ld	hl,(ix-7)
	push	hl
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	ld	hl,(ix+9)
	ex	de,hl
	push	bc
	push	de
	ld	de,0x6
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	call	__callde##
	add	sp,6
;624 
;625     if (setZeroOffset)  {
@249:
	.debug	# 625
	ld	a,(ix-18)
	or	a,a
	jp	z,@250
;626       gain = ci->gains[hdwIdx];  offset = 0.0;
@251:
	.debug	< @251 @252
	.debug	# 626
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x16
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ld	hl,(ix-7)
	add	hl,hl
	add	hl,hl
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	ld	(ix-22),hl
	ex	de,hl
	ld	(ix-24),hl
	ex	de,hl
	ld	de,0
	ld	c,e
	ld	b,e
	ld	hl,bc
	ld	(ix-26),hl
	ex	de,hl
	ld	(ix-28),hl
	ex	de,hl
;627       for (ut=0; ut<numSamples; ++ut)  {
@253:
	.debug	< @253 @254
	.debug	# 627
	ld	(ix-5),hl
@255:
	ld	hl,(ix-5)
	ex	de,hl
	ld	hl,(ix-13)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	nc,@256
;628         offset += ci->getRaw(hdwIdx);
@258:
	.debug	< @258 @259
	.debug	# 628
	ld	hl,(ix-7)
	push	hl
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	ld	hl,(ix+9)
	ex	de,hl
	call	__farld2##
	call	__callde##
	pop	hl
	push	bc
	push	de
	ld	hl,(ix-28)
	ex	de,hl
	ld	hl,(ix-26)
	ld	bc,hl
	call	__fadd##
	ld	hl,bc
	ld	(ix-26),hl
	ex	de,hl
	ld	(ix-28),hl
	ex	de,hl
;629         printf("    %s \r", Engineering(offset/(float)(ut+1), 6, temp));
	.debug	# 629
	ld	hl,-184+@147
	add	hl,sp
	push	hl
	ld	hl,0x6
	push	hl
	ld	hl,(ix-5)
	inc	hl
	ex	de,hl
	call	__uitof##
	push	bc
	push	de
	ld	hl,(ix-28)
	ex	de,hl
	ld	hl,(ix-26)
	ld	bc,hl
	call	__fdivr##
	push	bc
	push	de
	lcall	$Engineering
	add	sp,8
	push	hl
	ld	de,word (phys @15+776)
	ld	c,phys @15+776 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;630         fflush(stdout);  sleepMS(interval);
	.debug	# 630
	ld	hl,(__stdio)
	push	hl
	lcall	$fflush
	pop	de
	ld	hl,(ix-11)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	lcall	$sleepMS
	add	sp,4
;631       }
@259:
	.debug	>
;632       offset /= (float) numSamples;  printf("\n");
	ld	hl,(ix-5)
	inc	hl
	ld	(ix-5),hl
	jp	@255
@256:
@254:
	.debug	>
	.debug	# 632
	ld	hl,(ix-13)
	ex	de,hl
	call	__uitof##
	push	bc
	push	de
	ld	hl,(ix-28)
	ex	de,hl
	ld	hl,(ix-26)
	ld	bc,hl
	call	__fdivr##
	ld	hl,bc
	ld	(ix-26),hl
	ex	de,hl
	ld	(ix-28),hl
	ex	de,hl
	ld	de,word (phys @15+6)
	ld	c,phys @15+6 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;633     }
@252:
	.debug	>
;634 
;635     if (setRange)  {
@250:
	.debug	# 635
	ld	a,(ix-19)
	or	a,a
	jp	z,@260
;636       minRaw = ci->minRaw(hdwIdx);  maxRaw = ci->maxRaw(hdwIdx);
@261:
	.debug	< @261 @262
	.debug	# 636
	ld	hl,(ix-7)
	push	hl
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	ld	hl,(ix+9)
	ex	de,hl
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	call	__callde##
	pop	hl
	ld	hl,bc
	ld	(ix-38),hl
	ex	de,hl
	ld	(ix-40),hl
	ex	de,hl
	ld	hl,(ix-7)
	push	hl
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	ld	hl,(ix+9)
	ex	de,hl
	push	bc
	push	de
	ld	de,0x4
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	call	__callde##
	pop	hl
	ld	hl,bc
	ld	(ix-42),hl
	ex	de,hl
	ld	(ix-44),hl
	ex	de,hl
;637       offset = (maxRaw * minValue - maxValue * minRaw) / (minValue - maxVal
	.debug	# 637
	push	bc
	push	de
	ld	hl,(ix-32)
	ex	de,hl
	ld	hl,(ix-30)
	ld	bc,hl
	call	__fmlt##
	push	bc
	push	de
	ld	hl,(ix-36)
	ex	de,hl
	ld	hl,(ix-34)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-40)
	ex	de,hl
	ld	hl,(ix-38)
	ld	bc,hl
	call	__fmlt##
	call	__fsub##
	push	bc
	push	de
	ld	hl,(ix-32)
	ex	de,hl
	ld	hl,(ix-30)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-36)
	ex	de,hl
	ld	hl,(ix-34)
	ld	bc,hl
	call	__fsub##
	call	__fdiv##
	ld	hl,bc
	ld	(ix-26),hl
	ex	de,hl
	ld	(ix-28),hl
	ex	de,hl
;638       gain = maxValue / (maxRaw - offset);
	.debug	# 638
	ld	hl,(ix-44)
	ex	de,hl
	ld	hl,(ix-42)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-28)
	ex	de,hl
	ld	hl,(ix-26)
	ld	bc,hl
	call	__fsub##
	push	bc
	push	de
	ld	hl,(ix-36)
	ex	de,hl
	ld	hl,(ix-34)
	ld	bc,hl
	call	__fdivr##
	ld	hl,bc
	ld	(ix-22),hl
	ex	de,hl
	ld	(ix-24),hl
	ex	de,hl
;639     }
@262:
	.debug	>
;640 
;641 
;642     if (gain == 0.0)
@260:
	.debug	# 642
	ld	hl,(ix-24)
	ex	de,hl
	ld	hl,(ix-22)
	ld	bc,hl
	ld	a,b
	and	a,7Fh
	or	a,c
	or	a,d
	or	a,e
	jr	nz,@263
;643       updatedCalib = calibValue(ci, hdwIdx, temp, egu1, egu2);
	.debug	# 643
	ld	hl,(ix-56)
	ex	de,hl
	ld	hl,(ix-54)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-52)
	ex	de,hl
	ld	hl,(ix-50)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,-176+@147
	add	hl,sp
	push	hl
	ld	hl,(ix-7)
	push	hl
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	push	bc
	push	de
	lcall	$calibValue
	add	sp,16
	ld	(ix-20),a
;644     else  {
	jr	@264
@263:
;645       ci->gains[hdwIdx] = gain;  ci->offsets[hdwIdx] = offset;
@265:
	.debug	< @265 @266
	.debug	# 645
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x16
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ld	hl,(ix-7)
	add	hl,hl
	add	hl,hl
	add	hl,de
	ex	de,hl
	ld	hl,(ix-22)
	ld	bc,hl
	ld	hl,(ix-24)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x18
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ld	hl,(ix-7)
	add	hl,hl
	add	hl,hl
	add	hl,de
	ex	de,hl
	ld	hl,(ix-26)
	ld	bc,hl
	ld	hl,(ix-28)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;646       updatedCalib = true;
	.debug	# 646
	ld	(ix-20),0x1
;647     }
@266:
	.debug	>
;648 
;649   //--- If calibrations where changed, then we need to update any values --
;650   //--- that are dependent on them, and to force the recompute of the ---
;651   //--- reading or the hdw output value ---
;652     if (updatedCalib)  {
@264:
	.debug	# 652
	ld	a,(ix-20)
	or	a,a
	jr	z,@267
;653       if (ci->newCalib)  ci->newCalib(hdwIdx);
@268:
	.debug	< @268 @269
	.debug	# 653
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x10
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ld	a,e
	or	a,d
	jr	z,@270
	ld	hl,(ix-7)
	push	hl
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	ld	hl,(ix+9)
	ex	de,hl
	push	bc
	push	de
	ld	de,0x10
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	call	__callde##
	pop	hl
;654       chgsMade = true;
@270:
	.debug	# 654
	ld	(ix-16),0x1
;655     }
@269:
	.debug	>
;656 
;657     if (updatedCalib AND !quietMode)
@267:
	.debug	# 657
	ld	a,(ix-20)
	or	a,a
	jr	z,@272
	ld	hl,(ix-48)
	ex	de,hl
	ld	hl,(ix-46)
	ld	bc,hl
	ld	a,b
	and	a,7Fh
	or	a,c
	or	a,d
	or	a,e
	jr	nz,@272
;658       showGainOffsetRange(hdwIdx, ci, temp, true);
	.debug	# 658
	ld	hl,0x1
	push	hl
	ld	hl,-182+@147
	add	hl,sp
	push	hl
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-7)
	push	hl
	lcall	$showGainOffsetRange
	add	sp,10
;659   }
@272:
@233:
	.debug	>
;660 
;661 
;662   if (! foundMatch)  { printf("No such value: %s\r\n", argv[1]);  Exit(-1);
@231:
	ld	hl,(ix-3)
	inc	hl
	ld	(ix-3),hl
	jp	@229
@230:
@228:
	.debug	>
	.debug	# 662
	ld	a,(ix-15)
	or	a,a
	jr	nz,@273
@274:
	.debug	< @274 @275
	ld	hl,(ix+7)
	inc	hl
	inc	hl
	ld	hl,(hl)
	push	hl
	ld	de,word (phys @15+785)
	ld	c,phys @15+785 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
	ld	hl,0xffff
	push	hl
	lcall	$Exit
	pop	hl
@275:
	.debug	>
;663 
;664   if (chgsMade AND !quietMode)  {
@273:
	.debug	# 664
	ld	a,(ix-16)
	or	a,a
	jr	z,@277
	ld	hl,(ix-48)
	ex	de,hl
	ld	hl,(ix-46)
	ld	bc,hl
	ld	a,b
	and	a,7Fh
	or	a,c
	or	a,d
	or	a,e
	jr	nz,@277
;665     printf("\r\nSave updated calibrations (Y/N): ");  GETS(temp);
@278:
	.debug	< @278 @279
	.debug	# 665
	ld	de,word (phys @15+805)
	ld	c,phys @15+805 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	bool	hl
	ld	l,h
	push	hl
	push	hl
	push	hl
	ld	hl,-178+@147
	add	hl,sp
	push	hl
	lcall	$Gets
	add	sp,8
;666     if (toupper(*temp) == 'Y')
	.debug	# 666
	ld	hl,-184+@147
	add	hl,sp
	ld	a,(hl)
	bool	hl
	ld	l,a
	push	hl
	call	_toupper
	pop	de
	ld	de,0x59
	or	a,a
	sbc	hl,de
	jr	nz,@280
;667       saveParams(temp, sizeof(temp), ci->paramFile, ForceFlush);
	.debug	# 667
	ld	hl,0x1
	push	hl
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x14
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	push	de
	ld	hl,0x80
	push	hl
	ld	hl,-178+@147
	add	hl,sp
	push	hl
	lcall	$saveParams
	add	sp,8
;668   }
@280:
@279:
	.debug	>
;669 
;670   Exit(0);
@277:
	.debug	# 670
	bool	hl
	ld	l,h
	push	hl
	lcall	$Exit
	pop	hl
;671 }
@148:
	.debug	} @148 671

@147	equ	184
	ld	sp,ix
	pop	ix
	lret
@149	equ	186
;672 
;673 
;674 //-------------------------------------------------------------------------
	.extern	_strcmp 40
	.extern	_strcpy 52
	.extern	_stricmp 40
	.extern	_fstrcmp 53
	.extern	$gmtime_r 54
	.extern	$strstri 52
	.extern	$Engineering 56
	.extern	_current 57
	.extern	__stdio 59
	.extern	$farprintf 61
	.extern	$farsprintf 62
	.extern	_strtod 63
	.extern	$strtoi 64
	.extern	_adcGain 65
	.extern	_adcOffset 65
	.extern	_dacGain 65
	.extern	_dacOffset 65
	.extern	_NumHdwADC 7
	.extern	_NumHdwDAC 7
	.extern	_readGain 65
	.extern	_readOffset 65
	.extern	_setGain 65
	.extern	_setOffset 65
	.cseg
_newDACCalib:
	pop	iy
	lcall	$$newDACCalib
	.extern	$$newDACCalib
	.extern	$newDACCalib 66
_newADCCalib:
	pop	iy
	lcall	$$newADCCalib
	.extern	$$newADCCalib
	.extern	$newADCCalib 66
_setStateDAC:
	pop	iy
	lcall	$$setStateDAC
	.extern	$$setStateDAC
	.extern	$setStateDAC 67
	.extern	$read 68
	.extern	$write 68
	.extern	$fcntl 69
	.extern	$fflush 70
	.extern	_timeZone 6
	.extern	$sleepMS 71
	.extern	$Gets 72
	.extern	$Exit 73
	.extern	$stat 74
	.extern	$saveParams 75
	.extern	$loadParams 75
	.extern	_commonCmds 76
	.extern	_NumCommonCmds 6
	.extern	_isdigit 77
	.extern	_toupper 77
	.extern	_NumApplAIN 7
	.extern	_NumApplAOUT 7
	.extern	_applCmds 76
	.extern	_NumApplCmds 6
	.extern	_hdwCfgFile 78
	.extern	_devDataFile 78
_ainName:
	pop	iy
	lcall	$$ainName
	.extern	$$ainName
	.extern	$ainName 79
_aoutName:
	pop	iy
	lcall	$$aoutName
	.extern	$$aoutName
	.extern	$aoutName 79
_logicalOrderAIN:
	pop	iy
	lcall	$$logicalOrderAIN
	.extern	$$logicalOrderAIN
	.extern	$logicalOrderAIN 80
_logicalOrderAOUT:
	pop	iy
	lcall	$$logicalOrderAOUT
	.extern	$$logicalOrderAOUT
	.extern	$logicalOrderAOUT 80
_adcGetRaw:
	pop	iy
	lcall	$$adcGetRaw
	.extern	$$adcGetRaw
	.extern	$adcGetRaw 81
_adcMinRaw:
	pop	iy
	lcall	$$adcMinRaw
	.extern	$$adcMinRaw
	.extern	$adcMinRaw 81
_adcMaxRaw:
	pop	iy
	lcall	$$adcMaxRaw
	.extern	$$adcMaxRaw
	.extern	$adcMaxRaw 81
_adcDefaults:
	pop	iy
	lcall	$$adcDefaults
	.extern	$$adcDefaults
	.extern	$adcDefaults 82
_adcCalibPoints:
	pop	iy
	lcall	$$adcCalibPoints
	.extern	$$adcCalibPoints
	.extern	$adcCalibPoints 82
_adcUnits:
	pop	iy
	lcall	$$adcUnits
	.extern	$$adcUnits
	.extern	$adcUnits 79
_dacGetRaw:
	pop	iy
	lcall	$$dacGetRaw
	.extern	$$dacGetRaw
	.extern	$dacGetRaw 81
_dacMinRaw:
	pop	iy
	lcall	$$dacMinRaw
	.extern	$$dacMinRaw
	.extern	$dacMinRaw 81
_dacMaxRaw:
	pop	iy
	lcall	$$dacMaxRaw
	.extern	$$dacMaxRaw
	.extern	$dacMaxRaw 81
_dacDefaults:
	pop	iy
	lcall	$$dacDefaults
	.extern	$$dacDefaults
	.extern	$dacDefaults 82
_dacCalibPoints:
	pop	iy
	lcall	$$dacCalibPoints
	.extern	$$dacCalibPoints
	.extern	$dacCalibPoints 82
_dacUnits:
	pop	iy
	lcall	$$dacUnits
	.extern	$$dacUnits
	.extern	$dacUnits 79
_readGetRaw:
	pop	iy
	lcall	$$readGetRaw
	.extern	$$readGetRaw
	.extern	$readGetRaw 81
_readMinRaw:
	pop	iy
	lcall	$$readMinRaw
	.extern	$$readMinRaw
	.extern	$readMinRaw 81
_readMaxRaw:
	pop	iy
	lcall	$$readMaxRaw
	.extern	$$readMaxRaw
	.extern	$readMaxRaw 81
_readDefaults:
	pop	iy
	lcall	$$readDefaults
	.extern	$$readDefaults
	.extern	$readDefaults 82
_readCalibPoints:
	pop	iy
	lcall	$$readCalibPoints
	.extern	$$readCalibPoints
	.extern	$readCalibPoints 82
_readUnits:
	pop	iy
	lcall	$$readUnits
	.extern	$$readUnits
	.extern	$readUnits 79
_setGetRaw:
	pop	iy
	lcall	$$setGetRaw
	.extern	$$setGetRaw
	.extern	$setGetRaw 81
_setMinRaw:
	pop	iy
	lcall	$$setMinRaw
	.extern	$$setMinRaw
	.extern	$setMinRaw 81
_setMaxRaw:
	pop	iy
	lcall	$$setMaxRaw
	.extern	$$setMaxRaw
	.extern	$setMaxRaw 81
_setDefaults:
	pop	iy
	lcall	$$setDefaults
	.extern	$$setDefaults
	.extern	$setDefaults 82
_setCalibPoints:
	pop	iy
	lcall	$$setCalibPoints
	.extern	$$setCalibPoints
	.extern	$setCalibPoints 82
_setUnits:
	pop	iy
	lcall	$$setUnits
	.extern	$$setUnits
	.extern	$setUnits 79
	.debug	T	D0000320001E000F00010053000000076765745261770053000200
	.debug	T	076D696E5261770053000400076D6178526177005400060009
	.debug	T	64656661756C747300540008000C63616C6962506F696E7473
	.debug	T	0055000A0006756E6974730055000C00086765744E616D6500
	.debug	T	56000E00066F726465720057001000096E657743616C696200
	.debug	T	580012000A7365744F757470757400590014000A706172616D
	.debug	T	46696C65005A001600066761696E73005A001800086F666673
	.debug	T	657473005B001A000A6E756D56616C7565730022001C000973
	.debug	T	6574446573637200
	.debug	T	0B000221000100010022000000
	.debug	T	070000220002000300
	.debug	T	070008230004002400
	.debug	T	2F000324000A00030001005C00000008636D644E616D65005D0004
	.debug	T	000970726F634D61696E005C00060006646573637200
	.debug	T	130002250003000300060000000600020026000400
	.debug	T	070000260002002200
	.debug	T	09000127000E0022000700
	.debug	T	0F00022800020006002200000022000200
	.debug	T	7E000329001200090003746D000600000007746D5F736563000600
	.debug	T	020007746D5F6D696E000600040008746D5F686F7572000600
	.debug	T	060008746D5F6D646179000600080007746D5F6D6F6E000600
	.debug	T	0A0008746D5F796561720006000C0008746D5F776461790006
	.debug	T	000E0008746D5F79646179000600100009746D5F6973647374
	.debug	T	00
	.debug	T	BB00032A002A000D00057374617400090000000773745F64657600
	.debug	T	090004000773745F696E6F00090008000873745F6D6F646500
	.debug	T	06000C000973745F6E6C696E6B0006000E000773745F756964
	.debug	T	00060010000773745F67696400090012000873745F72646576
	.debug	T	00090016000873745F73697A650006001A000B73745F626C6B
	.debug	T	73697A650006001C000A73745F626C6F636B730009001E0009
	.debug	T	73745F6174696D6500090022000973745F6D74696D65000900
	.debug	T	26000973745F6374696D6500
	.debug	T	0F00022B00020022002200000009000200
	.debug	T	1700022C000400220022000000090002002200060003000800
	.debug	T	1F00022D0006000600060000000600020006000400060006000300
	.debug	T	080003000A00
	.debug	T	0900012E00800003008000
	.debug	T	0900012F00600003006000
	.debug	T	17000230000400010007000000310002002200060003000800
	.debug	T	070008310004002000
	.debug	T	1B00023200050003003100000007000400220006000A0008000A00
	.debug	T	0C00
	.debug	T	130002330003000100070000002600020031000400
	.debug	T	0F00023400020022002200000022000200
	.debug	T	0F00023500020006005C0000005C000400
	.debug	T	0F00023600020037005F00000037000200
	.debug	T	070000370002002900
	.debug	T	1300023800030022000A0000000600040022000600
	.debug	T	070000390002003A00
	.debug	T	7702033A00E8002D000C7461736B5F737472756374005B00000006
	.debug	T	737461636B005B0002000C737461636B5F7374617274000700
	.debug	T	04000B737461636B5F73697A65000300060005737365670003
	.debug	T	0007000773746B6C6C7200030008000773746B686C72000300
	.debug	T	09000677707361720007000A0008777073616C68720003000C
	.debug	T	000677707362720007000D0008777073626C68720060000F00
	.debug	T	064644536574000300110009757365436F756E740003001200
	.debug	T	08636C61696D65640007001300067374617465003900150007
	.debug	T	6D794164647200030017000A7A65726F416674657200060018
	.debug	T	0005617267630026001A000561726776002E001C0005617267
	.debug	T	730062009C0007776169745173000900A0000C7369675F7065
	.debug	T	6E64696E67000900A4000C7369675F626C6F636B6564000600
	.debug	T	A8000E707265656D70745F636F756E74000300AA0006696E55
	.debug	T	7365000300AB000565786974000300AC000A6C6F675374646F
	.debug	T	7574000300AD000B7265646972537464696F000900AE000A64
	.debug	T	696167466C616773005D00B2000970726F634D61696E000600
	.debug	T	B40004706964000600B6000570706964000300B80009707269
	.debug	T	6F72697479000600B900086C617374457272000900BB000873
	.debug	T	746172746564000900BF000C6C617374526573756D65640009
	.debug	T	00C3000C6C61737453746F70706564000900C7000C6C617374
	.debug	T	52756E6E696E67000900CB000D726573756D65645469636B73
	.debug	T	000900CF000A7469636B7355736564000900D300076D735573
	.debug	T	6564000300D700096F7574436F756E74005C00D800076F7574
	.debug	T	507472000900DC000B736C6565705469636B73000900E0000D
	.debug	T	736C65657053746172746564000900E4000D74696D656F7574
	.debug	T	5469636B7300
	.debug	T	0700003B0002003C00
	.debug	T	5400033C000C000600010063000000065F5F6F7574006500020005
	.debug	T	5F5F696E0067000400085F5F77726974650067000600075F5F
	.debug	T	726561640006000800085F5F756E6765740069000A000B5F5F
	.debug	T	757365724461746100
	.debug	T	0F00023D00020006005C0000000D000000
	.debug	T	1300023E00030006005C0000005C0004000D000000
	.debug	T	0F00023F0002000B002200000026000200
	.debug	T	130002400003000600220000002600020006000400
	.debug	T	090001410000000A000000
	.debug	T	0B000242000100010007000000
	.debug	T	130002430003000100070000000A00020003000600
	.debug	T	130002440003000600060000006900020006000400
	.debug	T	130002450003000600060000000600020006000400
	.debug	T	0B00024600010006003B000000
	.debug	T	0B000247000100090009000000
	.debug	T	17000248000400220022000000220002000700040007000600
	.debug	T	0B000249000100010006000000
	.debug	T	0F00024A0002000600220000006A000200
	.debug	T	1700024B000400060022000000070002005900040003000600
	.debug	T	0900014C00000024000000
	.debug	T	0B00024D000100060006000000
	.debug	T	7200034E003100080001002200000009626173654E616D65000300
	.debug	T	02000963617465676F7279006B00030007706172616D73006D
	.debug	T	0007000B7772697465436F756E740006002700036664006E00
	.debug	T	29000962626D43616368650007002D000A636163686553697A
	.debug	T	650007002F00076F666673657400
	.debug	T	0F00024F00020022000700000022000200
	.debug	T	0B000250000100070007000000
	.debug	T	0B0002510001000A0007000000
	.debug	T	130002520003000100070000005A0002005A000400
	.debug	T	070000530002005100
	.debug	T	070000540002005200
	.debug	T	070000550002004F00
	.debug	T	070000560002005000
	.debug	T	070000570002004200
	.debug	T	070000580002004300
	.debug	T	070000590002004E00
	.debug	T	0700005A0002000A00
	.debug	T	0700005B0002000700
	.debug	T	0700085C0004000300
	.debug	T	0700005D0002005E00
	.debug	T	0F00025E00020001000600000026000200
	.debug	T	0700005F0002000900
	.debug	T	070000600002006100
	.debug	T	070008610004000100
	.debug	T	280003620004000100125F5F776169745F71756575655F68656164
	.debug	T	0070000000096C6973744865616400
	.debug	T	070000630002006400
	.debug	T	0F00026400020006000300000069000200
	.debug	T	070000650002006600
	.debug	T	0B000266000100060069000000
	.debug	T	070000670002006800
	.debug	T	1300026800030008005C0000000800040069000800
	.debug	T	070000690002000100
	.debug	T	0700006A0002002A00
	.debug	T	0700086B0004006C00
	.debug	T	4900036C001000060001000400000003696400040002000573697A
	.debug	T	650004000400056772616E00610006000564617461005C000A
	.debug	T	00056E616D650071000E000B726573746F726556616C00
	.debug	T	0900016D00200007001000
	.debug	T	0700086E0004006F00
	.debug	T	3300036F000A0004000100090000000574696D6500070004000573
	.debug	T	697A6500070006000864657654797065000700080004637263
	.debug	T	00
	.debug	T	2600037000040002000A6C6973745F686561640073000000056E65
	.debug	T	78740073000200057072657600
	.debug	T	070000710002007200
	.debug	T	130002720003000100610000002200040007000600
	.debug	T	070000730002007000
	.defseg	CONST
	.seg	CONST
@1:
	.db	"ADC",0,"DAC",0,"Device Readings",0,"Device Settings",0,"?",0,"-?",0,"/?",0,"help",0,"-help",0,"/help",0,"       0 unknown",0,"   "
	.db	0,10,0,"-quiet",0,"reload",0,"save",0,"dump",0,"show",0,"all",0,"range",0,"setpoints",0,"defaults",0,"zero",0
	.seg	FARCONST
@15:
	.db	13,10,"%ls",13,10,0,"%8lu %04d-%02d-%02d %02d:%02d",0,"%4ums  ",0,"%4us   ",0,"%4um   ",0,"%4uh   ",0,"%4u:%02u:%02u ",0
	.db	"%06lX: ",0,"%02X ",0,"read error: %d",13,10,0,"EOF",13,10,0,"KILL",13,10,0,"write error",13,10,0,13,10,"       ----Gain----  ---O"
	.db	"ffset---  ------- Range -------  ------Name------",13,10,0,"%4u:  %s  %s  %s %s  %.24s",13,10,0,13,10,"Un"
	.db	"usable calibration data",13,10,0,10,"usage: %s ...",13,10,0,"     all|<name>|#",13,10,"     all|<name>|# defau"
	.db	"lts",13,10,"     all|<name>|# range <min> <max>",13,10,"     all|<name>|# <gain> <offset>",13,10,0,"     a"
	.db	"ll|<name>|# setpoints <point1> <point2>",13,10,0,"     all|<name>|# zero [interval [#samples]"
	.db	"]",13,10,"     dump",13,10,"     show",13,10,"     reload",13,10,"     save",13,10,"  (-quiet at end will skip prompts"
	.db	")",13,10,0,"%s %2d %s %s -quiet",13,10,0,13,10,"%s calibration data:",13,10,0,13,10,"Invalid range command",13,10,0,13,10,"Invali"
	.db	"d range",13,10,0,13,10,"Invalid setpoints command",13,10,0,13,10,"Invalid setpoints",13,10,0,13,10,"Unusable gain: %s",13,10,0," "
	.db	" %s (Y/N/Q): ",0,"    %s ",13,0,"No such value: %s",13,10,0,13,10,"Save updated calibrations (Y/N): ",0
	.end
