	.objcmt	Softools, Inc. ** Control Cross-C Globally Optimizing Compiler ** Version 2.18.00
	.objcmt	Copyright (c) 1989 - 2003, Softools, Inc.  All rights reserved.
	.debug	P 5
	.debug	X 11 10
	.debug	X 12 10
	.debug	N 'C:\work\dev\Rabbit_ST\rtos\drivers\flashFile.c' 4 58 11 8 2 32
;1 //----- flashFile.c ----- 02/08/12 -----(07/13/06)-----
;2 
;3 //-------------------------------------------------------------------------
;4 //  Standard DEBROS virtual file/device I/O API wrapper for the SHDesigns-b
;5 //  Flash File system API.
;6 //-------------------------------------------------------------------------
;7 //  Update log (most recent first)
;8 //
;9 //
;10 //  2012-02-08 - Mark Davis
;11 //               - errno is now set to EBADF rather than ENXIO when a funct
;12 //                 is passed an invalid device pointer.
;13 //
;14 //  2010-07-13 - Mark Davis
;15 //               - Added support for FIONSPACE request for ioctl() calls.
;16 //                 This allows poll() to work properly if called for flash
;17 //                 files.
;18 //
;19 //  2010-04-01 - Mark Davis
;20 //               - _flashFileFstat_() no longer changes the value of errno 
;21 //                 ffile_fstat() returns a non-0 value.  This avoids a
;22 //                 confusing errno value (and message from perror() if used
;23 //                 when ffile_fstat() detects a problem.
;24 //
;25 //  2010-03-23 - Mark Davis
;26 //               - Added locks around call to ffile_info() in _flashFileDes
;27 //                 to eliminate error msgs and minimize risk of concurrency
;28 //                 problems when formatting the description for a file.  NO
;29 //                 that the concurrency issue is not critical as this is fo
;30 //                 display purposes only.
;31 //
;32 //  2009-06-18 - Mark Davis
;33 //               - The open func now recognizes the O_APPEND flag.
;34 //
;35 //  2009-03-26 - Mark Davis
;36 //               - Added unlink and rename functions
;37 //
;38 //  2009-03-24 - Mark Davis
;39 //               - added _flashFileEntry_() function for getting info about
;40 //                 flash file driver fds
;41 //
;42 //  2008-04-07 - Mark Davis
;43 //               - changes to support dynamically registered file systems
;44 //
;45 //-------------------------------------------------------------------------
;46 
;47 #include <common.h>
;48 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\time.h' 15 48 18 10 12 22
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\string.h' 26 27 14 2 6 25
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stddef.h' 21 20 12 5 6 22
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\math.h' 19 23 18 21 9 21
	.debug	I
	.debug	I
;49 #include <unistd.h>
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\sched.h' 3 49 6 8 6 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\signal.h' 6 21 8 17 3 29
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\list.h' 21 49 15 26 7 30
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\wait.h' 10 13 9 20 4 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\dummy.h' 25 58 21 12 10 27
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\list.h' 21 49 15 26 7 30
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	I
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Rabbit.h' 24 40 11 19 5 30
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stdio.h' 22 16 12 9 4 26
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\SoftoolsIDblock.h' 18 52 15 4 6 26
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\FlashBlock.h' 5 10 16 30 11 24
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Flash.h' 0 55 21 17 7 26
	.debug	I
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Stdlib.h' 2 30 16 6 7 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\dcdefs.h' 18 42 23 19 7 26
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Rabbit.h' 24 40 11 19 5 30
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\SoftoolsIDBlock.h' 18 52 15 4 6 26
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\errors.h' 25 8 15 18 11 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stdlib.h' 2 30 16 6 7 24
	.debug	I
	.debug	# 109
_LIN2SEG	.macro

	.debug	# 110
add hl,hl

	.debug	# 111
rla

	.debug	# 112
add hl,hl

	.debug	# 113
rla

	.debug	# 114
add hl,hl

	.debug	# 115
rla

	.debug	# 116
add hl,hl

	.debug	# 117
rla

	.debug	# 118
sub 0x0E

	.debug	# 119
or a

	.debug	# 120
rr hl

	.debug	# 121
scf

	.debug	# 122
rr hl

	.debug	# 123
scf

	.debug	# 124
rr hl

	.debug	# 125
scf

	.debug	# 126
rr hl

	.debug	# 127
.endm

	.cseg
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\hdwdefs.h' 20 2 12 27 10 31
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\sched.h' 3 49 6 8 6 32
	.debug	I
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\fcntl.h' 29 48 12 5 12 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\wait.h' 10 13 9 20 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\ioctl.h' 2 15 10 21 5 30
	.debug	I
	.debug	I
	.debug	I
;50 #include <fcntl.h>
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\fcntl.h' 29 48 12 5 12 32
	.debug	I
;51 #include <sys/stat.h>
;52 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\stat.h' 0 48 10 31 3 29
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\time.h' 15 48 18 10 12 22
	.debug	I
	.debug	I
;53 #include <errno.h>
;54 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\errno.h' 22 0 10 11 8 30
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	I
	.debug	I
;55 #include <sys/flashFile.h>
;56 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\flashFile.h' 15 56 20 12 3 27
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I
;57 #include <Rabbit.h>
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Rabbit.h' 24 40 11 19 5 30
	.debug	I
;58 #include <dcdefs.h>
;59 
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\dcdefs.h' 18 42 23 19 7 26
	.debug	I
;60 
;61 #include <DLMIII.h>
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\fs\DLMIII.h' 3 21 14 4 6 30
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\ZWIDblock.h' 29 54 20 12 3 27
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\SoftoolsIDBlock.h' 18 52 15 4 6 26
	.debug	I
	.debug	I
;62 #include <SHD_DLM.h>
;63 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\fs\SHD_DLM.h' 7 53 11 8 2 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\socket.h' 2 54 9 7 6 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\netinet\in.h' 15 56 20 12 3 27
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip.h' 10 19 7 30 6 29
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\dcdefs.h' 18 42 23 19 7 26
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\dcrtcp.h' 1 9 9 21 2 32
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\tcp_config.h' 9 28 14 7 1 25
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\neterrno.h' 26 24 16 30 7 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\errors.h' 25 8 15 18 11 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\servlist.h' 7 29 16 30 7 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\net.h' 21 21 9 7 3 32
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ppp.h' 4 42 22 17 6 26
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ppplink.h' 18 1 2 19 9 26
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\chat.h' 12 7 15 6 10 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Rabbit.h' 24 40 11 19 5 30
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\net.h' 21 21 9 7 3 32
	.debug	I
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\pktdrv.h' 16 19 17 14 3 25
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\arp.h' 21 56 14 30 7 24
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ip.h' 16 35 12 25 4 25
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ip.h' 16 35 12 25 4 25
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\udp.h' 23 23 20 4 3 30
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\icmp.h' 2 44 0 17 5 25
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\tcp.h' 14 5 18 19 4 25
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\bootp.h' 2 16 3 7 2 26
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\bsdname.h' 9 41 20 10 2 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\icmp.h' 2 44 0 17 5 25
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\dns.h' 18 15 17 7 1 25
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\servlist.h' 7 29 16 30 7 24
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\igmp.h' 10 41 20 10 2 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\smtp.h' 0 54 12 2 8 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\http.h' 28 52 16 7 1 25
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\zserver.h' 26 57 12 10 1 25
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\limits.h' 1 13 9 26 5 19
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\pool.h' 10 58 16 7 1 25
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\errno.h' 16 4 11 6 2 29
	.debug	I
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\mib.h' 28 3 18 15 4 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\snmp.h' 22 42 15 4 11 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ftp_client.h' 9 41 20 10 2 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ftp_server.h' 5 50 18 7 1 25
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\zserver.h' 26 57 12 10 1 25
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ethernet.h' 21 56 23 21 3 26
	.debug	I
	.debug	I
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\wait.h' 10 13 9 20 4 32
	.debug	I
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\fs\DLMIII.h' 3 21 14 4 6 30
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I
;64 
;65 #include <sys/farprintf.h>
;66 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\farprintf.h' 5 43 7 29 11 27
	.debug	I
;67 
;68 IODEV_FUNCS(flashFile)
	.defseg	CONST
	.seg	CONST
_flashFileIOFuncs::
	.dw	word __flashFileRead_
	.dw	word __flashFileWrite_
	.dw	word __flashFileClose_
	.dw	word __flashFileLseek_
	.dw	word __flashFileFstat_
	.dw	word __flashFileioctl_
	.dw	word __flashFileDescr_
	.dw	word __flashFileGetQueues_
	.debug	G _flashFileIOFuncs 32 0
;69 IODEV_FUNCS(flashFile)
;70 FILESYS_FUNCS(flashFile)
_flashFileFSysFuncs::
	.dw	@1
	.dw	word _flashFileIOFuncs
	.dw	word __flashFileTick_
	.dw	word __flashFileEntry_
	.dw	word __flashFileOpen_
	.dw	word __flashFileUnlink_
	.dw	word __flashFileRename_
	.debug	G _flashFileFSysFuncs 33 0
;71 FILESYS_FUNCS(flashFile)
;72 //typedef  int (*GetCFunc)(void);
;73 //typedef  int (*PutCFunc)(int ch);
;74 
;75 
;76 // The file_io.c device layer has its own table of open files and we don't
;77 // (at least currently) need to add any functionality to it so no table is
;78 // needed at this layer.
;79 //
;80 // static int ffid[MAX_FILES];
;81 
;82 
;83 #define FFILE     ((FILE_DATA *)ioDev)
;84 #define FFHandle(ff)  ((int)((ff) - openFiles))
;85 
;86 //-------------------------------------------------------------------------
;87 //  func called once by init process to initialize data structures
;88 //-------------------------------------------------------------------------
;89 void flashFileInit_()
;90 {
	.defseg	FARCODE
	.seg	FARCODE
$flashFileInit_::
	.debug	G $flashFileInit_ 34 9
	.debug	{ $flashFileInit_ 34 89 @4 @3
;91 //  uchar  i;
;92 
;93 //  for (i=0; i<MAX_FILES; ++i)  ffid[i] = -1;
;94 
;95 //  flashFileFSysFuncs.tick = NULL;
;96 
;97   registerFileSys(&flashFileFSysFuncs);
	.debug	# 97
	ld	hl,_flashFileFSysFuncs
	push	hl
	lcall	$registerFileSys
	pop	de
;98 }
@3:
	.debug	} @3 98

@2	equ	0
	lret
@4	equ	0
;99 
;100 
;101 //-------------------------------------------------------------------------
;102 //  Returns true if provided pointer is a valid, in-use FlashFile device.
;103 //  Returns false if is not.
;104 //-------------------------------------------------------------------------
;105 bool  validFFILE(void *ioDev)
;106 {
$validFFILE::
	.debug	G $validFFILE 35 9
	.debug	{ $validFFILE 35 105 @7 @6
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A ioDev 5 36
;107   if (ioDev)
	.debug	# 107
	ld	hl,(ix+5)
	bool	hl
	jr	z,@8
;108     if (FFILE == openFiles + (int)(FFILE - openFiles))
	.debug	# 108
	ld	hl,(ix+5)
	ld	de,_openFiles
	or	a,a
	sbc	hl,de
	ld	de,0x16
	call	__idiv##
	ld	bc,0x16
	ex	de,hl
	mul
	ld	hl,_openFiles
	add	hl,bc
	ex	de,hl
	ld	hl,(ix+5)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	nz,@9
;109       if (FFILE->flags & FFLAG_OPEN)  return true;
	.debug	# 109
	ld	h,d
	ld	l,e
	ld	de,0x14
	add	hl,de
	ld	hl,(hl)
	ld	e,0x1
	and	hl,de
	jr	z,@10
	ld	a,e
	jr	@6
;110 
;111   return false;
@10:
@9:
@8:
	.debug	# 111
	xor	a,a
;112 }
@6:
	.debug	} @6 112

@5	equ	0
	pop	ix
	lret
@7	equ	2
;113 
;114 //-------------------------------------------------------------------------
;115 //  Open file in flash and return a file descriptor for it
;116 //
;117 //  Should only be called from the fcntl.c layer!
;118 //-------------------------------------------------------------------------
;119 fd_t _flashFileOpen_(const char *path, int flags, int mode)
;120 {
	.align	4
$$_flashFileOpen_::
	ex	(sp),iy
$_flashFileOpen_::
	.debug	G $_flashFileOpen_ 37 9
	.debug	{ $_flashFileOpen_ 37 119 @13 @12
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-6
	.debug	A path 5 38
	.debug	A flags 7 6
	.debug	A mode 9 6
;121   fd_t  fd;
	.debug	L fd -2 6
;122   int  handle;  // flash file handle
	.debug	L handle -4 6
;123   FILE_DATA  *ioDev;
	.debug	L ioDev -6 39
;124 
;125 
;126   KLOCK();
	.debug	# 126
	call	_KLOCK
;127 
;128 //--- try to open file - create it if asked to and it doesn't exist yet ---
;129   handle = ffile_open((char *)path);
	.debug	# 129
	ld	hl,(ix+5)
	push	hl
	lcall	$ffile_open
	pop	de
	ld	(ix-4),hl
;130   if (handle == FERR_NOTFOUND)  {
	.debug	# 130
	ld	de,0xffff
	or	a,a
	sbc	hl,de
	jr	nz,@14
;131     if (! (flags & O_CREAT))  { KUNLOCK();  ERRNO = ENOENT;  return -1; }
@15:
	.debug	< @15 @16
	.debug	# 131
	ld	hl,(ix+7)
	ld	de,0x4
	and	hl,de
	jr	nz,@17
@18:
	.debug	< @18 @19
	call	_KUNLOCK
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x2
	ld	(hl),e
	inc	hl
	ld	(hl),d
	jr	@115
@19:
	.debug	>
;132     handle = ffile_create((char *)path);
@17:
	.debug	# 132
	ld	hl,(ix+5)
	push	hl
	lcall	$ffile_create
	pop	de
	ld	(ix-4),hl
;133   }
@16:
	.debug	>
;134   if (handle < 0)  {
@14:
	.debug	# 134
	ld	hl,(ix-4)
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@20
;135     KUNLOCK();
@21:
	.debug	< @21 @22
	.debug	# 135
	call	_KUNLOCK
;136     switch (handle)  {
	.debug	# 136
	ld	hl,(ix-4)
	jr	@23
;137       case FERR_TOOMANYFILES:  ERRNO = ENFILE;  break;
@25:
	.debug	< @25 @26
	.debug	# 137
@27:
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x17
	jr	@116
;138       case FERR_NOXMEM:  ERRNO = ENOMEM;  break;
	.debug	# 138
@28:
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0xc
@116:
	ld	(hl),e
	inc	hl
	ld	(hl),d
;139     }
	jr	@115
@26:
	.debug	>
;140     return -1;
@23:
	ex	de,hl
	ld	hl,0x3
	add	hl,de
	bool	hl
	jr	z,@28
	ld	l,0x2
	add	hl,de
	bool	hl
	jr	z,@27
@24:
	.debug	# 140
	jr	@115
;141   }
@22:
	.debug	>
;142 
;143   ioDev = openFiles + handle;
@20:
	.debug	# 143
	ld	hl,(ix-4)
	ld	bc,0x16
	ex	de,hl
	mul
	ld	hl,_openFiles
	add	hl,bc
	ld	(ix-6),hl
;144 
;145 //--- allocate a file descriptor to reference the Flash File data ---
;146   if ((fd = _allocFile_(3, &flashFileIOFuncs, ioDev)) < 0)  {
	.debug	# 146
	push	hl
	ld	hl,_flashFileIOFuncs
	push	hl
	ld	hl,0x3
	push	hl
	lcall	$_allocFile_
	add	sp,6
	ld	(ix-2),hl
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@29
;147     ffile_close(handle);  KUNLOCK();  return -1;  }
@30:
	.debug	< @30 @31
	.debug	# 147
	ld	hl,(ix-4)
	push	hl
	lcall	$ffile_close
	pop	hl
	call	_KUNLOCK
@115:
	ld	hl,0xffff
	jr	@12
@31:
	.debug	>
;148 
;149   KUNLOCK();
@29:
	.debug	# 149
	call	_KUNLOCK
;150 
;151   if (flags & O_APPEND)  _flashFileLseek_(ioDev, 0, FSEEK_END);
	.debug	# 151
	ld	hl,(ix+7)
	ld	de,0x10
	and	hl,de
	jr	z,@32
	ld	hl,0x2
	push	hl
	ld	e,d
	ld	c,e
	ld	b,e
	push	bc
	push	de
	ld	hl,(ix-6)
	push	hl
	lcall	$_flashFileLseek_
	add	sp,8
;152 
;153 //--- everything OK - return the descriptor assigned for this process ---
;154   return fd;
@32:
	.debug	# 154
	ld	hl,(ix-2)
;155 }
@12:
	.debug	} @12 155

@11	equ	6
	ld	sp,ix
	pop	ix
	lret
@13	equ	8
;156 
;157 
;158 //-------------------------------------------------------------------------
;159 //  func called each kernel tick to provide file system with CPU cycles
;160 //  Should ONLY be called by the kernel task!
;161 //-------------------------------------------------------------------------
;162 void _flashFileTick_(void)
;163 {
	.align	4
$$_flashFileTick_::
	ex	(sp),iy
$_flashFileTick_::
	.debug	G $_flashFileTick_ 41 9
	.debug	{ $_flashFileTick_ 41 162 @35 @34
;164 
;165 }
@34:
	.debug	} @34 165

@33	equ	0
	lret
@35	equ	0
;166 
;167 
;168 //-------------------------------------------------------------------------
;169 //  Return the state of the specified ioDev entry or NULL if not a valid
;170 //  entry #.
;171 //
;172 //  For valid entrys, the entryState struct is filled in
;173 //-------------------------------------------------------------------------
;174 void *_flashFileEntry_(uint idx, EntryState *entryState)
;175 {
	.align	4
$$_flashFileEntry_::
	ex	(sp),iy
$_flashFileEntry_::
	.debug	G $_flashFileEntry_ 42 9
	.debug	{ $_flashFileEntry_ 42 174 @38 @37
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	.debug	A idx 5 7
	.debug	A entryState 7 43
;176   FILE_DATA  *fileData;
	.debug	L fileData -2 39
;177 
;178   if (idx >= DOPEN_FILES)  return NULL;
	.debug	# 178
	ld	hl,(ix+5)
	ld	de,0x4
	or	a,a
	sbc	hl,de
	jr	c,@39
	bool	hl
	ld	l,h
	jr	@37
;179 
;180   fileData = openFiles + idx;
@39:
	.debug	# 180
	ld	hl,(ix+5)
	ld	bc,0x16
	ex	de,hl
	mul
	ld	hl,_openFiles
	add	hl,bc
	ld	(ix-2),hl
;181 
;182   entryState->openCount = ((fileData->flags & FFLAG_OPEN) ? 1 : 0);
	.debug	# 182
	ld	de,0x14
	add	hl,de
	ld	hl,(hl)
	ld	e,0x1
	and	hl,de
	jr	z,@40
	ld	h,d
	ld	l,e
	jr	@41
@40:
	bool	hl
	ld	l,h
@41:
	ex	de,hl
	ld	hl,(ix+7)
	ld	(hl),e
	inc	hl
	ld	(hl),d
;183   entryState->unused = (entryState->openCount == 0);
	.debug	# 183
	ld	hl,(ix+7)
	ld	hl,(hl)
	bool	hl
	ld	l,h
	jr	nz,@42
	inc	l
@42:
	ex	de,hl
	ld	hl,(ix+7)
	ex	de,hl
	inc	de
	inc	de
	ex	de,hl
	ld	(hl),e
;184 
;185   return fileData;
	.debug	# 185
	ld	hl,(ix-2)
;186 }
@37:
	.debug	} @37 186

@36	equ	2
	ld	sp,ix
	pop	ix
	lret
@38	equ	4
;187 
;188 
;189 //-------------------------------------------------------------------------
;190 //  Delete a file
;191 //
;192 //  To be called ONLY by fcntl functions
;193 //-------------------------------------------------------------------------
;194 int _flashFileUnlink_(char *path)
;195 {
	.align	4
$$_flashFileUnlink_::
	ex	(sp),iy
$_flashFileUnlink_::
	.debug	G $_flashFileUnlink_ 45 9
	.debug	{ $_flashFileUnlink_ 45 194 @45 @44
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	.debug	A path 5 38
;196   int  stat;
	.debug	L stat -2 6
;197 
;198   KLOCK();  stat = ffile_delete(path);  KUNLOCK();
	.debug	# 198
	call	_KLOCK
	ld	hl,(ix+5)
	push	hl
	lcall	$ffile_delete
	pop	de
	ld	(ix-2),hl
	call	_KUNLOCK
;199 
;200   return stat;
	.debug	# 200
	ld	hl,(ix-2)
;201 }
@44:
	.debug	} @44 201

@43	equ	2
	ld	sp,ix
	pop	ix
	lret
@45	equ	4
;202 
;203 
;204 //-------------------------------------------------------------------------
;205 //  Change the name of a file
;206 //
;207 //  To be called ONLY by fcntl functions
;208 //-------------------------------------------------------------------------
;209 int _flashFileRename_(const char *oldPath, const char *newPath)
;210 {
	.align	4
$$_flashFileRename_::
	ex	(sp),iy
$_flashFileRename_::
	.debug	G $_flashFileRename_ 46 9
	.debug	{ $_flashFileRename_ 46 209 @48 @47
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	.debug	A oldPath 5 38
	.debug	A newPath 7 38
;211   int  stat;
	.debug	L stat -2 6
;212 
;213   KLOCK();  stat = ffile_rename_(oldPath, newPath);  KUNLOCK();
	.debug	# 213
	call	_KLOCK
	ld	hl,(ix+7)
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$ffile_rename_
	add	sp,4
	ld	(ix-2),hl
	call	_KUNLOCK
;214 
;215   return stat;
	.debug	# 215
	ld	hl,(ix-2)
;216 }
@47:
	.debug	} @47 216

@46	equ	2
	ld	sp,ix
	pop	ix
	lret
@48	equ	4
;217 
;218 
;219 
;220 
;221 //=========================================================================
;222 //  IODev interface functions (for use by fcntl module)
;223 //=========================================================================
;224 
;225 //-------------------------------------------------------------------------
;226 //  Return wait queues to by used by fcntl layer when blocking on I/O calls
;227 //
;228 //  Should only be called from the fcntl.c layer!
;229 //-------------------------------------------------------------------------
;230 int _flashFileGetQueues_(void *ioDev, WaitQueues far *queues)
;231 {
	.align	4
$$_flashFileGetQueues_::
	ex	(sp),iy
$_flashFileGetQueues_::
	.debug	G $_flashFileGetQueues_ 47 9
	.debug	{ $_flashFileGetQueues_ 47 230 @51 @50
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A ioDev 5 36
	.debug	A queues 7 48
;232   queues->readQueue = queues->writeQueue = &sleepQueue;
	.debug	# 232
	ld	hl,(ix+7)
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,_sleepQueue
	call	__farst2##
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	ld	hl,(ix+7)
	ex	de,hl
	call	__farst2##
;233   return 0;
	.debug	# 233
	bool	hl
	ld	l,h
;234 }
@50:
	.debug	} @50 234

@49	equ	0
	pop	ix
	lret
@51	equ	2
;235 
;236 //-------------------------------------------------------------------------
;237 //  Attempt to read bytes from a file in flash
;238 //
;239 //  Should only be called from the fcntl.c/read() function!
;240 //
;241 //  RETURN VALUEs:
;242 //  - if bytes read: # of bytes read
;243 //  - if no bytes read:
;244 //    - if more possible in the future: -1 and ERRNO == EAGAIN
;245 //    - if no more possible (EOF):  0
;246 //-------------------------------------------------------------------------
;247 int _flashFileRead_(void *ioDev, char *buf, int numBytes, bool dontBlock)
;248 {
	.align	4
$$_flashFileRead_::
	ex	(sp),iy
$_flashFileRead_::
	.debug	G $_flashFileRead_ 50 9
	.debug	{ $_flashFileRead_ 50 247 @54 @53
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-4
	.debug	A ioDev 5 36
	.debug	A buf 7 38
	.debug	A numBytes 9 6
	.debug	A dontBlock 11 3
;249   int  stat, handle;
	.debug	L stat -2 6
	.debug	L handle -4 6
;250 
;251 
;252   KLOCK();
	.debug	# 252
	call	_KLOCK
;253 
;254   if (! validFFILE(ioDev))  { KUNLOCK();  ERRNO = EBADF;  return -1; }
	.debug	# 254
	ld	hl,(ix+5)
	push	hl
	lcall	$validFFILE
	pop	hl
	or	a,a
	jr	nz,@55
@56:
	.debug	< @56 @57
	call	_KUNLOCK
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x9
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,0xffff
	jr	@53
@57:
	.debug	>
;255 
;256   handle = FFHandle(FFILE);
@55:
	.debug	# 256
	ld	hl,(ix+5)
	ld	de,_openFiles
	or	a,a
	sbc	hl,de
	ld	de,0x16
	call	__idiv##
	ld	(ix-4),hl
;257 
;258   stat = ffile_read(handle, (char far *)buf, numBytes);
	.debug	# 258
	ld	hl,(ix+9)
	push	hl
	ld	hl,(ix+7)
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	ld	hl,(ix-4)
	push	hl
	lcall	$ffile_read
	add	sp,8
	ld	(ix-2),hl
;259 
;260   KUNLOCK();  return stat;
	.debug	# 260
	call	_KUNLOCK
	ld	hl,(ix-2)
;261 }
@53:
	.debug	} @53 261

@52	equ	4
	ld	sp,ix
	pop	ix
	lret
@54	equ	6
;262 
;263 //-------------------------------------------------------------------------
;264 //  Attempt to write bytes to file in flash
;265 //
;266 //  Should only be called from the fcntl.c/write() function!
;267 //
;268 //  RETURN VALUEs:
;269 //  - if bytes written: # of bytes written
;270 //  - if no bytes written:
;271 //    - if more possible in the future: -1 and ERRNO == EAGAIN
;272 //    - if no more possible (EOF):  0
;273 //-------------------------------------------------------------------------
;274 int _flashFileWrite_(void *ioDev, char *buf, int numBytes, bool dontBlock)
;275 {
	.align	4
$$_flashFileWrite_::
	ex	(sp),iy
$_flashFileWrite_::
	.debug	G $_flashFileWrite_ 50 9
	.debug	{ $_flashFileWrite_ 50 274 @60 @59
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-4
	.debug	A ioDev 5 36
	.debug	A buf 7 38
	.debug	A numBytes 9 6
	.debug	A dontBlock 11 3
;276   int  stat, handle;
	.debug	L stat -2 6
	.debug	L handle -4 6
;277 
;278 
;279   KLOCK();
	.debug	# 279
	call	_KLOCK
;280 
;281   if (! validFFILE(ioDev))  { KUNLOCK();  ERRNO = EBADF;  return -1; }
	.debug	# 281
	ld	hl,(ix+5)
	push	hl
	lcall	$validFFILE
	pop	hl
	or	a,a
	jr	nz,@61
@62:
	.debug	< @62 @63
	call	_KUNLOCK
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x9
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,0xffff
	jr	@59
@63:
	.debug	>
;282 
;283   handle = FFHandle(FFILE);
@61:
	.debug	# 283
	ld	hl,(ix+5)
	ld	de,_openFiles
	or	a,a
	sbc	hl,de
	ld	de,0x16
	call	__idiv##
	ld	(ix-4),hl
;284 
;285   stat = ffile_write(handle, (char far *)buf, numBytes);
	.debug	# 285
	ld	hl,(ix+9)
	push	hl
	ld	hl,(ix+7)
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	ld	hl,(ix-4)
	push	hl
	lcall	$ffile_write
	add	sp,8
	ld	(ix-2),hl
;286 
;287   KUNLOCK();  return stat;
	.debug	# 287
	call	_KUNLOCK
	ld	hl,(ix-2)
;288 }
@59:
	.debug	} @59 288

@58	equ	4
	ld	sp,ix
	pop	ix
	lret
@60	equ	6
;289 
;290 
;291 //-------------------------------------------------------------------------
;292 //  close a flashFile object
;293 //
;294 //  Should only be called from the fcntl.c layer!
;295 //-------------------------------------------------------------------------
;296 int _flashFileClose_(void *ioDev)
;297 {
	.align	4
$$_flashFileClose_::
	ex	(sp),iy
$_flashFileClose_::
	.debug	G $_flashFileClose_ 51 9
	.debug	{ $_flashFileClose_ 51 296 @66 @65
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A ioDev 5 36
;298   KLOCK();
	.debug	# 298
	call	_KLOCK
;299 
;300   if (! validFFILE(ioDev))  { KUNLOCK();  ERRNO = EBADF;  return -1; }
	.debug	# 300
	ld	hl,(ix+5)
	push	hl
	lcall	$validFFILE
	pop	hl
	or	a,a
	jr	nz,@67
@68:
	.debug	< @68 @69
	call	_KUNLOCK
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x9
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,0xffff
	jr	@65
@69:
	.debug	>
;301 
;302   ffile_close( FFHandle(FFILE) );
@67:
	.debug	# 302
	ld	hl,(ix+5)
	ld	de,_openFiles
	or	a,a
	sbc	hl,de
	ld	de,0x16
	call	__idiv##
	push	hl
	lcall	$ffile_close
	pop	hl
;303 
;304   KUNLOCK();
	.debug	# 304
	call	_KUNLOCK
;305 
;306   return 0;
	.debug	# 306
	bool	hl
	ld	l,h
;307 }
@65:
	.debug	} @65 307

@64	equ	0
	pop	ix
	lret
@66	equ	2
;308 
;309 //-------------------------------------------------------------------------
;310 //  Kernel-space function to reposition a file offset
;311 //
;312 //  Should only be called from the fcntl.c layer!
;313 //-------------------------------------------------------------------------
;314 off_t  _flashFileLseek_(void *ioDev, off_t offset, int whence)
;315 {
	.align	4
$$_flashFileLseek_::
	ex	(sp),iy
$_flashFileLseek_::
	.debug	G $_flashFileLseek_ 52 9
	.debug	{ $_flashFileLseek_ 52 314 @72 @71
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-8
	.debug	A ioDev 5 36
	.debug	A offset 7 9
	.debug	A whence 11 6
;316   int  stat, handle;
	.debug	L stat -2 6
	.debug	L handle -4 6
;317   off_t  newOffset;
	.debug	L newOffset -8 9
;318 
;319 
;320   KLOCK();
	.debug	# 320
	call	_KLOCK
;321 
;322   if (! validFFILE(ioDev))  { KUNLOCK();  ERRNO = EBADF;  return -1; }
	.debug	# 322
	ld	hl,(ix+5)
	push	hl
	lcall	$validFFILE
	pop	hl
	or	a,a
	jr	nz,@73
@74:
	.debug	< @74 @75
	call	_KUNLOCK
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x9
	jr	@114
@75:
	.debug	>
;323 
;324   handle = FFHandle(FFILE);
@73:
	.debug	# 324
	ld	hl,(ix+5)
	ld	de,_openFiles
	or	a,a
	sbc	hl,de
	ld	de,0x16
	call	__idiv##
	ld	(ix-4),hl
;325 
;326   stat = ffile_seek(handle, (long)offset, whence);
	.debug	# 326
	ld	hl,(ix+11)
	push	hl
	ld	hl,(ix+7)
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-4)
	push	hl
	lcall	$ffile_seek
	add	sp,8
	ld	(ix-2),hl
;327 
;328   if (stat != 0)  { KUNLOCK();  ERRNO = EINVAL;  return (off_t)-1; }
	.debug	# 328
	bool	hl
	jr	z,@76
@77:
	.debug	< @77 @78
	call	_KUNLOCK
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x16
@114:
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	de,0xffff
	ld	c,e
	ld	b,e
	jr	@71
@78:
	.debug	>
;329 
;330   newOffset = (off_t) ffile_tell(handle);
@76:
	.debug	# 330
	ld	hl,(ix-4)
	push	hl
	lcall	$ffile_tell
	pop	hl
	ld	hl,bc
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
;331 
;332   KUNLOCK();
	.debug	# 332
	call	_KUNLOCK
;333 
;334   return newOffset;
	.debug	# 334
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
;335 }
@71:
	.debug	} @71 335

@70	equ	8
	ld	sp,ix
	pop	ix
	lret
@72	equ	10
;336 
;337 //-------------------------------------------------------------------------
;338 //  Kernel-space function to get the status of a flash file
;339 //
;340 //  Should only be called from the fcntl.c layer!
;341 //-------------------------------------------------------------------------
;342 int  _flashFileFstat_(void *ioDev, struct stat *fsbuf)
;343 {
	.align	4
$$_flashFileFstat_::
	ex	(sp),iy
$_flashFileFstat_::
	.debug	G $_flashFileFstat_ 53 9
	.debug	{ $_flashFileFstat_ 53 342 @81 @80
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	.debug	A ioDev 5 36
	.debug	A fsbuf 7 54
;344   int  stat;
	.debug	L stat -2 6
;345 
;346 
;347   KLOCK();
	.debug	# 347
	call	_KLOCK
;348 
;349   if (! validFFILE(ioDev))  { KUNLOCK();  ERRNO = EBADF;  return -1; }
	.debug	# 349
	ld	hl,(ix+5)
	push	hl
	lcall	$validFFILE
	pop	hl
	or	a,a
	jr	nz,@82
@83:
	.debug	< @83 @84
	call	_KUNLOCK
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x9
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,0xffff
	jr	@80
@84:
	.debug	>
;350 
;351   stat = ffile_fstat(FFHandle(FFILE), fsbuf);
@82:
	.debug	# 351
	ld	hl,(ix+7)
	push	hl
	ld	hl,(ix+5)
	ld	de,_openFiles
	or	a,a
	sbc	hl,de
	ld	de,0x16
	call	__idiv##
	push	hl
	lcall	$ffile_fstat
	add	sp,4
	ld	(ix-2),hl
;352 
;353   KUNLOCK();
	.debug	# 353
	call	_KUNLOCK
;354 
;355   return stat;
	.debug	# 355
	ld	hl,(ix-2)
;356 }
@80:
	.debug	} @80 356

@79	equ	2
	ld	sp,ix
	pop	ix
	lret
@81	equ	4
;357 
;358 
;359 //-------------------------------------------------------------------------
;360 //  Kernel-space function to handle ioctl calls for flashFile ports
;361 //
;362 //  Should only be called from the fcntl.c layer!
;363 //-------------------------------------------------------------------------
;364 int _flashFileioctl_(void *ioDev, int request, void *arg)
;365 {
	.align	4
$$_flashFileioctl_::
	ex	(sp),iy
$_flashFileioctl_::
	.debug	G $_flashFileioctl_ 56 9
	.debug	{ $_flashFileioctl_ 56 364 @87 @86
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-10
	.debug	A ioDev 5 36
	.debug	A request 7 6
	.debug	A arg 9 36
;366   int  stat;
	.debug	L stat -2 6
;367   long  unread, freeSpace;
	.debug	L unread -6 8
	.debug	L freeSpace -10 8
;368 
;369 
;370   KLOCK();
	.debug	# 370
	call	_KLOCK
;371 
;372   if (! validFFILE(ioDev))  { KUNLOCK();  errno = EBADF;  return -1; }
	.debug	# 372
	ld	hl,(ix+5)
	push	hl
	lcall	$validFFILE
	pop	hl
	or	a,a
	jr	nz,@88
@89:
	.debug	< @89 @90
	call	_KUNLOCK
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x9
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,0xffff
	jp	@86
@90:
	.debug	>
;373 
;374   stat = -1;
@88:
	.debug	# 374
	ld	hl,0xffff
	ld	(ix-2),hl
;375 
;376   switch (request)  {
	.debug	# 376
	ld	hl,(ix+7)
	jp	@91
;377 
;378     case FIONREAD:
@93:
	.debug	< @93 @94
;379       unread = ffile_unread(FFHandle(FFILE));
	.debug	# 379
@95:
	ld	hl,(ix+5)
	ld	de,_openFiles
	or	a,a
	sbc	hl,de
	ld	de,0x16
	call	__idiv##
	push	hl
	lcall	$ffile_unread
	pop	hl
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
;380       if (unread > 0x7fff)  unread = 0x7fff;
	.debug	# 380
	push	bc
	push	de
	ld	de,0x7fff
	ld	bc,0
	call	__lcmp##
	jr	c,@96
	jr	z,@96
	ld	de,0x7fff
	ld	hl,0
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
;381       if (unread < 0)  break;
@96:
	.debug	# 381
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0
	ld	c,e
	ld	b,e
	call	__lcmp##
	jr	c,@92
;382       *((int *)arg) = (int) unread;  stat = 0;  break;
	.debug	# 382
	ld	hl,(ix-6)
	jr	@113
;383 
;384     case FIONSPACE:
;385       freeSpace = ffile_free();
	.debug	# 385
@98:
	lcall	$ffile_free
	ld	hl,bc
	ld	(ix-8),hl
	ex	de,hl
	ld	(ix-10),hl
	ex	de,hl
;386       if (freeSpace > 0x7fff)  freeSpace = 0x7fff;
	.debug	# 386
	push	bc
	push	de
	ld	de,0x7fff
	ld	bc,0
	call	__lcmp##
	jr	c,@99
	jr	z,@99
	ld	de,0x7fff
	ld	hl,0
	ld	(ix-8),hl
	ex	de,hl
	ld	(ix-10),hl
	ex	de,hl
;387       if (freeSpace < 0)  break;
@99:
	.debug	# 387
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0
	ld	c,e
	ld	b,e
	call	__lcmp##
	jr	c,@92
;388       *((int *)arg) = (int) freeSpace;  stat = 0;  break;
	.debug	# 388
	ld	hl,(ix-10)
@113:
	ex	de,hl
	ld	hl,(ix+9)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	bool	hl
	ld	l,h
	ld	(ix-2),hl
;389 
;390     default:
	jr	@92
;391       errno = EINVAL;
	.debug	# 391
@101:
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x16
	ld	(hl),e
	inc	hl
	ld	(hl),d
;392   }
@94:
	.debug	>
;393 
;394   KUNLOCK();  return stat;
	jr	@92
@91:
	ex	de,hl
	ld	hl,0xffffabe5
	add	hl,de
	bool	hl
	jp	z,@95
	ld	hl,0xffffa000
	add	hl,de
	bool	hl
	jr	z,@98
	jr	@101
@92:
	.debug	# 394
	call	_KUNLOCK
	ld	hl,(ix-2)
;395 }
@86:
	.debug	} @86 395

@85	equ	10
	ld	sp,ix
	pop	ix
	lret
@87	equ	12
;396 
;397 
;398 //-------------------------------------------------------------------------
;399 //  Kernel-space function to return a description of the specified file
;400 //
;401 //  Should only be called from the fcntl.c layer!
;402 //-------------------------------------------------------------------------
;403 char *_flashFileDescr_(void *ioDev, char *buf, int bufSize)
;404 {
	.align	4
$$_flashFileDescr_::
	ex	(sp),iy
$_flashFileDescr_::
	.debug	G $_flashFileDescr_ 57 9
	.debug	{ $_flashFileDescr_ 57 403 @104 @103
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-6
	.debug	A ioDev 5 36
	.debug	A buf 7 38
	.debug	A bufSize 9 6
;405   FILE_ENTRY far *fe;
	.debug	L fe -4 58
;406   char  *ptr;
	.debug	L ptr -6 38
;407 
;408   sprintf(buf, "flash 0x%04lX ", (ulong)ioDev);
	.debug	# 408
	ld	hl,(ix+5)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,word (phys @105)
	ld	c,phys @105 >> 16
	push	bc
	push	de
	ld	hl,(ix+7)
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	lcall	$farsprintf
	add	sp,12
;409 
;410   ptr = buf + strlen(buf);  strcpy(ptr, "<bad> <bad>");
	.debug	# 410
	ld	hl,(ix+7)
	push	hl
	call	_strlen
	pop	de
	ex	de,hl
	ld	hl,(ix+7)
	ex	de,hl
	add	hl,de
	ld	(ix-6),hl
	ld	hl,@1+10
	push	hl
	ld	hl,(ix-6)
	push	hl
	call	_strcpy
	add	sp,4
;411 
;412 //finish: need to limit output to bufSize...
;413 
;414   if (validFFILE(FFILE))  {
	.debug	# 414
	ld	hl,(ix+5)
	push	hl
	lcall	$validFFILE
	pop	hl
	or	a,a
	jp	z,@106
;415     sprintf(ptr, "flash[%d] ", FFHandle(FFILE));  while (*ptr) ++ptr;
@107:
	.debug	< @107 @108
	.debug	# 415
	ld	hl,(ix+5)
	ld	de,_openFiles
	or	a,a
	sbc	hl,de
	ld	de,0x16
	call	__idiv##
	push	hl
	ld	de,word (phys @105+15)
	ld	c,phys @105+15 >> 16
	push	bc
	push	de
	ld	hl,(ix-6)
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	lcall	$farsprintf
	add	sp,10
@109:
	ld	hl,(ix-6)
	ld	a,(hl)
	or	a,a
	jr	z,@110
	inc	hl
	ld	(ix-6),hl
;416     KLOCK();
	jr	@109
@110:
	.debug	# 416
	call	_KLOCK
;417     fe = ffile_info(openFiles[FFHandle(FFILE)].fatIdx);
	.debug	# 417
	ld	hl,(ix+5)
	ld	de,_openFiles
	or	a,a
	sbc	hl,de
	ld	de,0x16
	call	__idiv##
	ld	bc,0x16
	ex	de,hl
	mul
	ld	hl,_openFiles
	add	hl,bc
	ld	hl,(hl)
	push	hl
	lcall	$ffile_info
	pop	hl
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
;418     KUNLOCK();
	.debug	# 418
	call	_KUNLOCK
;419     if (fe != NULL)
	.debug	# 419
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	ld	a,e
	or	a,d
	or	a,c
	jr	z,@111
;420       sprintf(ptr, "%.32ls", fe->name);
	.debug	# 420
	ld	h,b
	ld	l,c
	ld	bc,hl
	push	bc
	push	de
	ld	de,word (phys @105+26)
	ld	c,phys @105+26 >> 16
	push	bc
	push	de
	ld	hl,(ix-6)
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	lcall	$farsprintf
	add	sp,12
;421     else
;422       strcpy(ptr, "<bad>");
	jr	@112
@111:
	.debug	# 422
	ld	hl,@1+16
	push	hl
	ld	hl,(ix-6)
	push	hl
	call	_strcpy
	add	sp,4
;423   }
@112:
@108:
	.debug	>
;424 
;425   return buf;
@106:
	.debug	# 425
	ld	hl,(ix+7)
;426 }
@103:
	.debug	} @103 426

@102	equ	6
	ld	sp,ix
	pop	ix
	lret
@104	equ	8
;427 
;428 
;429 //-------------------------------------------------------------------------
;430 
	.extern	_strcpy 60
	.extern	_strlen 45
	.extern	_current 61
	.extern	$farsprintf 63
	.extern	$registerFileSys 64
	.extern	$_allocFile_ 65
	.extern	_KLOCK 41
	.extern	_KUNLOCK 41
	.extern	_sleepQueue 66
	.cseg
__flashFileOpen_:
	pop	iy
	lcall	$$_flashFileOpen_
	.extern	_openFiles 67
	.extern	$ffile_open 45
	.extern	$ffile_read 68
	.extern	$ffile_write 68
	.extern	$ffile_create 45
	.extern	$ffile_delete 45
	.extern	$ffile_tell 69
	.extern	$ffile_seek 70
	.extern	$ffile_close 71
	.extern	$ffile_free 72
	.extern	$ffile_info 73
	.extern	$ffile_fstat 74
	.extern	$ffile_unread 69
	.extern	$ffile_rename_ 46
__flashFileRead_:
	pop	iy
	lcall	$$_flashFileRead_
__flashFileWrite_:
	pop	iy
	lcall	$$_flashFileWrite_
__flashFileClose_:
	pop	iy
	lcall	$$_flashFileClose_
__flashFileLseek_:
	pop	iy
	lcall	$$_flashFileLseek_
__flashFileFstat_:
	pop	iy
	lcall	$$_flashFileFstat_
__flashFileioctl_:
	pop	iy
	lcall	$$_flashFileioctl_
__flashFileDescr_:
	pop	iy
	lcall	$$_flashFileDescr_
__flashFileGetQueues_:
	pop	iy
	lcall	$$_flashFileGetQueues_
__flashFileTick_:
	pop	iy
	lcall	$$_flashFileTick_
__flashFileEntry_:
	pop	iy
	lcall	$$_flashFileEntry_
__flashFileUnlink_:
	pop	iy
	lcall	$$_flashFileUnlink_
__flashFileRename_:
	pop	iy
	lcall	$$_flashFileRename_
	.debug	T	64000320001000080001004B0000000572656164004B0002000677
	.debug	T	72697465004C00040006636C6F7365004D000600066C736565
	.debug	T	6B004E000800066673746174004F000A0006696F63746C0050
	.debug	T	000C000664657363720051000E000A67657451756575657300
	.debug	T	57000321000E000700010026000000056E616D6500520002000869
	.debug	T	6F46756E63730053000400057469636B005400060006656E74
	.debug	T	72790055000800056F70656E0056000A0007756E6C696E6B00
	.debug	T	57000C000772656E616D6500
	.debug	T	070002220000000100
	.debug	T	0B000223000100030024000000
	.debug	T	070000240002000100
	.debug	T	130002250003000600260000000600020006000400
	.debug	T	070000260002000300
	.debug	T	070000270002002800
	.debug	T	660003280016000700010007000000076661744964780007000200
	.debug	T	0A637572426C6B4E756D000900040004706F7300090008000A
	.debug	T	736563746F72506F730058000C000C736563746F725F627566
	.debug	T	66005800100009627566665F707472000600140006666C6167
	.debug	T	7300
	.debug	T	0B000229000100010001000000
	.debug	T	0F00022A0002002400070000002B000200
	.debug	T	0700002B0002002C00
	.debug	T	2400032C00030002000100060000000A6F70656E436F756E740003
	.debug	T	00020007756E7573656400
	.debug	T	0B00022D000100060026000000
	.debug	T	0F00022E00020006002600000026000200
	.debug	T	0F00022F00020006002400000030000200
	.debug	T	070008300004003100
	.debug	T	2800033100040002000100590000000A7265616451756575650059
	.debug	T	0002000B7772697465517565756500
	.debug	T	17000232000400060024000000260002000600040003000600
	.debug	T	0B000233000100060024000000
	.debug	T	130002340003000900240000000900020006000600
	.debug	T	0F00023500020006002400000036000200
	.debug	T	070000360002003700
	.debug	T	BB000337002A000D00057374617400090000000773745F64657600
	.debug	T	090004000773745F696E6F00090008000873745F6D6F646500
	.debug	T	06000C000973745F6E6C696E6B0006000E000773745F756964
	.debug	T	00060010000773745F67696400090012000873745F72646576
	.debug	T	00090016000873745F73697A650006001A000B73745F626C6B
	.debug	T	73697A650006001C000A73745F626C6F636B730009001E0009
	.debug	T	73745F6174696D6500090022000973745F6D74696D65000900
	.debug	T	26000973745F6374696D6500
	.debug	T	130002380003000600240000000600020024000400
	.debug	T	130002390003002600240000002600020006000400
	.debug	T	0700083A0004003B00
	.debug	T	4200033B007000050001005A000000056E616D6500050064000B73
	.debug	T	74617274626C6F636B000500660006666C6167730009006800
	.debug	T	0573697A650009006C00056461746500
	.debug	T	0F00023C00020026002600000026000200
	.debug	T	0700003D0002003E00
	.debug	T	7702033E00E8002D000C7461736B5F737472756374005B00000006
	.debug	T	737461636B005B0002000C737461636B5F7374617274000700
	.debug	T	04000B737461636B5F73697A65000300060005737365670003
	.debug	T	0007000773746B6C6C7200030008000773746B686C72000300
	.debug	T	09000677707361720007000A0008777073616C68720003000C
	.debug	T	000677707362720007000D0008777073626C6872005C000F00
	.debug	T	064644536574000300110009757365436F756E740003001200
	.debug	T	08636C61696D65640007001300067374617465003D00150007
	.debug	T	6D794164647200030017000A7A65726F416674657200060018
	.debug	T	000561726763005E001A000561726776005F001C0005617267
	.debug	T	730042009C0007776169745173000900A0000C7369675F7065
	.debug	T	6E64696E67000900A4000C7369675F626C6F636B6564000600
	.debug	T	A8000E707265656D70745F636F756E74000300AA0006696E55
	.debug	T	7365000300AB000565786974000300AC000A6C6F675374646F
	.debug	T	7574000300AD000B7265646972537464696F000900AE000A64
	.debug	T	696167466C616773006000B2000970726F634D61696E000600
	.debug	T	B40004706964000600B6000570706964000300B80009707269
	.debug	T	6F72697479000600B900086C617374457272000900BB000873
	.debug	T	746172746564000900BF000C6C617374526573756D65640009
	.debug	T	00C3000C6C61737453746F70706564000900C7000C6C617374
	.debug	T	52756E6E696E67000900CB000D726573756D65645469636B73
	.debug	T	000900CF000A7469636B7355736564000900D300076D735573
	.debug	T	6564000300D700096F7574436F756E74005800D800076F7574
	.debug	T	507472000900DC000B736C6565705469636B73000900E0000D
	.debug	T	736C65657053746172746564000900E4000D74696D656F7574
	.debug	T	5469636B7300
	.debug	T	1300023F000300060058000000580004000D000000
	.debug	T	0B000240000100060062000000
	.debug	T	130002410003000600060000005200020024000400
	.debug	T	280003420004000100125F5F776169745F71756575655F68656164
	.debug	T	0063000000096C6973744865616400
	.debug	T	0900014300580028000400
	.debug	T	130002440003000600060000005800020006000600
	.debug	T	0B000245000100080006000000
	.debug	T	130002460003000600060000000800020006000600
	.debug	T	0B000247000100010006000000
	.debug	T	0B000248000100080001000000
	.debug	T	0B0002490001003A0007000000
	.debug	T	0F00024A00020006000600000036000200
	.debug	T	0700004B0002003200
	.debug	T	0700004C0002003300
	.debug	T	0700004D0002003400
	.debug	T	0700004E0002003500
	.debug	T	0700004F0002003800
	.debug	T	070000500002003900
	.debug	T	070000510002002F00
	.debug	T	070000520002002000
	.debug	T	070000530002002900
	.debug	T	070000540002002A00
	.debug	T	070000550002002500
	.debug	T	070000560002002D00
	.debug	T	070000570002002E00
	.debug	T	070008580004000300
	.debug	T	070000590002004200
	.debug	T	0900015A00640003006400
	.debug	T	0700005B0002000700
	.debug	T	0700005C0002005D00
	.debug	T	0700085D0004000100
	.debug	T	0700005E0002002600
	.debug	T	0900015F00800003008000
	.debug	T	070000600002006100
	.debug	T	0F0002610002000100060000005E000200
	.debug	T	070000620002002100
	.debug	T	2600036300040002000A6C6973745F686561640064000000056E65
	.debug	T	78740064000200057072657600
	.debug	T	070000640002006300
	.seg	CONST
@1:
	.db	"flashFile",0,"<bad> <bad>",0
	.defseg	FARCONST
	.seg	FARCONST
@105:
	.db	"flash 0x%04lX ",0,"flash[%d] ",0,"%.32ls",0
	.end
