//----- help.c ----- 03/31/09 -----(03/14/06)-----

//-----------------------------------------------------------------------------
//
//  2009-xx-xx - Mark Davis
//               - original version of ...
//
//-----------------------------------------------------------------------------

#include <time.h>
#include <common.h>

#include <sys/types.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/socket.h>
#include <fcntl.h>
#include <arpa/inet.h>
#include <errno.h>
#include <signal.h>
#include <utime.h>


#include <busybox.h>

#include <sys/hdwDefs.h>

#include <dcdefs.h>

#include <ctype.h>
#include <limits.h>

#include <sys/SHD_headers.h>

#include <tsh.h>

#include <applic.h>

#include <sys/farprintf.h>


//-----------------------------------------------------------------------------
void showCmd(const CmdInfo far *cmdInfo)
{
  char  buf[32];

  fstrcpy(buf, cmdInfo->cmdName);
  printf("  %-16.16s %ls\r\n", buf, cmdInfo->descr);
}


//=============================================================================


//-----------------------------------------------------------------------------
void _task _help(int argc, char **argv)
{
  uint  u;


  printf("\r\nSystem commands:\r\n");
  for (u=0; u<NumCommonCmds; ++u)  showCmd(commonCmds + u);
  printf("\r\n");

  printf("Application commands:\r\n");
  for (u=0; u<NumApplCmds; ++u)  showCmd(applCmds + u);

  Exit(0);
}

//-----------------------------------------------------------------------------
