//----- sh.c ----- 03/31/09 -----(03/14/06)-----

//-----------------------------------------------------------------------------
//
//  2009-xx-xx - Mark Davis
//               - original version of ...
//
//-----------------------------------------------------------------------------

#include <time.h>
#include <common.h>

#include <sys/types.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/socket.h>
#include <fcntl.h>
#include <arpa/inet.h>
#include <errno.h>
#include <signal.h>
#include <utime.h>


#include <busybox.h>

#include <sys/hdwDefs.h>

#include <dcdefs.h>

#include <ctype.h>
#include <limits.h>

#include <sys/SHD_headers.h>

#include <sys/modbus.h>

#include <tsh.h>

#include <applic.h>

#include <sys/farprintf.h>

//-----------------------------------------------------------------------------
//  execute commands from a text file
//-----------------------------------------------------------------------------
void _task _sh(int argc, char **argv)
{
  int  i, ch;
  fd_t  fd;
  bool  eof;
  BufInfo  bufInfo;
  char  buf[256], cmd[128];


  if (showHelp(2, argc, argv))  {
    printf("\nusage:  sh fileName\r\n");  Exit(-1); }

  if ((fd = open(argv[1], O_RDONLY, 0)) < 0)  { perror(argv[1]);  Exit(-1); }

  bufInfo.buf = buf;  bufInfo.fd = fd;  bufInfo.bufSize = sizeof(buf);
  bufInfo.nextOut = bufInfo.count = 0;

  for (eof=false; !eof; )  {
    for (i=0; i<sizeof(cmd)-1; ++i)  {
      ch = readBufCh(&bufInfo);
      if (ch < 0)  { eof = true;  break; }
      if (ch == '\n')  break;
      cmd[i] = ch;
    }
    if (!i)  break;
    cmd[i] = 0;  cmdLine(cmd);
  }

  close(fd);  Exit(0);
}


//-----------------------------------------------------------------------------
