//----- stat.c ----- 03/31/09 -----(03/14/06)-----

//-----------------------------------------------------------------------------
//
//  2009-xx-xx - Mark Davis
//               - original version of ...
//
//-----------------------------------------------------------------------------

#include <time.h>
#include <common.h>

#include <sys/types.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <errno.h>


#include <busybox.h>

#include <dcdefs.h>

#include <ctype.h>
#include <limits.h>

#include <sys/SHD_headers.h>


#include <sys/farprintf.h>


//-----------------------------------------------------------------------------
//  show the status of a file
//-----------------------------------------------------------------------------
void _task _stat(int argc, char **argv)
{
  struct stat  fsInfo;
  char  timeStr[32];


  if (showHelp(2, argc, argv))  {
    printf("\nusage: stat fname\r\n");  Exit(-1); }

  if (stat(argv[1], &fsInfo))  { perror(argv[1]);  Exit(-1); }

  printf("  File: `%s`\r\n", argv[1]);
  printf("  Size: %lu\r\n", (ulong)fsInfo.st_size);
  printf("Access: (%lu)  %s\r",
         fsInfo.st_atime, ctime_r(&fsInfo.st_atime, timeStr));
  printf("Modify: (%lu)  %s\r",
         fsInfo.st_mtime, ctime_r(&fsInfo.st_mtime, timeStr));
  printf("Change: (%lu)  %s\r",
         fsInfo.st_ctime, ctime_r(&fsInfo.st_ctime, timeStr));

  Exit(0);
}


//-----------------------------------------------------------------------------
